// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewAddAccessGroupParams creates a new AddAccessGroupParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddAccessGroupParams() *AddAccessGroupParams {
	return &AddAccessGroupParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddAccessGroupParamsWithTimeout creates a new AddAccessGroupParams object
// with the ability to set a timeout on a request.
func NewAddAccessGroupParamsWithTimeout(timeout time.Duration) *AddAccessGroupParams {
	return &AddAccessGroupParams{
		timeout: timeout,
	}
}

// NewAddAccessGroupParamsWithContext creates a new AddAccessGroupParams object
// with the ability to set a context for a request.
func NewAddAccessGroupParamsWithContext(ctx context.Context) *AddAccessGroupParams {
	return &AddAccessGroupParams{
		Context: ctx,
	}
}

// NewAddAccessGroupParamsWithHTTPClient creates a new AddAccessGroupParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddAccessGroupParamsWithHTTPClient(client *http.Client) *AddAccessGroupParams {
	return &AddAccessGroupParams{
		HTTPClient: client,
	}
}

/*
AddAccessGroupParams contains all the parameters to send to the API endpoint

	for the add access group operation.

	Typically these are written to a http.Request.
*/
type AddAccessGroupParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.AccessGroup

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add access group params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddAccessGroupParams) WithDefaults() *AddAccessGroupParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add access group params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddAccessGroupParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddAccessGroupParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add access group params
func (o *AddAccessGroupParams) WithTimeout(timeout time.Duration) *AddAccessGroupParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add access group params
func (o *AddAccessGroupParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add access group params
func (o *AddAccessGroupParams) WithContext(ctx context.Context) *AddAccessGroupParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add access group params
func (o *AddAccessGroupParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add access group params
func (o *AddAccessGroupParams) WithHTTPClient(client *http.Client) *AddAccessGroupParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add access group params
func (o *AddAccessGroupParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add access group params
func (o *AddAccessGroupParams) WithUserAgent(userAgent *string) *AddAccessGroupParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add access group params
func (o *AddAccessGroupParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add access group params
func (o *AddAccessGroupParams) WithBody(body *models.AccessGroup) *AddAccessGroupParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add access group params
func (o *AddAccessGroupParams) SetBody(body *models.AccessGroup) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddAccessGroupParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
