// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddAccessGroupReader is a Reader for the AddAccessGroup structure.
type AddAccessGroupReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddAccessGroupReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddAccessGroupOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddAccessGroupTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddAccessGroupDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddAccessGroupOK creates a AddAccessGroupOK with default headers values
func NewAddAccessGroupOK() *AddAccessGroupOK {
	return &AddAccessGroupOK{}
}

/*
AddAccessGroupOK describes a response with status code 200, with default header values.

successful operation
*/
type AddAccessGroupOK struct {
	Payload *models.AccessGroup
}

// IsSuccess returns true when this add access group o k response has a 2xx status code
func (o *AddAccessGroupOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add access group o k response has a 3xx status code
func (o *AddAccessGroupOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add access group o k response has a 4xx status code
func (o *AddAccessGroupOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add access group o k response has a 5xx status code
func (o *AddAccessGroupOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add access group o k response a status code equal to that given
func (o *AddAccessGroupOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add access group o k response
func (o *AddAccessGroupOK) Code() int {
	return 200
}

func (o *AddAccessGroupOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/accessgroup/add][%d] addAccessGroupOK %s", 200, payload)
}

func (o *AddAccessGroupOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/accessgroup/add][%d] addAccessGroupOK %s", 200, payload)
}

func (o *AddAccessGroupOK) GetPayload() *models.AccessGroup {
	return o.Payload
}

func (o *AddAccessGroupOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AccessGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddAccessGroupTooManyRequests creates a AddAccessGroupTooManyRequests with default headers values
func NewAddAccessGroupTooManyRequests() *AddAccessGroupTooManyRequests {
	return &AddAccessGroupTooManyRequests{}
}

/*
AddAccessGroupTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddAccessGroupTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add access group too many requests response has a 2xx status code
func (o *AddAccessGroupTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add access group too many requests response has a 3xx status code
func (o *AddAccessGroupTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add access group too many requests response has a 4xx status code
func (o *AddAccessGroupTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add access group too many requests response has a 5xx status code
func (o *AddAccessGroupTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add access group too many requests response a status code equal to that given
func (o *AddAccessGroupTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add access group too many requests response
func (o *AddAccessGroupTooManyRequests) Code() int {
	return 429
}

func (o *AddAccessGroupTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/accessgroup/add][%d] addAccessGroupTooManyRequests", 429)
}

func (o *AddAccessGroupTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/accessgroup/add][%d] addAccessGroupTooManyRequests", 429)
}

func (o *AddAccessGroupTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddAccessGroupDefault creates a AddAccessGroupDefault with default headers values
func NewAddAccessGroupDefault(code int) *AddAccessGroupDefault {
	return &AddAccessGroupDefault{
		_statusCode: code,
	}
}

/*
AddAccessGroupDefault describes a response with status code -1, with default header values.

Error
*/
type AddAccessGroupDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add access group default response has a 2xx status code
func (o *AddAccessGroupDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add access group default response has a 3xx status code
func (o *AddAccessGroupDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add access group default response has a 4xx status code
func (o *AddAccessGroupDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add access group default response has a 5xx status code
func (o *AddAccessGroupDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add access group default response a status code equal to that given
func (o *AddAccessGroupDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add access group default response
func (o *AddAccessGroupDefault) Code() int {
	return o._statusCode
}

func (o *AddAccessGroupDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/accessgroup/add][%d] addAccessGroup default %s", o._statusCode, payload)
}

func (o *AddAccessGroupDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/accessgroup/add][%d] addAccessGroup default %s", o._statusCode, payload)
}

func (o *AddAccessGroupDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddAccessGroupDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
