// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddConfigSourceReader is a Reader for the AddConfigSource structure.
type AddConfigSourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddConfigSourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddConfigSourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddConfigSourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddConfigSourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddConfigSourceOK creates a AddConfigSourceOK with default headers values
func NewAddConfigSourceOK() *AddConfigSourceOK {
	return &AddConfigSourceOK{}
}

/*
AddConfigSourceOK describes a response with status code 200, with default header values.

successful operation
*/
type AddConfigSourceOK struct {
	Payload *models.ConfigSource
}

// IsSuccess returns true when this add config source o k response has a 2xx status code
func (o *AddConfigSourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add config source o k response has a 3xx status code
func (o *AddConfigSourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add config source o k response has a 4xx status code
func (o *AddConfigSourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add config source o k response has a 5xx status code
func (o *AddConfigSourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add config source o k response a status code equal to that given
func (o *AddConfigSourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add config source o k response
func (o *AddConfigSourceOK) Code() int {
	return 200
}

func (o *AddConfigSourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/configsources][%d] addConfigSourceOK %s", 200, payload)
}

func (o *AddConfigSourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/configsources][%d] addConfigSourceOK %s", 200, payload)
}

func (o *AddConfigSourceOK) GetPayload() *models.ConfigSource {
	return o.Payload
}

func (o *AddConfigSourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ConfigSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddConfigSourceTooManyRequests creates a AddConfigSourceTooManyRequests with default headers values
func NewAddConfigSourceTooManyRequests() *AddConfigSourceTooManyRequests {
	return &AddConfigSourceTooManyRequests{}
}

/*
AddConfigSourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddConfigSourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add config source too many requests response has a 2xx status code
func (o *AddConfigSourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add config source too many requests response has a 3xx status code
func (o *AddConfigSourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add config source too many requests response has a 4xx status code
func (o *AddConfigSourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add config source too many requests response has a 5xx status code
func (o *AddConfigSourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add config source too many requests response a status code equal to that given
func (o *AddConfigSourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add config source too many requests response
func (o *AddConfigSourceTooManyRequests) Code() int {
	return 429
}

func (o *AddConfigSourceTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/configsources][%d] addConfigSourceTooManyRequests", 429)
}

func (o *AddConfigSourceTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/configsources][%d] addConfigSourceTooManyRequests", 429)
}

func (o *AddConfigSourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddConfigSourceDefault creates a AddConfigSourceDefault with default headers values
func NewAddConfigSourceDefault(code int) *AddConfigSourceDefault {
	return &AddConfigSourceDefault{
		_statusCode: code,
	}
}

/*
AddConfigSourceDefault describes a response with status code -1, with default header values.

Error
*/
type AddConfigSourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add config source default response has a 2xx status code
func (o *AddConfigSourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add config source default response has a 3xx status code
func (o *AddConfigSourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add config source default response has a 4xx status code
func (o *AddConfigSourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add config source default response has a 5xx status code
func (o *AddConfigSourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add config source default response a status code equal to that given
func (o *AddConfigSourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add config source default response
func (o *AddConfigSourceDefault) Code() int {
	return o._statusCode
}

func (o *AddConfigSourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/configsources][%d] addConfigSource default %s", o._statusCode, payload)
}

func (o *AddConfigSourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/configsources][%d] addConfigSource default %s", o._statusCode, payload)
}

func (o *AddConfigSourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddConfigSourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
