// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddDeviceDatasourceInstanceReader is a Reader for the AddDeviceDatasourceInstance structure.
type AddDeviceDatasourceInstanceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddDeviceDatasourceInstanceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddDeviceDatasourceInstanceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddDeviceDatasourceInstanceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddDeviceDatasourceInstanceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddDeviceDatasourceInstanceOK creates a AddDeviceDatasourceInstanceOK with default headers values
func NewAddDeviceDatasourceInstanceOK() *AddDeviceDatasourceInstanceOK {
	return &AddDeviceDatasourceInstanceOK{}
}

/*
AddDeviceDatasourceInstanceOK describes a response with status code 200, with default header values.

successful operation
*/
type AddDeviceDatasourceInstanceOK struct {
	Payload *models.DeviceDataSourceInstance
}

// IsSuccess returns true when this add device datasource instance o k response has a 2xx status code
func (o *AddDeviceDatasourceInstanceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add device datasource instance o k response has a 3xx status code
func (o *AddDeviceDatasourceInstanceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add device datasource instance o k response has a 4xx status code
func (o *AddDeviceDatasourceInstanceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add device datasource instance o k response has a 5xx status code
func (o *AddDeviceDatasourceInstanceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add device datasource instance o k response a status code equal to that given
func (o *AddDeviceDatasourceInstanceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add device datasource instance o k response
func (o *AddDeviceDatasourceInstanceOK) Code() int {
	return 200
}

func (o *AddDeviceDatasourceInstanceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /device/devices/{deviceId}/devicedatasources/{hdsId}/instances][%d] addDeviceDatasourceInstanceOK %s", 200, payload)
}

func (o *AddDeviceDatasourceInstanceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /device/devices/{deviceId}/devicedatasources/{hdsId}/instances][%d] addDeviceDatasourceInstanceOK %s", 200, payload)
}

func (o *AddDeviceDatasourceInstanceOK) GetPayload() *models.DeviceDataSourceInstance {
	return o.Payload
}

func (o *AddDeviceDatasourceInstanceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceDataSourceInstance)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddDeviceDatasourceInstanceTooManyRequests creates a AddDeviceDatasourceInstanceTooManyRequests with default headers values
func NewAddDeviceDatasourceInstanceTooManyRequests() *AddDeviceDatasourceInstanceTooManyRequests {
	return &AddDeviceDatasourceInstanceTooManyRequests{}
}

/*
AddDeviceDatasourceInstanceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddDeviceDatasourceInstanceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add device datasource instance too many requests response has a 2xx status code
func (o *AddDeviceDatasourceInstanceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add device datasource instance too many requests response has a 3xx status code
func (o *AddDeviceDatasourceInstanceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add device datasource instance too many requests response has a 4xx status code
func (o *AddDeviceDatasourceInstanceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add device datasource instance too many requests response has a 5xx status code
func (o *AddDeviceDatasourceInstanceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add device datasource instance too many requests response a status code equal to that given
func (o *AddDeviceDatasourceInstanceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add device datasource instance too many requests response
func (o *AddDeviceDatasourceInstanceTooManyRequests) Code() int {
	return 429
}

func (o *AddDeviceDatasourceInstanceTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /device/devices/{deviceId}/devicedatasources/{hdsId}/instances][%d] addDeviceDatasourceInstanceTooManyRequests", 429)
}

func (o *AddDeviceDatasourceInstanceTooManyRequests) String() string {
	return fmt.Sprintf("[POST /device/devices/{deviceId}/devicedatasources/{hdsId}/instances][%d] addDeviceDatasourceInstanceTooManyRequests", 429)
}

func (o *AddDeviceDatasourceInstanceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddDeviceDatasourceInstanceDefault creates a AddDeviceDatasourceInstanceDefault with default headers values
func NewAddDeviceDatasourceInstanceDefault(code int) *AddDeviceDatasourceInstanceDefault {
	return &AddDeviceDatasourceInstanceDefault{
		_statusCode: code,
	}
}

/*
AddDeviceDatasourceInstanceDefault describes a response with status code -1, with default header values.

Error
*/
type AddDeviceDatasourceInstanceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add device datasource instance default response has a 2xx status code
func (o *AddDeviceDatasourceInstanceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add device datasource instance default response has a 3xx status code
func (o *AddDeviceDatasourceInstanceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add device datasource instance default response has a 4xx status code
func (o *AddDeviceDatasourceInstanceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add device datasource instance default response has a 5xx status code
func (o *AddDeviceDatasourceInstanceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add device datasource instance default response a status code equal to that given
func (o *AddDeviceDatasourceInstanceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add device datasource instance default response
func (o *AddDeviceDatasourceInstanceDefault) Code() int {
	return o._statusCode
}

func (o *AddDeviceDatasourceInstanceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /device/devices/{deviceId}/devicedatasources/{hdsId}/instances][%d] addDeviceDatasourceInstance default %s", o._statusCode, payload)
}

func (o *AddDeviceDatasourceInstanceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /device/devices/{deviceId}/devicedatasources/{hdsId}/instances][%d] addDeviceDatasourceInstance default %s", o._statusCode, payload)
}

func (o *AddDeviceDatasourceInstanceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddDeviceDatasourceInstanceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
