// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddEventSourceReader is a Reader for the AddEventSource structure.
type AddEventSourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddEventSourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddEventSourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddEventSourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddEventSourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddEventSourceOK creates a AddEventSourceOK with default headers values
func NewAddEventSourceOK() *AddEventSourceOK {
	return &AddEventSourceOK{}
}

/*
AddEventSourceOK describes a response with status code 200, with default header values.

successful operation
*/
type AddEventSourceOK struct {
	Payload models.EventSource
}

// IsSuccess returns true when this add event source o k response has a 2xx status code
func (o *AddEventSourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add event source o k response has a 3xx status code
func (o *AddEventSourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add event source o k response has a 4xx status code
func (o *AddEventSourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add event source o k response has a 5xx status code
func (o *AddEventSourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add event source o k response a status code equal to that given
func (o *AddEventSourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add event source o k response
func (o *AddEventSourceOK) Code() int {
	return 200
}

func (o *AddEventSourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/eventsources][%d] addEventSourceOK %s", 200, payload)
}

func (o *AddEventSourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/eventsources][%d] addEventSourceOK %s", 200, payload)
}

func (o *AddEventSourceOK) GetPayload() models.EventSource {
	return o.Payload
}

func (o *AddEventSourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalEventSource(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewAddEventSourceTooManyRequests creates a AddEventSourceTooManyRequests with default headers values
func NewAddEventSourceTooManyRequests() *AddEventSourceTooManyRequests {
	return &AddEventSourceTooManyRequests{}
}

/*
AddEventSourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddEventSourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add event source too many requests response has a 2xx status code
func (o *AddEventSourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add event source too many requests response has a 3xx status code
func (o *AddEventSourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add event source too many requests response has a 4xx status code
func (o *AddEventSourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add event source too many requests response has a 5xx status code
func (o *AddEventSourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add event source too many requests response a status code equal to that given
func (o *AddEventSourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add event source too many requests response
func (o *AddEventSourceTooManyRequests) Code() int {
	return 429
}

func (o *AddEventSourceTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/eventsources][%d] addEventSourceTooManyRequests", 429)
}

func (o *AddEventSourceTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/eventsources][%d] addEventSourceTooManyRequests", 429)
}

func (o *AddEventSourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddEventSourceDefault creates a AddEventSourceDefault with default headers values
func NewAddEventSourceDefault(code int) *AddEventSourceDefault {
	return &AddEventSourceDefault{
		_statusCode: code,
	}
}

/*
AddEventSourceDefault describes a response with status code -1, with default header values.

Error
*/
type AddEventSourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add event source default response has a 2xx status code
func (o *AddEventSourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add event source default response has a 3xx status code
func (o *AddEventSourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add event source default response has a 4xx status code
func (o *AddEventSourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add event source default response has a 5xx status code
func (o *AddEventSourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add event source default response a status code equal to that given
func (o *AddEventSourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add event source default response
func (o *AddEventSourceDefault) Code() int {
	return o._statusCode
}

func (o *AddEventSourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/eventsources][%d] addEventSource default %s", o._statusCode, payload)
}

func (o *AddEventSourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/eventsources][%d] addEventSource default %s", o._statusCode, payload)
}

func (o *AddEventSourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddEventSourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
