// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddJobMonitorReader is a Reader for the AddJobMonitor structure.
type AddJobMonitorReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddJobMonitorReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddJobMonitorOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddJobMonitorTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddJobMonitorDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddJobMonitorOK creates a AddJobMonitorOK with default headers values
func NewAddJobMonitorOK() *AddJobMonitorOK {
	return &AddJobMonitorOK{}
}

/*
AddJobMonitorOK describes a response with status code 200, with default header values.

successful operation
*/
type AddJobMonitorOK struct {
	Payload *models.BatchJob
}

// IsSuccess returns true when this add job monitor o k response has a 2xx status code
func (o *AddJobMonitorOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add job monitor o k response has a 3xx status code
func (o *AddJobMonitorOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add job monitor o k response has a 4xx status code
func (o *AddJobMonitorOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add job monitor o k response has a 5xx status code
func (o *AddJobMonitorOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add job monitor o k response a status code equal to that given
func (o *AddJobMonitorOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add job monitor o k response
func (o *AddJobMonitorOK) Code() int {
	return 200
}

func (o *AddJobMonitorOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/batchjobs][%d] addJobMonitorOK %s", 200, payload)
}

func (o *AddJobMonitorOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/batchjobs][%d] addJobMonitorOK %s", 200, payload)
}

func (o *AddJobMonitorOK) GetPayload() *models.BatchJob {
	return o.Payload
}

func (o *AddJobMonitorOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.BatchJob)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddJobMonitorTooManyRequests creates a AddJobMonitorTooManyRequests with default headers values
func NewAddJobMonitorTooManyRequests() *AddJobMonitorTooManyRequests {
	return &AddJobMonitorTooManyRequests{}
}

/*
AddJobMonitorTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddJobMonitorTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add job monitor too many requests response has a 2xx status code
func (o *AddJobMonitorTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add job monitor too many requests response has a 3xx status code
func (o *AddJobMonitorTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add job monitor too many requests response has a 4xx status code
func (o *AddJobMonitorTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add job monitor too many requests response has a 5xx status code
func (o *AddJobMonitorTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add job monitor too many requests response a status code equal to that given
func (o *AddJobMonitorTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add job monitor too many requests response
func (o *AddJobMonitorTooManyRequests) Code() int {
	return 429
}

func (o *AddJobMonitorTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/batchjobs][%d] addJobMonitorTooManyRequests", 429)
}

func (o *AddJobMonitorTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/batchjobs][%d] addJobMonitorTooManyRequests", 429)
}

func (o *AddJobMonitorTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddJobMonitorDefault creates a AddJobMonitorDefault with default headers values
func NewAddJobMonitorDefault(code int) *AddJobMonitorDefault {
	return &AddJobMonitorDefault{
		_statusCode: code,
	}
}

/*
AddJobMonitorDefault describes a response with status code -1, with default header values.

Error
*/
type AddJobMonitorDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add job monitor default response has a 2xx status code
func (o *AddJobMonitorDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add job monitor default response has a 3xx status code
func (o *AddJobMonitorDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add job monitor default response has a 4xx status code
func (o *AddJobMonitorDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add job monitor default response has a 5xx status code
func (o *AddJobMonitorDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add job monitor default response a status code equal to that given
func (o *AddJobMonitorDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add job monitor default response
func (o *AddJobMonitorDefault) Code() int {
	return o._statusCode
}

func (o *AddJobMonitorDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/batchjobs][%d] addJobMonitor default %s", o._statusCode, payload)
}

func (o *AddJobMonitorDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/batchjobs][%d] addJobMonitor default %s", o._statusCode, payload)
}

func (o *AddJobMonitorDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddJobMonitorDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
