// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewAddLogSourceParams creates a new AddLogSourceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddLogSourceParams() *AddLogSourceParams {
	return &AddLogSourceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddLogSourceParamsWithTimeout creates a new AddLogSourceParams object
// with the ability to set a timeout on a request.
func NewAddLogSourceParamsWithTimeout(timeout time.Duration) *AddLogSourceParams {
	return &AddLogSourceParams{
		timeout: timeout,
	}
}

// NewAddLogSourceParamsWithContext creates a new AddLogSourceParams object
// with the ability to set a context for a request.
func NewAddLogSourceParamsWithContext(ctx context.Context) *AddLogSourceParams {
	return &AddLogSourceParams{
		Context: ctx,
	}
}

// NewAddLogSourceParamsWithHTTPClient creates a new AddLogSourceParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddLogSourceParamsWithHTTPClient(client *http.Client) *AddLogSourceParams {
	return &AddLogSourceParams{
		HTTPClient: client,
	}
}

/*
AddLogSourceParams contains all the parameters to send to the API endpoint

	for the add log source operation.

	Typically these are written to a http.Request.
*/
type AddLogSourceParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.LogSource

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add log source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddLogSourceParams) WithDefaults() *AddLogSourceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add log source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddLogSourceParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddLogSourceParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add log source params
func (o *AddLogSourceParams) WithTimeout(timeout time.Duration) *AddLogSourceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add log source params
func (o *AddLogSourceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add log source params
func (o *AddLogSourceParams) WithContext(ctx context.Context) *AddLogSourceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add log source params
func (o *AddLogSourceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add log source params
func (o *AddLogSourceParams) WithHTTPClient(client *http.Client) *AddLogSourceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add log source params
func (o *AddLogSourceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add log source params
func (o *AddLogSourceParams) WithUserAgent(userAgent *string) *AddLogSourceParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add log source params
func (o *AddLogSourceParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add log source params
func (o *AddLogSourceParams) WithBody(body *models.LogSource) *AddLogSourceParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add log source params
func (o *AddLogSourceParams) SetBody(body *models.LogSource) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddLogSourceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
