// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddLogSourceReader is a Reader for the AddLogSource structure.
type AddLogSourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddLogSourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddLogSourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddLogSourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddLogSourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddLogSourceOK creates a AddLogSourceOK with default headers values
func NewAddLogSourceOK() *AddLogSourceOK {
	return &AddLogSourceOK{}
}

/*
AddLogSourceOK describes a response with status code 200, with default header values.

successful operation
*/
type AddLogSourceOK struct {
	Payload *models.LogSource
}

// IsSuccess returns true when this add log source o k response has a 2xx status code
func (o *AddLogSourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add log source o k response has a 3xx status code
func (o *AddLogSourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add log source o k response has a 4xx status code
func (o *AddLogSourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add log source o k response has a 5xx status code
func (o *AddLogSourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add log source o k response a status code equal to that given
func (o *AddLogSourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add log source o k response
func (o *AddLogSourceOK) Code() int {
	return 200
}

func (o *AddLogSourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/logsources][%d] addLogSourceOK %s", 200, payload)
}

func (o *AddLogSourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/logsources][%d] addLogSourceOK %s", 200, payload)
}

func (o *AddLogSourceOK) GetPayload() *models.LogSource {
	return o.Payload
}

func (o *AddLogSourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LogSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddLogSourceTooManyRequests creates a AddLogSourceTooManyRequests with default headers values
func NewAddLogSourceTooManyRequests() *AddLogSourceTooManyRequests {
	return &AddLogSourceTooManyRequests{}
}

/*
AddLogSourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddLogSourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add log source too many requests response has a 2xx status code
func (o *AddLogSourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add log source too many requests response has a 3xx status code
func (o *AddLogSourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add log source too many requests response has a 4xx status code
func (o *AddLogSourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add log source too many requests response has a 5xx status code
func (o *AddLogSourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add log source too many requests response a status code equal to that given
func (o *AddLogSourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add log source too many requests response
func (o *AddLogSourceTooManyRequests) Code() int {
	return 429
}

func (o *AddLogSourceTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/logsources][%d] addLogSourceTooManyRequests", 429)
}

func (o *AddLogSourceTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/logsources][%d] addLogSourceTooManyRequests", 429)
}

func (o *AddLogSourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddLogSourceDefault creates a AddLogSourceDefault with default headers values
func NewAddLogSourceDefault(code int) *AddLogSourceDefault {
	return &AddLogSourceDefault{
		_statusCode: code,
	}
}

/*
AddLogSourceDefault describes a response with status code -1, with default header values.

Error
*/
type AddLogSourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add log source default response has a 2xx status code
func (o *AddLogSourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add log source default response has a 3xx status code
func (o *AddLogSourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add log source default response has a 4xx status code
func (o *AddLogSourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add log source default response has a 5xx status code
func (o *AddLogSourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add log source default response a status code equal to that given
func (o *AddLogSourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add log source default response
func (o *AddLogSourceDefault) Code() int {
	return o._statusCode
}

func (o *AddLogSourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/logsources][%d] addLogSource default %s", o._statusCode, payload)
}

func (o *AddLogSourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/logsources][%d] addLogSource default %s", o._statusCode, payload)
}

func (o *AddLogSourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddLogSourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
