// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddNetscanReader is a Reader for the AddNetscan structure.
type AddNetscanReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddNetscanReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddNetscanOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddNetscanTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddNetscanDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddNetscanOK creates a AddNetscanOK with default headers values
func NewAddNetscanOK() *AddNetscanOK {
	return &AddNetscanOK{}
}

/*
AddNetscanOK describes a response with status code 200, with default header values.

successful operation
*/
type AddNetscanOK struct {
	Payload models.Netscan
}

// IsSuccess returns true when this add netscan o k response has a 2xx status code
func (o *AddNetscanOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add netscan o k response has a 3xx status code
func (o *AddNetscanOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add netscan o k response has a 4xx status code
func (o *AddNetscanOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add netscan o k response has a 5xx status code
func (o *AddNetscanOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add netscan o k response a status code equal to that given
func (o *AddNetscanOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add netscan o k response
func (o *AddNetscanOK) Code() int {
	return 200
}

func (o *AddNetscanOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/netscans][%d] addNetscanOK %s", 200, payload)
}

func (o *AddNetscanOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/netscans][%d] addNetscanOK %s", 200, payload)
}

func (o *AddNetscanOK) GetPayload() models.Netscan {
	return o.Payload
}

func (o *AddNetscanOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalNetscan(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewAddNetscanTooManyRequests creates a AddNetscanTooManyRequests with default headers values
func NewAddNetscanTooManyRequests() *AddNetscanTooManyRequests {
	return &AddNetscanTooManyRequests{}
}

/*
AddNetscanTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddNetscanTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add netscan too many requests response has a 2xx status code
func (o *AddNetscanTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add netscan too many requests response has a 3xx status code
func (o *AddNetscanTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add netscan too many requests response has a 4xx status code
func (o *AddNetscanTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add netscan too many requests response has a 5xx status code
func (o *AddNetscanTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add netscan too many requests response a status code equal to that given
func (o *AddNetscanTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add netscan too many requests response
func (o *AddNetscanTooManyRequests) Code() int {
	return 429
}

func (o *AddNetscanTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/netscans][%d] addNetscanTooManyRequests", 429)
}

func (o *AddNetscanTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/netscans][%d] addNetscanTooManyRequests", 429)
}

func (o *AddNetscanTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddNetscanDefault creates a AddNetscanDefault with default headers values
func NewAddNetscanDefault(code int) *AddNetscanDefault {
	return &AddNetscanDefault{
		_statusCode: code,
	}
}

/*
AddNetscanDefault describes a response with status code -1, with default header values.

Error
*/
type AddNetscanDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add netscan default response has a 2xx status code
func (o *AddNetscanDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add netscan default response has a 3xx status code
func (o *AddNetscanDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add netscan default response has a 4xx status code
func (o *AddNetscanDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add netscan default response has a 5xx status code
func (o *AddNetscanDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add netscan default response a status code equal to that given
func (o *AddNetscanDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add netscan default response
func (o *AddNetscanDefault) Code() int {
	return o._statusCode
}

func (o *AddNetscanDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/netscans][%d] addNetscan default %s", o._statusCode, payload)
}

func (o *AddNetscanDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/netscans][%d] addNetscan default %s", o._statusCode, payload)
}

func (o *AddNetscanDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddNetscanDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
