// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewAddOidParams creates a new AddOidParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddOidParams() *AddOidParams {
	return &AddOidParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddOidParamsWithTimeout creates a new AddOidParams object
// with the ability to set a timeout on a request.
func NewAddOidParamsWithTimeout(timeout time.Duration) *AddOidParams {
	return &AddOidParams{
		timeout: timeout,
	}
}

// NewAddOidParamsWithContext creates a new AddOidParams object
// with the ability to set a context for a request.
func NewAddOidParamsWithContext(ctx context.Context) *AddOidParams {
	return &AddOidParams{
		Context: ctx,
	}
}

// NewAddOidParamsWithHTTPClient creates a new AddOidParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddOidParamsWithHTTPClient(client *http.Client) *AddOidParams {
	return &AddOidParams{
		HTTPClient: client,
	}
}

/*
AddOidParams contains all the parameters to send to the API endpoint

	for the add oid operation.

	Typically these are written to a http.Request.
*/
type AddOidParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.RestOidV3

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add oid params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddOidParams) WithDefaults() *AddOidParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add oid params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddOidParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddOidParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add oid params
func (o *AddOidParams) WithTimeout(timeout time.Duration) *AddOidParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add oid params
func (o *AddOidParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add oid params
func (o *AddOidParams) WithContext(ctx context.Context) *AddOidParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add oid params
func (o *AddOidParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add oid params
func (o *AddOidParams) WithHTTPClient(client *http.Client) *AddOidParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add oid params
func (o *AddOidParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add oid params
func (o *AddOidParams) WithUserAgent(userAgent *string) *AddOidParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add oid params
func (o *AddOidParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add oid params
func (o *AddOidParams) WithBody(body *models.RestOidV3) *AddOidParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add oid params
func (o *AddOidParams) SetBody(body *models.RestOidV3) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddOidParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
