// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddOidReader is a Reader for the AddOid structure.
type AddOidReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddOidReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddOidOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddOidTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddOidDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddOidOK creates a AddOidOK with default headers values
func NewAddOidOK() *AddOidOK {
	return &AddOidOK{}
}

/*
AddOidOK describes a response with status code 200, with default header values.

successful operation
*/
type AddOidOK struct {
	Payload *models.RestOidV3
}

// IsSuccess returns true when this add oid o k response has a 2xx status code
func (o *AddOidOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add oid o k response has a 3xx status code
func (o *AddOidOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add oid o k response has a 4xx status code
func (o *AddOidOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add oid o k response has a 5xx status code
func (o *AddOidOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add oid o k response a status code equal to that given
func (o *AddOidOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add oid o k response
func (o *AddOidOK) Code() int {
	return 200
}

func (o *AddOidOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/oids][%d] addOidOK %s", 200, payload)
}

func (o *AddOidOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/oids][%d] addOidOK %s", 200, payload)
}

func (o *AddOidOK) GetPayload() *models.RestOidV3 {
	return o.Payload
}

func (o *AddOidOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RestOidV3)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddOidTooManyRequests creates a AddOidTooManyRequests with default headers values
func NewAddOidTooManyRequests() *AddOidTooManyRequests {
	return &AddOidTooManyRequests{}
}

/*
AddOidTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddOidTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add oid too many requests response has a 2xx status code
func (o *AddOidTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add oid too many requests response has a 3xx status code
func (o *AddOidTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add oid too many requests response has a 4xx status code
func (o *AddOidTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add oid too many requests response has a 5xx status code
func (o *AddOidTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add oid too many requests response a status code equal to that given
func (o *AddOidTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add oid too many requests response
func (o *AddOidTooManyRequests) Code() int {
	return 429
}

func (o *AddOidTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/oids][%d] addOidTooManyRequests", 429)
}

func (o *AddOidTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/oids][%d] addOidTooManyRequests", 429)
}

func (o *AddOidTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddOidDefault creates a AddOidDefault with default headers values
func NewAddOidDefault(code int) *AddOidDefault {
	return &AddOidDefault{
		_statusCode: code,
	}
}

/*
AddOidDefault describes a response with status code -1, with default header values.

Error
*/
type AddOidDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add oid default response has a 2xx status code
func (o *AddOidDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add oid default response has a 3xx status code
func (o *AddOidDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add oid default response has a 4xx status code
func (o *AddOidDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add oid default response has a 5xx status code
func (o *AddOidDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add oid default response a status code equal to that given
func (o *AddOidDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add oid default response
func (o *AddOidDefault) Code() int {
	return o._statusCode
}

func (o *AddOidDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/oids][%d] addOid default %s", o._statusCode, payload)
}

func (o *AddOidDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/oids][%d] addOid default %s", o._statusCode, payload)
}

func (o *AddOidDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddOidDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
