// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewAddPropertyRuleParams creates a new AddPropertyRuleParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddPropertyRuleParams() *AddPropertyRuleParams {
	return &AddPropertyRuleParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddPropertyRuleParamsWithTimeout creates a new AddPropertyRuleParams object
// with the ability to set a timeout on a request.
func NewAddPropertyRuleParamsWithTimeout(timeout time.Duration) *AddPropertyRuleParams {
	return &AddPropertyRuleParams{
		timeout: timeout,
	}
}

// NewAddPropertyRuleParamsWithContext creates a new AddPropertyRuleParams object
// with the ability to set a context for a request.
func NewAddPropertyRuleParamsWithContext(ctx context.Context) *AddPropertyRuleParams {
	return &AddPropertyRuleParams{
		Context: ctx,
	}
}

// NewAddPropertyRuleParamsWithHTTPClient creates a new AddPropertyRuleParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddPropertyRuleParamsWithHTTPClient(client *http.Client) *AddPropertyRuleParams {
	return &AddPropertyRuleParams{
		HTTPClient: client,
	}
}

/*
AddPropertyRuleParams contains all the parameters to send to the API endpoint

	for the add property rule operation.

	Typically these are written to a http.Request.
*/
type AddPropertyRuleParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.PropertyRule

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add property rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddPropertyRuleParams) WithDefaults() *AddPropertyRuleParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add property rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddPropertyRuleParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddPropertyRuleParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add property rule params
func (o *AddPropertyRuleParams) WithTimeout(timeout time.Duration) *AddPropertyRuleParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add property rule params
func (o *AddPropertyRuleParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add property rule params
func (o *AddPropertyRuleParams) WithContext(ctx context.Context) *AddPropertyRuleParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add property rule params
func (o *AddPropertyRuleParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add property rule params
func (o *AddPropertyRuleParams) WithHTTPClient(client *http.Client) *AddPropertyRuleParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add property rule params
func (o *AddPropertyRuleParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add property rule params
func (o *AddPropertyRuleParams) WithUserAgent(userAgent *string) *AddPropertyRuleParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add property rule params
func (o *AddPropertyRuleParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add property rule params
func (o *AddPropertyRuleParams) WithBody(body *models.PropertyRule) *AddPropertyRuleParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add property rule params
func (o *AddPropertyRuleParams) SetBody(body *models.PropertyRule) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddPropertyRuleParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
