// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddPropertyRuleReader is a Reader for the AddPropertyRule structure.
type AddPropertyRuleReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddPropertyRuleReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddPropertyRuleOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddPropertyRuleTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddPropertyRuleDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddPropertyRuleOK creates a AddPropertyRuleOK with default headers values
func NewAddPropertyRuleOK() *AddPropertyRuleOK {
	return &AddPropertyRuleOK{}
}

/*
AddPropertyRuleOK describes a response with status code 200, with default header values.

successful operation
*/
type AddPropertyRuleOK struct {
	Payload *models.PropertyRule
}

// IsSuccess returns true when this add property rule o k response has a 2xx status code
func (o *AddPropertyRuleOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add property rule o k response has a 3xx status code
func (o *AddPropertyRuleOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add property rule o k response has a 4xx status code
func (o *AddPropertyRuleOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add property rule o k response has a 5xx status code
func (o *AddPropertyRuleOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add property rule o k response a status code equal to that given
func (o *AddPropertyRuleOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add property rule o k response
func (o *AddPropertyRuleOK) Code() int {
	return 200
}

func (o *AddPropertyRuleOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/propertyrules][%d] addPropertyRuleOK %s", 200, payload)
}

func (o *AddPropertyRuleOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/propertyrules][%d] addPropertyRuleOK %s", 200, payload)
}

func (o *AddPropertyRuleOK) GetPayload() *models.PropertyRule {
	return o.Payload
}

func (o *AddPropertyRuleOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.PropertyRule)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddPropertyRuleTooManyRequests creates a AddPropertyRuleTooManyRequests with default headers values
func NewAddPropertyRuleTooManyRequests() *AddPropertyRuleTooManyRequests {
	return &AddPropertyRuleTooManyRequests{}
}

/*
AddPropertyRuleTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddPropertyRuleTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add property rule too many requests response has a 2xx status code
func (o *AddPropertyRuleTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add property rule too many requests response has a 3xx status code
func (o *AddPropertyRuleTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add property rule too many requests response has a 4xx status code
func (o *AddPropertyRuleTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add property rule too many requests response has a 5xx status code
func (o *AddPropertyRuleTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add property rule too many requests response a status code equal to that given
func (o *AddPropertyRuleTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add property rule too many requests response
func (o *AddPropertyRuleTooManyRequests) Code() int {
	return 429
}

func (o *AddPropertyRuleTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/propertyrules][%d] addPropertyRuleTooManyRequests", 429)
}

func (o *AddPropertyRuleTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/propertyrules][%d] addPropertyRuleTooManyRequests", 429)
}

func (o *AddPropertyRuleTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddPropertyRuleDefault creates a AddPropertyRuleDefault with default headers values
func NewAddPropertyRuleDefault(code int) *AddPropertyRuleDefault {
	return &AddPropertyRuleDefault{
		_statusCode: code,
	}
}

/*
AddPropertyRuleDefault describes a response with status code -1, with default header values.

Error
*/
type AddPropertyRuleDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add property rule default response has a 2xx status code
func (o *AddPropertyRuleDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add property rule default response has a 3xx status code
func (o *AddPropertyRuleDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add property rule default response has a 4xx status code
func (o *AddPropertyRuleDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add property rule default response has a 5xx status code
func (o *AddPropertyRuleDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add property rule default response a status code equal to that given
func (o *AddPropertyRuleDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add property rule default response
func (o *AddPropertyRuleDefault) Code() int {
	return o._statusCode
}

func (o *AddPropertyRuleDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/propertyrules][%d] addPropertyRule default %s", o._statusCode, payload)
}

func (o *AddPropertyRuleDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/propertyrules][%d] addPropertyRule default %s", o._statusCode, payload)
}

func (o *AddPropertyRuleDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddPropertyRuleDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
