// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddTopologySourceReader is a Reader for the AddTopologySource structure.
type AddTopologySourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddTopologySourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddTopologySourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddTopologySourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddTopologySourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddTopologySourceOK creates a AddTopologySourceOK with default headers values
func NewAddTopologySourceOK() *AddTopologySourceOK {
	return &AddTopologySourceOK{}
}

/*
AddTopologySourceOK describes a response with status code 200, with default header values.

successful operation
*/
type AddTopologySourceOK struct {
	Payload *models.TopologySource
}

// IsSuccess returns true when this add topology source o k response has a 2xx status code
func (o *AddTopologySourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add topology source o k response has a 3xx status code
func (o *AddTopologySourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add topology source o k response has a 4xx status code
func (o *AddTopologySourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add topology source o k response has a 5xx status code
func (o *AddTopologySourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add topology source o k response a status code equal to that given
func (o *AddTopologySourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add topology source o k response
func (o *AddTopologySourceOK) Code() int {
	return 200
}

func (o *AddTopologySourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/topologysources][%d] addTopologySourceOK %s", 200, payload)
}

func (o *AddTopologySourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/topologysources][%d] addTopologySourceOK %s", 200, payload)
}

func (o *AddTopologySourceOK) GetPayload() *models.TopologySource {
	return o.Payload
}

func (o *AddTopologySourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.TopologySource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddTopologySourceTooManyRequests creates a AddTopologySourceTooManyRequests with default headers values
func NewAddTopologySourceTooManyRequests() *AddTopologySourceTooManyRequests {
	return &AddTopologySourceTooManyRequests{}
}

/*
AddTopologySourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddTopologySourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add topology source too many requests response has a 2xx status code
func (o *AddTopologySourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add topology source too many requests response has a 3xx status code
func (o *AddTopologySourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add topology source too many requests response has a 4xx status code
func (o *AddTopologySourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add topology source too many requests response has a 5xx status code
func (o *AddTopologySourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add topology source too many requests response a status code equal to that given
func (o *AddTopologySourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add topology source too many requests response
func (o *AddTopologySourceTooManyRequests) Code() int {
	return 429
}

func (o *AddTopologySourceTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/topologysources][%d] addTopologySourceTooManyRequests", 429)
}

func (o *AddTopologySourceTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/topologysources][%d] addTopologySourceTooManyRequests", 429)
}

func (o *AddTopologySourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddTopologySourceDefault creates a AddTopologySourceDefault with default headers values
func NewAddTopologySourceDefault(code int) *AddTopologySourceDefault {
	return &AddTopologySourceDefault{
		_statusCode: code,
	}
}

/*
AddTopologySourceDefault describes a response with status code -1, with default header values.

Error
*/
type AddTopologySourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add topology source default response has a 2xx status code
func (o *AddTopologySourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add topology source default response has a 3xx status code
func (o *AddTopologySourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add topology source default response has a 4xx status code
func (o *AddTopologySourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add topology source default response has a 5xx status code
func (o *AddTopologySourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add topology source default response a status code equal to that given
func (o *AddTopologySourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add topology source default response
func (o *AddTopologySourceDefault) Code() int {
	return o._statusCode
}

func (o *AddTopologySourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/topologysources][%d] addTopologySource default %s", o._statusCode, payload)
}

func (o *AddTopologySourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/topologysources][%d] addTopologySource default %s", o._statusCode, payload)
}

func (o *AddTopologySourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddTopologySourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
