// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddWebsiteReader is a Reader for the AddWebsite structure.
type AddWebsiteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddWebsiteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddWebsiteOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddWebsiteTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddWebsiteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddWebsiteOK creates a AddWebsiteOK with default headers values
func NewAddWebsiteOK() *AddWebsiteOK {
	return &AddWebsiteOK{}
}

/*
AddWebsiteOK describes a response with status code 200, with default header values.

successful operation
*/
type AddWebsiteOK struct {
	Payload models.Website
}

// IsSuccess returns true when this add website o k response has a 2xx status code
func (o *AddWebsiteOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add website o k response has a 3xx status code
func (o *AddWebsiteOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add website o k response has a 4xx status code
func (o *AddWebsiteOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add website o k response has a 5xx status code
func (o *AddWebsiteOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add website o k response a status code equal to that given
func (o *AddWebsiteOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add website o k response
func (o *AddWebsiteOK) Code() int {
	return 200
}

func (o *AddWebsiteOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /website/websites][%d] addWebsiteOK %s", 200, payload)
}

func (o *AddWebsiteOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /website/websites][%d] addWebsiteOK %s", 200, payload)
}

func (o *AddWebsiteOK) GetPayload() models.Website {
	return o.Payload
}

func (o *AddWebsiteOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalWebsite(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewAddWebsiteTooManyRequests creates a AddWebsiteTooManyRequests with default headers values
func NewAddWebsiteTooManyRequests() *AddWebsiteTooManyRequests {
	return &AddWebsiteTooManyRequests{}
}

/*
AddWebsiteTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddWebsiteTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add website too many requests response has a 2xx status code
func (o *AddWebsiteTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add website too many requests response has a 3xx status code
func (o *AddWebsiteTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add website too many requests response has a 4xx status code
func (o *AddWebsiteTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add website too many requests response has a 5xx status code
func (o *AddWebsiteTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add website too many requests response a status code equal to that given
func (o *AddWebsiteTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add website too many requests response
func (o *AddWebsiteTooManyRequests) Code() int {
	return 429
}

func (o *AddWebsiteTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /website/websites][%d] addWebsiteTooManyRequests", 429)
}

func (o *AddWebsiteTooManyRequests) String() string {
	return fmt.Sprintf("[POST /website/websites][%d] addWebsiteTooManyRequests", 429)
}

func (o *AddWebsiteTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddWebsiteDefault creates a AddWebsiteDefault with default headers values
func NewAddWebsiteDefault(code int) *AddWebsiteDefault {
	return &AddWebsiteDefault{
		_statusCode: code,
	}
}

/*
AddWebsiteDefault describes a response with status code -1, with default header values.

Error
*/
type AddWebsiteDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add website default response has a 2xx status code
func (o *AddWebsiteDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add website default response has a 3xx status code
func (o *AddWebsiteDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add website default response has a 4xx status code
func (o *AddWebsiteDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add website default response has a 5xx status code
func (o *AddWebsiteDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add website default response a status code equal to that given
func (o *AddWebsiteDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add website default response
func (o *AddWebsiteDefault) Code() int {
	return o._statusCode
}

func (o *AddWebsiteDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /website/websites][%d] addWebsite default %s", o._statusCode, payload)
}

func (o *AddWebsiteDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /website/websites][%d] addWebsite default %s", o._statusCode, payload)
}

func (o *AddWebsiteDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddWebsiteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
