// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteAPITokenByIDReader is a Reader for the DeleteAPITokenByID structure.
type DeleteAPITokenByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteAPITokenByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteAPITokenByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteAPITokenByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteAPITokenByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteAPITokenByIDOK creates a DeleteAPITokenByIDOK with default headers values
func NewDeleteAPITokenByIDOK() *DeleteAPITokenByIDOK {
	return &DeleteAPITokenByIDOK{}
}

/*
DeleteAPITokenByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteAPITokenByIDOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete Api token by Id o k response has a 2xx status code
func (o *DeleteAPITokenByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete Api token by Id o k response has a 3xx status code
func (o *DeleteAPITokenByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete Api token by Id o k response has a 4xx status code
func (o *DeleteAPITokenByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete Api token by Id o k response has a 5xx status code
func (o *DeleteAPITokenByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete Api token by Id o k response a status code equal to that given
func (o *DeleteAPITokenByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete Api token by Id o k response
func (o *DeleteAPITokenByIDOK) Code() int {
	return 200
}

func (o *DeleteAPITokenByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/admins/{adminId}/apitokens/{apitokenId}][%d] deleteApiTokenByIdOK %s", 200, payload)
}

func (o *DeleteAPITokenByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/admins/{adminId}/apitokens/{apitokenId}][%d] deleteApiTokenByIdOK %s", 200, payload)
}

func (o *DeleteAPITokenByIDOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteAPITokenByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteAPITokenByIDTooManyRequests creates a DeleteAPITokenByIDTooManyRequests with default headers values
func NewDeleteAPITokenByIDTooManyRequests() *DeleteAPITokenByIDTooManyRequests {
	return &DeleteAPITokenByIDTooManyRequests{}
}

/*
DeleteAPITokenByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteAPITokenByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete Api token by Id too many requests response has a 2xx status code
func (o *DeleteAPITokenByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete Api token by Id too many requests response has a 3xx status code
func (o *DeleteAPITokenByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete Api token by Id too many requests response has a 4xx status code
func (o *DeleteAPITokenByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete Api token by Id too many requests response has a 5xx status code
func (o *DeleteAPITokenByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete Api token by Id too many requests response a status code equal to that given
func (o *DeleteAPITokenByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete Api token by Id too many requests response
func (o *DeleteAPITokenByIDTooManyRequests) Code() int {
	return 429
}

func (o *DeleteAPITokenByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /setting/admins/{adminId}/apitokens/{apitokenId}][%d] deleteApiTokenByIdTooManyRequests", 429)
}

func (o *DeleteAPITokenByIDTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /setting/admins/{adminId}/apitokens/{apitokenId}][%d] deleteApiTokenByIdTooManyRequests", 429)
}

func (o *DeleteAPITokenByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteAPITokenByIDDefault creates a DeleteAPITokenByIDDefault with default headers values
func NewDeleteAPITokenByIDDefault(code int) *DeleteAPITokenByIDDefault {
	return &DeleteAPITokenByIDDefault{
		_statusCode: code,
	}
}

/*
DeleteAPITokenByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteAPITokenByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete Api token by Id default response has a 2xx status code
func (o *DeleteAPITokenByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete Api token by Id default response has a 3xx status code
func (o *DeleteAPITokenByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete Api token by Id default response has a 4xx status code
func (o *DeleteAPITokenByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete Api token by Id default response has a 5xx status code
func (o *DeleteAPITokenByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete Api token by Id default response a status code equal to that given
func (o *DeleteAPITokenByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete Api token by Id default response
func (o *DeleteAPITokenByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteAPITokenByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/admins/{adminId}/apitokens/{apitokenId}][%d] deleteApiTokenById default %s", o._statusCode, payload)
}

func (o *DeleteAPITokenByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/admins/{adminId}/apitokens/{apitokenId}][%d] deleteApiTokenById default %s", o._statusCode, payload)
}

func (o *DeleteAPITokenByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteAPITokenByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
