// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteConfigSourceByIDReader is a Reader for the DeleteConfigSourceByID structure.
type DeleteConfigSourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteConfigSourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteConfigSourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteConfigSourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteConfigSourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteConfigSourceByIDOK creates a DeleteConfigSourceByIDOK with default headers values
func NewDeleteConfigSourceByIDOK() *DeleteConfigSourceByIDOK {
	return &DeleteConfigSourceByIDOK{}
}

/*
DeleteConfigSourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteConfigSourceByIDOK struct {
	Payload *models.ConfigSource
}

// IsSuccess returns true when this delete config source by Id o k response has a 2xx status code
func (o *DeleteConfigSourceByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete config source by Id o k response has a 3xx status code
func (o *DeleteConfigSourceByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete config source by Id o k response has a 4xx status code
func (o *DeleteConfigSourceByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete config source by Id o k response has a 5xx status code
func (o *DeleteConfigSourceByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete config source by Id o k response a status code equal to that given
func (o *DeleteConfigSourceByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete config source by Id o k response
func (o *DeleteConfigSourceByIDOK) Code() int {
	return 200
}

func (o *DeleteConfigSourceByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/configsources/{id}][%d] deleteConfigSourceByIdOK %s", 200, payload)
}

func (o *DeleteConfigSourceByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/configsources/{id}][%d] deleteConfigSourceByIdOK %s", 200, payload)
}

func (o *DeleteConfigSourceByIDOK) GetPayload() *models.ConfigSource {
	return o.Payload
}

func (o *DeleteConfigSourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ConfigSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteConfigSourceByIDTooManyRequests creates a DeleteConfigSourceByIDTooManyRequests with default headers values
func NewDeleteConfigSourceByIDTooManyRequests() *DeleteConfigSourceByIDTooManyRequests {
	return &DeleteConfigSourceByIDTooManyRequests{}
}

/*
DeleteConfigSourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteConfigSourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete config source by Id too many requests response has a 2xx status code
func (o *DeleteConfigSourceByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete config source by Id too many requests response has a 3xx status code
func (o *DeleteConfigSourceByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete config source by Id too many requests response has a 4xx status code
func (o *DeleteConfigSourceByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete config source by Id too many requests response has a 5xx status code
func (o *DeleteConfigSourceByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete config source by Id too many requests response a status code equal to that given
func (o *DeleteConfigSourceByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete config source by Id too many requests response
func (o *DeleteConfigSourceByIDTooManyRequests) Code() int {
	return 429
}

func (o *DeleteConfigSourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /setting/configsources/{id}][%d] deleteConfigSourceByIdTooManyRequests", 429)
}

func (o *DeleteConfigSourceByIDTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /setting/configsources/{id}][%d] deleteConfigSourceByIdTooManyRequests", 429)
}

func (o *DeleteConfigSourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteConfigSourceByIDDefault creates a DeleteConfigSourceByIDDefault with default headers values
func NewDeleteConfigSourceByIDDefault(code int) *DeleteConfigSourceByIDDefault {
	return &DeleteConfigSourceByIDDefault{
		_statusCode: code,
	}
}

/*
DeleteConfigSourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteConfigSourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete config source by Id default response has a 2xx status code
func (o *DeleteConfigSourceByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete config source by Id default response has a 3xx status code
func (o *DeleteConfigSourceByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete config source by Id default response has a 4xx status code
func (o *DeleteConfigSourceByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete config source by Id default response has a 5xx status code
func (o *DeleteConfigSourceByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete config source by Id default response a status code equal to that given
func (o *DeleteConfigSourceByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete config source by Id default response
func (o *DeleteConfigSourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteConfigSourceByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/configsources/{id}][%d] deleteConfigSourceById default %s", o._statusCode, payload)
}

func (o *DeleteConfigSourceByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/configsources/{id}][%d] deleteConfigSourceById default %s", o._statusCode, payload)
}

func (o *DeleteConfigSourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteConfigSourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
