// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteLogPartitionByIDReader is a Reader for the DeleteLogPartitionByID structure.
type DeleteLogPartitionByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteLogPartitionByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteLogPartitionByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteLogPartitionByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteLogPartitionByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteLogPartitionByIDOK creates a DeleteLogPartitionByIDOK with default headers values
func NewDeleteLogPartitionByIDOK() *DeleteLogPartitionByIDOK {
	return &DeleteLogPartitionByIDOK{}
}

/*
DeleteLogPartitionByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteLogPartitionByIDOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete log partition by Id o k response has a 2xx status code
func (o *DeleteLogPartitionByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete log partition by Id o k response has a 3xx status code
func (o *DeleteLogPartitionByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete log partition by Id o k response has a 4xx status code
func (o *DeleteLogPartitionByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete log partition by Id o k response has a 5xx status code
func (o *DeleteLogPartitionByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete log partition by Id o k response a status code equal to that given
func (o *DeleteLogPartitionByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete log partition by Id o k response
func (o *DeleteLogPartitionByIDOK) Code() int {
	return 200
}

func (o *DeleteLogPartitionByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /log/partitions/{id}][%d] deleteLogPartitionByIdOK %s", 200, payload)
}

func (o *DeleteLogPartitionByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /log/partitions/{id}][%d] deleteLogPartitionByIdOK %s", 200, payload)
}

func (o *DeleteLogPartitionByIDOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteLogPartitionByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteLogPartitionByIDTooManyRequests creates a DeleteLogPartitionByIDTooManyRequests with default headers values
func NewDeleteLogPartitionByIDTooManyRequests() *DeleteLogPartitionByIDTooManyRequests {
	return &DeleteLogPartitionByIDTooManyRequests{}
}

/*
DeleteLogPartitionByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteLogPartitionByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete log partition by Id too many requests response has a 2xx status code
func (o *DeleteLogPartitionByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete log partition by Id too many requests response has a 3xx status code
func (o *DeleteLogPartitionByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete log partition by Id too many requests response has a 4xx status code
func (o *DeleteLogPartitionByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete log partition by Id too many requests response has a 5xx status code
func (o *DeleteLogPartitionByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete log partition by Id too many requests response a status code equal to that given
func (o *DeleteLogPartitionByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete log partition by Id too many requests response
func (o *DeleteLogPartitionByIDTooManyRequests) Code() int {
	return 429
}

func (o *DeleteLogPartitionByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /log/partitions/{id}][%d] deleteLogPartitionByIdTooManyRequests", 429)
}

func (o *DeleteLogPartitionByIDTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /log/partitions/{id}][%d] deleteLogPartitionByIdTooManyRequests", 429)
}

func (o *DeleteLogPartitionByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteLogPartitionByIDDefault creates a DeleteLogPartitionByIDDefault with default headers values
func NewDeleteLogPartitionByIDDefault(code int) *DeleteLogPartitionByIDDefault {
	return &DeleteLogPartitionByIDDefault{
		_statusCode: code,
	}
}

/*
DeleteLogPartitionByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteLogPartitionByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete log partition by Id default response has a 2xx status code
func (o *DeleteLogPartitionByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete log partition by Id default response has a 3xx status code
func (o *DeleteLogPartitionByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete log partition by Id default response has a 4xx status code
func (o *DeleteLogPartitionByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete log partition by Id default response has a 5xx status code
func (o *DeleteLogPartitionByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete log partition by Id default response a status code equal to that given
func (o *DeleteLogPartitionByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete log partition by Id default response
func (o *DeleteLogPartitionByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteLogPartitionByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /log/partitions/{id}][%d] deleteLogPartitionById default %s", o._statusCode, payload)
}

func (o *DeleteLogPartitionByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /log/partitions/{id}][%d] deleteLogPartitionById default %s", o._statusCode, payload)
}

func (o *DeleteLogPartitionByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteLogPartitionByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
