// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeletePropertyRuleParams creates a new DeletePropertyRuleParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeletePropertyRuleParams() *DeletePropertyRuleParams {
	return &DeletePropertyRuleParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeletePropertyRuleParamsWithTimeout creates a new DeletePropertyRuleParams object
// with the ability to set a timeout on a request.
func NewDeletePropertyRuleParamsWithTimeout(timeout time.Duration) *DeletePropertyRuleParams {
	return &DeletePropertyRuleParams{
		timeout: timeout,
	}
}

// NewDeletePropertyRuleParamsWithContext creates a new DeletePropertyRuleParams object
// with the ability to set a context for a request.
func NewDeletePropertyRuleParamsWithContext(ctx context.Context) *DeletePropertyRuleParams {
	return &DeletePropertyRuleParams{
		Context: ctx,
	}
}

// NewDeletePropertyRuleParamsWithHTTPClient creates a new DeletePropertyRuleParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeletePropertyRuleParamsWithHTTPClient(client *http.Client) *DeletePropertyRuleParams {
	return &DeletePropertyRuleParams{
		HTTPClient: client,
	}
}

/*
DeletePropertyRuleParams contains all the parameters to send to the API endpoint

	for the delete property rule operation.

	Typically these are written to a http.Request.
*/
type DeletePropertyRuleParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// ID.
	//
	// Format: int32
	ID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete property rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeletePropertyRuleParams) WithDefaults() *DeletePropertyRuleParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete property rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeletePropertyRuleParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := DeletePropertyRuleParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the delete property rule params
func (o *DeletePropertyRuleParams) WithTimeout(timeout time.Duration) *DeletePropertyRuleParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete property rule params
func (o *DeletePropertyRuleParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete property rule params
func (o *DeletePropertyRuleParams) WithContext(ctx context.Context) *DeletePropertyRuleParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete property rule params
func (o *DeletePropertyRuleParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete property rule params
func (o *DeletePropertyRuleParams) WithHTTPClient(client *http.Client) *DeletePropertyRuleParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete property rule params
func (o *DeletePropertyRuleParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the delete property rule params
func (o *DeletePropertyRuleParams) WithUserAgent(userAgent *string) *DeletePropertyRuleParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the delete property rule params
func (o *DeletePropertyRuleParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithID adds the id to the delete property rule params
func (o *DeletePropertyRuleParams) WithID(id int32) *DeletePropertyRuleParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the delete property rule params
func (o *DeletePropertyRuleParams) SetID(id int32) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *DeletePropertyRuleParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
