// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteSDTByIDReader is a Reader for the DeleteSDTByID structure.
type DeleteSDTByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteSDTByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteSDTByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteSDTByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteSDTByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteSDTByIDOK creates a DeleteSDTByIDOK with default headers values
func NewDeleteSDTByIDOK() *DeleteSDTByIDOK {
	return &DeleteSDTByIDOK{}
}

/*
DeleteSDTByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteSDTByIDOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete Sdt by Id o k response has a 2xx status code
func (o *DeleteSDTByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete Sdt by Id o k response has a 3xx status code
func (o *DeleteSDTByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete Sdt by Id o k response has a 4xx status code
func (o *DeleteSDTByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete Sdt by Id o k response has a 5xx status code
func (o *DeleteSDTByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete Sdt by Id o k response a status code equal to that given
func (o *DeleteSDTByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete Sdt by Id o k response
func (o *DeleteSDTByIDOK) Code() int {
	return 200
}

func (o *DeleteSDTByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /sdt/sdts/{id}][%d] deleteSdtByIdOK %s", 200, payload)
}

func (o *DeleteSDTByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /sdt/sdts/{id}][%d] deleteSdtByIdOK %s", 200, payload)
}

func (o *DeleteSDTByIDOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteSDTByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteSDTByIDTooManyRequests creates a DeleteSDTByIDTooManyRequests with default headers values
func NewDeleteSDTByIDTooManyRequests() *DeleteSDTByIDTooManyRequests {
	return &DeleteSDTByIDTooManyRequests{}
}

/*
DeleteSDTByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteSDTByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete Sdt by Id too many requests response has a 2xx status code
func (o *DeleteSDTByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete Sdt by Id too many requests response has a 3xx status code
func (o *DeleteSDTByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete Sdt by Id too many requests response has a 4xx status code
func (o *DeleteSDTByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete Sdt by Id too many requests response has a 5xx status code
func (o *DeleteSDTByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete Sdt by Id too many requests response a status code equal to that given
func (o *DeleteSDTByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete Sdt by Id too many requests response
func (o *DeleteSDTByIDTooManyRequests) Code() int {
	return 429
}

func (o *DeleteSDTByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /sdt/sdts/{id}][%d] deleteSdtByIdTooManyRequests", 429)
}

func (o *DeleteSDTByIDTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /sdt/sdts/{id}][%d] deleteSdtByIdTooManyRequests", 429)
}

func (o *DeleteSDTByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteSDTByIDDefault creates a DeleteSDTByIDDefault with default headers values
func NewDeleteSDTByIDDefault(code int) *DeleteSDTByIDDefault {
	return &DeleteSDTByIDDefault{
		_statusCode: code,
	}
}

/*
DeleteSDTByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteSDTByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete Sdt by Id default response has a 2xx status code
func (o *DeleteSDTByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete Sdt by Id default response has a 3xx status code
func (o *DeleteSDTByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete Sdt by Id default response has a 4xx status code
func (o *DeleteSDTByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete Sdt by Id default response has a 5xx status code
func (o *DeleteSDTByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete Sdt by Id default response a status code equal to that given
func (o *DeleteSDTByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete Sdt by Id default response
func (o *DeleteSDTByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteSDTByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /sdt/sdts/{id}][%d] deleteSdtById default %s", o._statusCode, payload)
}

func (o *DeleteSDTByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /sdt/sdts/{id}][%d] deleteSdtById default %s", o._statusCode, payload)
}

func (o *DeleteSDTByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteSDTByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
