// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteWebsiteByIDReader is a Reader for the DeleteWebsiteByID structure.
type DeleteWebsiteByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteWebsiteByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteWebsiteByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteWebsiteByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteWebsiteByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteWebsiteByIDOK creates a DeleteWebsiteByIDOK with default headers values
func NewDeleteWebsiteByIDOK() *DeleteWebsiteByIDOK {
	return &DeleteWebsiteByIDOK{}
}

/*
DeleteWebsiteByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteWebsiteByIDOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete website by Id o k response has a 2xx status code
func (o *DeleteWebsiteByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete website by Id o k response has a 3xx status code
func (o *DeleteWebsiteByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete website by Id o k response has a 4xx status code
func (o *DeleteWebsiteByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete website by Id o k response has a 5xx status code
func (o *DeleteWebsiteByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete website by Id o k response a status code equal to that given
func (o *DeleteWebsiteByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete website by Id o k response
func (o *DeleteWebsiteByIDOK) Code() int {
	return 200
}

func (o *DeleteWebsiteByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /website/websites/{id}][%d] deleteWebsiteByIdOK %s", 200, payload)
}

func (o *DeleteWebsiteByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /website/websites/{id}][%d] deleteWebsiteByIdOK %s", 200, payload)
}

func (o *DeleteWebsiteByIDOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteWebsiteByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteWebsiteByIDTooManyRequests creates a DeleteWebsiteByIDTooManyRequests with default headers values
func NewDeleteWebsiteByIDTooManyRequests() *DeleteWebsiteByIDTooManyRequests {
	return &DeleteWebsiteByIDTooManyRequests{}
}

/*
DeleteWebsiteByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteWebsiteByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete website by Id too many requests response has a 2xx status code
func (o *DeleteWebsiteByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete website by Id too many requests response has a 3xx status code
func (o *DeleteWebsiteByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete website by Id too many requests response has a 4xx status code
func (o *DeleteWebsiteByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete website by Id too many requests response has a 5xx status code
func (o *DeleteWebsiteByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete website by Id too many requests response a status code equal to that given
func (o *DeleteWebsiteByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete website by Id too many requests response
func (o *DeleteWebsiteByIDTooManyRequests) Code() int {
	return 429
}

func (o *DeleteWebsiteByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /website/websites/{id}][%d] deleteWebsiteByIdTooManyRequests", 429)
}

func (o *DeleteWebsiteByIDTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /website/websites/{id}][%d] deleteWebsiteByIdTooManyRequests", 429)
}

func (o *DeleteWebsiteByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteWebsiteByIDDefault creates a DeleteWebsiteByIDDefault with default headers values
func NewDeleteWebsiteByIDDefault(code int) *DeleteWebsiteByIDDefault {
	return &DeleteWebsiteByIDDefault{
		_statusCode: code,
	}
}

/*
DeleteWebsiteByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteWebsiteByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete website by Id default response has a 2xx status code
func (o *DeleteWebsiteByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete website by Id default response has a 3xx status code
func (o *DeleteWebsiteByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete website by Id default response has a 4xx status code
func (o *DeleteWebsiteByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete website by Id default response has a 5xx status code
func (o *DeleteWebsiteByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete website by Id default response a status code equal to that given
func (o *DeleteWebsiteByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete website by Id default response
func (o *DeleteWebsiteByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteWebsiteByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /website/websites/{id}][%d] deleteWebsiteById default %s", o._statusCode, payload)
}

func (o *DeleteWebsiteByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /website/websites/{id}][%d] deleteWebsiteById default %s", o._statusCode, payload)
}

func (o *DeleteWebsiteByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteWebsiteByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
