// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewDiscoverSubscriptionsParams creates a new DiscoverSubscriptionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDiscoverSubscriptionsParams() *DiscoverSubscriptionsParams {
	return &DiscoverSubscriptionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDiscoverSubscriptionsParamsWithTimeout creates a new DiscoverSubscriptionsParams object
// with the ability to set a timeout on a request.
func NewDiscoverSubscriptionsParamsWithTimeout(timeout time.Duration) *DiscoverSubscriptionsParams {
	return &DiscoverSubscriptionsParams{
		timeout: timeout,
	}
}

// NewDiscoverSubscriptionsParamsWithContext creates a new DiscoverSubscriptionsParams object
// with the ability to set a context for a request.
func NewDiscoverSubscriptionsParamsWithContext(ctx context.Context) *DiscoverSubscriptionsParams {
	return &DiscoverSubscriptionsParams{
		Context: ctx,
	}
}

// NewDiscoverSubscriptionsParamsWithHTTPClient creates a new DiscoverSubscriptionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewDiscoverSubscriptionsParamsWithHTTPClient(client *http.Client) *DiscoverSubscriptionsParams {
	return &DiscoverSubscriptionsParams{
		HTTPClient: client,
	}
}

/*
DiscoverSubscriptionsParams contains all the parameters to send to the API endpoint

	for the discover subscriptions operation.

	Typically these are written to a http.Request.
*/
type DiscoverSubscriptionsParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.RestAzureSubscriptionsDiscoverV3

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the discover subscriptions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DiscoverSubscriptionsParams) WithDefaults() *DiscoverSubscriptionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the discover subscriptions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DiscoverSubscriptionsParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := DiscoverSubscriptionsParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) WithTimeout(timeout time.Duration) *DiscoverSubscriptionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) WithContext(ctx context.Context) *DiscoverSubscriptionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) WithHTTPClient(client *http.Client) *DiscoverSubscriptionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) WithUserAgent(userAgent *string) *DiscoverSubscriptionsParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) WithBody(body *models.RestAzureSubscriptionsDiscoverV3) *DiscoverSubscriptionsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the discover subscriptions params
func (o *DiscoverSubscriptionsParams) SetBody(body *models.RestAzureSubscriptionsDiscoverV3) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *DiscoverSubscriptionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
