// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// FetchReportUsingTaskIDReader is a Reader for the FetchReportUsingTaskID structure.
type FetchReportUsingTaskIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *FetchReportUsingTaskIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewFetchReportUsingTaskIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewFetchReportUsingTaskIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewFetchReportUsingTaskIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewFetchReportUsingTaskIDOK creates a FetchReportUsingTaskIDOK with default headers values
func NewFetchReportUsingTaskIDOK() *FetchReportUsingTaskIDOK {
	return &FetchReportUsingTaskIDOK{}
}

/*
FetchReportUsingTaskIDOK describes a response with status code 200, with default header values.

successful operation
*/
type FetchReportUsingTaskIDOK struct {
	Payload *models.GenerateReportResult
}

// IsSuccess returns true when this fetch report using task Id o k response has a 2xx status code
func (o *FetchReportUsingTaskIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this fetch report using task Id o k response has a 3xx status code
func (o *FetchReportUsingTaskIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this fetch report using task Id o k response has a 4xx status code
func (o *FetchReportUsingTaskIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this fetch report using task Id o k response has a 5xx status code
func (o *FetchReportUsingTaskIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this fetch report using task Id o k response a status code equal to that given
func (o *FetchReportUsingTaskIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the fetch report using task Id o k response
func (o *FetchReportUsingTaskIDOK) Code() int {
	return 200
}

func (o *FetchReportUsingTaskIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports/{id}/tasks/{taskId}][%d] fetchReportUsingTaskIdOK %s", 200, payload)
}

func (o *FetchReportUsingTaskIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports/{id}/tasks/{taskId}][%d] fetchReportUsingTaskIdOK %s", 200, payload)
}

func (o *FetchReportUsingTaskIDOK) GetPayload() *models.GenerateReportResult {
	return o.Payload
}

func (o *FetchReportUsingTaskIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.GenerateReportResult)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewFetchReportUsingTaskIDTooManyRequests creates a FetchReportUsingTaskIDTooManyRequests with default headers values
func NewFetchReportUsingTaskIDTooManyRequests() *FetchReportUsingTaskIDTooManyRequests {
	return &FetchReportUsingTaskIDTooManyRequests{}
}

/*
FetchReportUsingTaskIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type FetchReportUsingTaskIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this fetch report using task Id too many requests response has a 2xx status code
func (o *FetchReportUsingTaskIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this fetch report using task Id too many requests response has a 3xx status code
func (o *FetchReportUsingTaskIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this fetch report using task Id too many requests response has a 4xx status code
func (o *FetchReportUsingTaskIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this fetch report using task Id too many requests response has a 5xx status code
func (o *FetchReportUsingTaskIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this fetch report using task Id too many requests response a status code equal to that given
func (o *FetchReportUsingTaskIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the fetch report using task Id too many requests response
func (o *FetchReportUsingTaskIDTooManyRequests) Code() int {
	return 429
}

func (o *FetchReportUsingTaskIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /report/reports/{id}/tasks/{taskId}][%d] fetchReportUsingTaskIdTooManyRequests", 429)
}

func (o *FetchReportUsingTaskIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /report/reports/{id}/tasks/{taskId}][%d] fetchReportUsingTaskIdTooManyRequests", 429)
}

func (o *FetchReportUsingTaskIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewFetchReportUsingTaskIDDefault creates a FetchReportUsingTaskIDDefault with default headers values
func NewFetchReportUsingTaskIDDefault(code int) *FetchReportUsingTaskIDDefault {
	return &FetchReportUsingTaskIDDefault{
		_statusCode: code,
	}
}

/*
FetchReportUsingTaskIDDefault describes a response with status code -1, with default header values.

Error
*/
type FetchReportUsingTaskIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this fetch report using task Id default response has a 2xx status code
func (o *FetchReportUsingTaskIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this fetch report using task Id default response has a 3xx status code
func (o *FetchReportUsingTaskIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this fetch report using task Id default response has a 4xx status code
func (o *FetchReportUsingTaskIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this fetch report using task Id default response has a 5xx status code
func (o *FetchReportUsingTaskIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this fetch report using task Id default response a status code equal to that given
func (o *FetchReportUsingTaskIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the fetch report using task Id default response
func (o *FetchReportUsingTaskIDDefault) Code() int {
	return o._statusCode
}

func (o *FetchReportUsingTaskIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports/{id}/tasks/{taskId}][%d] fetchReportUsingTaskId default %s", o._statusCode, payload)
}

func (o *FetchReportUsingTaskIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports/{id}/tasks/{taskId}][%d] fetchReportUsingTaskId default %s", o._statusCode, payload)
}

func (o *FetchReportUsingTaskIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *FetchReportUsingTaskIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
