// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GenerateReportByIDReader is a Reader for the GenerateReportByID structure.
type GenerateReportByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GenerateReportByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGenerateReportByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGenerateReportByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGenerateReportByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGenerateReportByIDOK creates a GenerateReportByIDOK with default headers values
func NewGenerateReportByIDOK() *GenerateReportByIDOK {
	return &GenerateReportByIDOK{}
}

/*
GenerateReportByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GenerateReportByIDOK struct {
	Payload *models.GenerateReportResult
}

// IsSuccess returns true when this generate report by Id o k response has a 2xx status code
func (o *GenerateReportByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this generate report by Id o k response has a 3xx status code
func (o *GenerateReportByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this generate report by Id o k response has a 4xx status code
func (o *GenerateReportByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this generate report by Id o k response has a 5xx status code
func (o *GenerateReportByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this generate report by Id o k response a status code equal to that given
func (o *GenerateReportByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the generate report by Id o k response
func (o *GenerateReportByIDOK) Code() int {
	return 200
}

func (o *GenerateReportByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /report/reports/{id}/executions][%d] generateReportByIdOK %s", 200, payload)
}

func (o *GenerateReportByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /report/reports/{id}/executions][%d] generateReportByIdOK %s", 200, payload)
}

func (o *GenerateReportByIDOK) GetPayload() *models.GenerateReportResult {
	return o.Payload
}

func (o *GenerateReportByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.GenerateReportResult)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGenerateReportByIDTooManyRequests creates a GenerateReportByIDTooManyRequests with default headers values
func NewGenerateReportByIDTooManyRequests() *GenerateReportByIDTooManyRequests {
	return &GenerateReportByIDTooManyRequests{}
}

/*
GenerateReportByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GenerateReportByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this generate report by Id too many requests response has a 2xx status code
func (o *GenerateReportByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this generate report by Id too many requests response has a 3xx status code
func (o *GenerateReportByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this generate report by Id too many requests response has a 4xx status code
func (o *GenerateReportByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this generate report by Id too many requests response has a 5xx status code
func (o *GenerateReportByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this generate report by Id too many requests response a status code equal to that given
func (o *GenerateReportByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the generate report by Id too many requests response
func (o *GenerateReportByIDTooManyRequests) Code() int {
	return 429
}

func (o *GenerateReportByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /report/reports/{id}/executions][%d] generateReportByIdTooManyRequests", 429)
}

func (o *GenerateReportByIDTooManyRequests) String() string {
	return fmt.Sprintf("[POST /report/reports/{id}/executions][%d] generateReportByIdTooManyRequests", 429)
}

func (o *GenerateReportByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGenerateReportByIDDefault creates a GenerateReportByIDDefault with default headers values
func NewGenerateReportByIDDefault(code int) *GenerateReportByIDDefault {
	return &GenerateReportByIDDefault{
		_statusCode: code,
	}
}

/*
GenerateReportByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GenerateReportByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this generate report by Id default response has a 2xx status code
func (o *GenerateReportByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this generate report by Id default response has a 3xx status code
func (o *GenerateReportByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this generate report by Id default response has a 4xx status code
func (o *GenerateReportByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this generate report by Id default response has a 5xx status code
func (o *GenerateReportByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this generate report by Id default response a status code equal to that given
func (o *GenerateReportByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the generate report by Id default response
func (o *GenerateReportByIDDefault) Code() int {
	return o._statusCode
}

func (o *GenerateReportByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /report/reports/{id}/executions][%d] generateReportById default %s", o._statusCode, payload)
}

func (o *GenerateReportByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /report/reports/{id}/executions][%d] generateReportById default %s", o._statusCode, payload)
}

func (o *GenerateReportByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GenerateReportByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
