// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAccessGroupByIDReader is a Reader for the GetAccessGroupByID structure.
type GetAccessGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAccessGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAccessGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAccessGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAccessGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAccessGroupByIDOK creates a GetAccessGroupByIDOK with default headers values
func NewGetAccessGroupByIDOK() *GetAccessGroupByIDOK {
	return &GetAccessGroupByIDOK{}
}

/*
GetAccessGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAccessGroupByIDOK struct {
	Payload *models.AccessGroup
}

// IsSuccess returns true when this get access group by Id o k response has a 2xx status code
func (o *GetAccessGroupByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get access group by Id o k response has a 3xx status code
func (o *GetAccessGroupByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get access group by Id o k response has a 4xx status code
func (o *GetAccessGroupByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get access group by Id o k response has a 5xx status code
func (o *GetAccessGroupByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get access group by Id o k response a status code equal to that given
func (o *GetAccessGroupByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get access group by Id o k response
func (o *GetAccessGroupByIDOK) Code() int {
	return 200
}

func (o *GetAccessGroupByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup/{id}][%d] getAccessGroupByIdOK %s", 200, payload)
}

func (o *GetAccessGroupByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup/{id}][%d] getAccessGroupByIdOK %s", 200, payload)
}

func (o *GetAccessGroupByIDOK) GetPayload() *models.AccessGroup {
	return o.Payload
}

func (o *GetAccessGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AccessGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccessGroupByIDTooManyRequests creates a GetAccessGroupByIDTooManyRequests with default headers values
func NewGetAccessGroupByIDTooManyRequests() *GetAccessGroupByIDTooManyRequests {
	return &GetAccessGroupByIDTooManyRequests{}
}

/*
GetAccessGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAccessGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get access group by Id too many requests response has a 2xx status code
func (o *GetAccessGroupByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get access group by Id too many requests response has a 3xx status code
func (o *GetAccessGroupByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get access group by Id too many requests response has a 4xx status code
func (o *GetAccessGroupByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get access group by Id too many requests response has a 5xx status code
func (o *GetAccessGroupByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get access group by Id too many requests response a status code equal to that given
func (o *GetAccessGroupByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get access group by Id too many requests response
func (o *GetAccessGroupByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetAccessGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/accessgroup/{id}][%d] getAccessGroupByIdTooManyRequests", 429)
}

func (o *GetAccessGroupByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/accessgroup/{id}][%d] getAccessGroupByIdTooManyRequests", 429)
}

func (o *GetAccessGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAccessGroupByIDDefault creates a GetAccessGroupByIDDefault with default headers values
func NewGetAccessGroupByIDDefault(code int) *GetAccessGroupByIDDefault {
	return &GetAccessGroupByIDDefault{
		_statusCode: code,
	}
}

/*
GetAccessGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetAccessGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get access group by Id default response has a 2xx status code
func (o *GetAccessGroupByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get access group by Id default response has a 3xx status code
func (o *GetAccessGroupByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get access group by Id default response has a 4xx status code
func (o *GetAccessGroupByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get access group by Id default response has a 5xx status code
func (o *GetAccessGroupByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get access group by Id default response a status code equal to that given
func (o *GetAccessGroupByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get access group by Id default response
func (o *GetAccessGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetAccessGroupByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup/{id}][%d] getAccessGroupById default %s", o._statusCode, payload)
}

func (o *GetAccessGroupByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup/{id}][%d] getAccessGroupById default %s", o._statusCode, payload)
}

func (o *GetAccessGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAccessGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
