// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAdminListJSONReader is a Reader for the GetAdminListJSON structure.
type GetAdminListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAdminListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAdminListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAdminListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAdminListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAdminListJSONOK creates a GetAdminListJSONOK with default headers values
func NewGetAdminListJSONOK() *GetAdminListJSONOK {
	return &GetAdminListJSONOK{}
}

/*
GetAdminListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAdminListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get admin list Json o k response has a 2xx status code
func (o *GetAdminListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get admin list Json o k response has a 3xx status code
func (o *GetAdminListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get admin list Json o k response has a 4xx status code
func (o *GetAdminListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get admin list Json o k response has a 5xx status code
func (o *GetAdminListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get admin list Json o k response a status code equal to that given
func (o *GetAdminListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get admin list Json o k response
func (o *GetAdminListJSONOK) Code() int {
	return 200
}

func (o *GetAdminListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins?__json=][%d] getAdminListJsonOK %s", 200, payload)
}

func (o *GetAdminListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins?__json=][%d] getAdminListJsonOK %s", 200, payload)
}

func (o *GetAdminListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetAdminListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAdminListJSONTooManyRequests creates a GetAdminListJSONTooManyRequests with default headers values
func NewGetAdminListJSONTooManyRequests() *GetAdminListJSONTooManyRequests {
	return &GetAdminListJSONTooManyRequests{}
}

/*
GetAdminListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAdminListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get admin list Json too many requests response has a 2xx status code
func (o *GetAdminListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get admin list Json too many requests response has a 3xx status code
func (o *GetAdminListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get admin list Json too many requests response has a 4xx status code
func (o *GetAdminListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get admin list Json too many requests response has a 5xx status code
func (o *GetAdminListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get admin list Json too many requests response a status code equal to that given
func (o *GetAdminListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get admin list Json too many requests response
func (o *GetAdminListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetAdminListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/admins?__json=][%d] getAdminListJsonTooManyRequests", 429)
}

func (o *GetAdminListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/admins?__json=][%d] getAdminListJsonTooManyRequests", 429)
}

func (o *GetAdminListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAdminListJSONDefault creates a GetAdminListJSONDefault with default headers values
func NewGetAdminListJSONDefault(code int) *GetAdminListJSONDefault {
	return &GetAdminListJSONDefault{
		_statusCode: code,
	}
}

/*
GetAdminListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetAdminListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get admin list Json default response has a 2xx status code
func (o *GetAdminListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get admin list Json default response has a 3xx status code
func (o *GetAdminListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get admin list Json default response has a 4xx status code
func (o *GetAdminListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get admin list Json default response has a 5xx status code
func (o *GetAdminListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get admin list Json default response a status code equal to that given
func (o *GetAdminListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get admin list Json default response
func (o *GetAdminListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetAdminListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins?__json=][%d] getAdminListJson default %s", o._statusCode, payload)
}

func (o *GetAdminListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins?__json=][%d] getAdminListJson default %s", o._statusCode, payload)
}

func (o *GetAdminListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAdminListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
