// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAlertByIDReader is a Reader for the GetAlertByID structure.
type GetAlertByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAlertByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAlertByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAlertByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAlertByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAlertByIDOK creates a GetAlertByIDOK with default headers values
func NewGetAlertByIDOK() *GetAlertByIDOK {
	return &GetAlertByIDOK{}
}

/*
GetAlertByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAlertByIDOK struct {
	Payload *models.Alert
}

// IsSuccess returns true when this get alert by Id o k response has a 2xx status code
func (o *GetAlertByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get alert by Id o k response has a 3xx status code
func (o *GetAlertByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get alert by Id o k response has a 4xx status code
func (o *GetAlertByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get alert by Id o k response has a 5xx status code
func (o *GetAlertByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get alert by Id o k response a status code equal to that given
func (o *GetAlertByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get alert by Id o k response
func (o *GetAlertByIDOK) Code() int {
	return 200
}

func (o *GetAlertByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /alert/alerts/{id}][%d] getAlertByIdOK %s", 200, payload)
}

func (o *GetAlertByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /alert/alerts/{id}][%d] getAlertByIdOK %s", 200, payload)
}

func (o *GetAlertByIDOK) GetPayload() *models.Alert {
	return o.Payload
}

func (o *GetAlertByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Alert)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAlertByIDTooManyRequests creates a GetAlertByIDTooManyRequests with default headers values
func NewGetAlertByIDTooManyRequests() *GetAlertByIDTooManyRequests {
	return &GetAlertByIDTooManyRequests{}
}

/*
GetAlertByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAlertByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get alert by Id too many requests response has a 2xx status code
func (o *GetAlertByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get alert by Id too many requests response has a 3xx status code
func (o *GetAlertByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get alert by Id too many requests response has a 4xx status code
func (o *GetAlertByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get alert by Id too many requests response has a 5xx status code
func (o *GetAlertByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get alert by Id too many requests response a status code equal to that given
func (o *GetAlertByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get alert by Id too many requests response
func (o *GetAlertByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetAlertByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /alert/alerts/{id}][%d] getAlertByIdTooManyRequests", 429)
}

func (o *GetAlertByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /alert/alerts/{id}][%d] getAlertByIdTooManyRequests", 429)
}

func (o *GetAlertByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAlertByIDDefault creates a GetAlertByIDDefault with default headers values
func NewGetAlertByIDDefault(code int) *GetAlertByIDDefault {
	return &GetAlertByIDDefault{
		_statusCode: code,
	}
}

/*
GetAlertByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetAlertByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get alert by Id default response has a 2xx status code
func (o *GetAlertByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get alert by Id default response has a 3xx status code
func (o *GetAlertByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get alert by Id default response has a 4xx status code
func (o *GetAlertByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get alert by Id default response has a 5xx status code
func (o *GetAlertByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get alert by Id default response a status code equal to that given
func (o *GetAlertByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get alert by Id default response
func (o *GetAlertByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetAlertByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /alert/alerts/{id}][%d] getAlertById default %s", o._statusCode, payload)
}

func (o *GetAlertByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /alert/alerts/{id}][%d] getAlertById default %s", o._statusCode, payload)
}

func (o *GetAlertByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAlertByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
