// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAlertListJSONReader is a Reader for the GetAlertListJSON structure.
type GetAlertListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAlertListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAlertListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAlertListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAlertListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAlertListJSONOK creates a GetAlertListJSONOK with default headers values
func NewGetAlertListJSONOK() *GetAlertListJSONOK {
	return &GetAlertListJSONOK{}
}

/*
GetAlertListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAlertListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get alert list Json o k response has a 2xx status code
func (o *GetAlertListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get alert list Json o k response has a 3xx status code
func (o *GetAlertListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get alert list Json o k response has a 4xx status code
func (o *GetAlertListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get alert list Json o k response has a 5xx status code
func (o *GetAlertListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get alert list Json o k response a status code equal to that given
func (o *GetAlertListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get alert list Json o k response
func (o *GetAlertListJSONOK) Code() int {
	return 200
}

func (o *GetAlertListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /alert/alerts?__json=][%d] getAlertListJsonOK %s", 200, payload)
}

func (o *GetAlertListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /alert/alerts?__json=][%d] getAlertListJsonOK %s", 200, payload)
}

func (o *GetAlertListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetAlertListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAlertListJSONTooManyRequests creates a GetAlertListJSONTooManyRequests with default headers values
func NewGetAlertListJSONTooManyRequests() *GetAlertListJSONTooManyRequests {
	return &GetAlertListJSONTooManyRequests{}
}

/*
GetAlertListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAlertListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get alert list Json too many requests response has a 2xx status code
func (o *GetAlertListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get alert list Json too many requests response has a 3xx status code
func (o *GetAlertListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get alert list Json too many requests response has a 4xx status code
func (o *GetAlertListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get alert list Json too many requests response has a 5xx status code
func (o *GetAlertListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get alert list Json too many requests response a status code equal to that given
func (o *GetAlertListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get alert list Json too many requests response
func (o *GetAlertListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetAlertListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /alert/alerts?__json=][%d] getAlertListJsonTooManyRequests", 429)
}

func (o *GetAlertListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /alert/alerts?__json=][%d] getAlertListJsonTooManyRequests", 429)
}

func (o *GetAlertListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAlertListJSONDefault creates a GetAlertListJSONDefault with default headers values
func NewGetAlertListJSONDefault(code int) *GetAlertListJSONDefault {
	return &GetAlertListJSONDefault{
		_statusCode: code,
	}
}

/*
GetAlertListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetAlertListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get alert list Json default response has a 2xx status code
func (o *GetAlertListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get alert list Json default response has a 3xx status code
func (o *GetAlertListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get alert list Json default response has a 4xx status code
func (o *GetAlertListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get alert list Json default response has a 5xx status code
func (o *GetAlertListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get alert list Json default response a status code equal to that given
func (o *GetAlertListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get alert list Json default response
func (o *GetAlertListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetAlertListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /alert/alerts?__json=][%d] getAlertListJson default %s", o._statusCode, payload)
}

func (o *GetAlertListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /alert/alerts?__json=][%d] getAlertListJson default %s", o._statusCode, payload)
}

func (o *GetAlertListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAlertListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
