// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAlertRuleByIDReader is a Reader for the GetAlertRuleByID structure.
type GetAlertRuleByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAlertRuleByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAlertRuleByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAlertRuleByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAlertRuleByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAlertRuleByIDOK creates a GetAlertRuleByIDOK with default headers values
func NewGetAlertRuleByIDOK() *GetAlertRuleByIDOK {
	return &GetAlertRuleByIDOK{}
}

/*
GetAlertRuleByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAlertRuleByIDOK struct {
	Payload *models.AlertRule
}

// IsSuccess returns true when this get alert rule by Id o k response has a 2xx status code
func (o *GetAlertRuleByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get alert rule by Id o k response has a 3xx status code
func (o *GetAlertRuleByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get alert rule by Id o k response has a 4xx status code
func (o *GetAlertRuleByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get alert rule by Id o k response has a 5xx status code
func (o *GetAlertRuleByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get alert rule by Id o k response a status code equal to that given
func (o *GetAlertRuleByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get alert rule by Id o k response
func (o *GetAlertRuleByIDOK) Code() int {
	return 200
}

func (o *GetAlertRuleByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/alert/rules/{id}][%d] getAlertRuleByIdOK %s", 200, payload)
}

func (o *GetAlertRuleByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/alert/rules/{id}][%d] getAlertRuleByIdOK %s", 200, payload)
}

func (o *GetAlertRuleByIDOK) GetPayload() *models.AlertRule {
	return o.Payload
}

func (o *GetAlertRuleByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AlertRule)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAlertRuleByIDTooManyRequests creates a GetAlertRuleByIDTooManyRequests with default headers values
func NewGetAlertRuleByIDTooManyRequests() *GetAlertRuleByIDTooManyRequests {
	return &GetAlertRuleByIDTooManyRequests{}
}

/*
GetAlertRuleByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAlertRuleByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get alert rule by Id too many requests response has a 2xx status code
func (o *GetAlertRuleByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get alert rule by Id too many requests response has a 3xx status code
func (o *GetAlertRuleByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get alert rule by Id too many requests response has a 4xx status code
func (o *GetAlertRuleByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get alert rule by Id too many requests response has a 5xx status code
func (o *GetAlertRuleByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get alert rule by Id too many requests response a status code equal to that given
func (o *GetAlertRuleByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get alert rule by Id too many requests response
func (o *GetAlertRuleByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetAlertRuleByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/alert/rules/{id}][%d] getAlertRuleByIdTooManyRequests", 429)
}

func (o *GetAlertRuleByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/alert/rules/{id}][%d] getAlertRuleByIdTooManyRequests", 429)
}

func (o *GetAlertRuleByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAlertRuleByIDDefault creates a GetAlertRuleByIDDefault with default headers values
func NewGetAlertRuleByIDDefault(code int) *GetAlertRuleByIDDefault {
	return &GetAlertRuleByIDDefault{
		_statusCode: code,
	}
}

/*
GetAlertRuleByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetAlertRuleByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get alert rule by Id default response has a 2xx status code
func (o *GetAlertRuleByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get alert rule by Id default response has a 3xx status code
func (o *GetAlertRuleByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get alert rule by Id default response has a 4xx status code
func (o *GetAlertRuleByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get alert rule by Id default response has a 5xx status code
func (o *GetAlertRuleByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get alert rule by Id default response a status code equal to that given
func (o *GetAlertRuleByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get alert rule by Id default response
func (o *GetAlertRuleByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetAlertRuleByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/alert/rules/{id}][%d] getAlertRuleById default %s", o._statusCode, payload)
}

func (o *GetAlertRuleByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/alert/rules/{id}][%d] getAlertRuleById default %s", o._statusCode, payload)
}

func (o *GetAlertRuleByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAlertRuleByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
