// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAllLogPartitionsReader is a Reader for the GetAllLogPartitions structure.
type GetAllLogPartitionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAllLogPartitionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAllLogPartitionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAllLogPartitionsTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAllLogPartitionsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAllLogPartitionsOK creates a GetAllLogPartitionsOK with default headers values
func NewGetAllLogPartitionsOK() *GetAllLogPartitionsOK {
	return &GetAllLogPartitionsOK{}
}

/*
GetAllLogPartitionsOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAllLogPartitionsOK struct {
	Payload *models.Pagination
}

// IsSuccess returns true when this get all log partitions o k response has a 2xx status code
func (o *GetAllLogPartitionsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get all log partitions o k response has a 3xx status code
func (o *GetAllLogPartitionsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get all log partitions o k response has a 4xx status code
func (o *GetAllLogPartitionsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get all log partitions o k response has a 5xx status code
func (o *GetAllLogPartitionsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get all log partitions o k response a status code equal to that given
func (o *GetAllLogPartitionsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get all log partitions o k response
func (o *GetAllLogPartitionsOK) Code() int {
	return 200
}

func (o *GetAllLogPartitionsOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /log/partitions][%d] getAllLogPartitionsOK %s", 200, payload)
}

func (o *GetAllLogPartitionsOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /log/partitions][%d] getAllLogPartitionsOK %s", 200, payload)
}

func (o *GetAllLogPartitionsOK) GetPayload() *models.Pagination {
	return o.Payload
}

func (o *GetAllLogPartitionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Pagination)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAllLogPartitionsTooManyRequests creates a GetAllLogPartitionsTooManyRequests with default headers values
func NewGetAllLogPartitionsTooManyRequests() *GetAllLogPartitionsTooManyRequests {
	return &GetAllLogPartitionsTooManyRequests{}
}

/*
GetAllLogPartitionsTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAllLogPartitionsTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get all log partitions too many requests response has a 2xx status code
func (o *GetAllLogPartitionsTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get all log partitions too many requests response has a 3xx status code
func (o *GetAllLogPartitionsTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get all log partitions too many requests response has a 4xx status code
func (o *GetAllLogPartitionsTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get all log partitions too many requests response has a 5xx status code
func (o *GetAllLogPartitionsTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get all log partitions too many requests response a status code equal to that given
func (o *GetAllLogPartitionsTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get all log partitions too many requests response
func (o *GetAllLogPartitionsTooManyRequests) Code() int {
	return 429
}

func (o *GetAllLogPartitionsTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /log/partitions][%d] getAllLogPartitionsTooManyRequests", 429)
}

func (o *GetAllLogPartitionsTooManyRequests) String() string {
	return fmt.Sprintf("[GET /log/partitions][%d] getAllLogPartitionsTooManyRequests", 429)
}

func (o *GetAllLogPartitionsTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAllLogPartitionsDefault creates a GetAllLogPartitionsDefault with default headers values
func NewGetAllLogPartitionsDefault(code int) *GetAllLogPartitionsDefault {
	return &GetAllLogPartitionsDefault{
		_statusCode: code,
	}
}

/*
GetAllLogPartitionsDefault describes a response with status code -1, with default header values.

Error
*/
type GetAllLogPartitionsDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get all log partitions default response has a 2xx status code
func (o *GetAllLogPartitionsDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get all log partitions default response has a 3xx status code
func (o *GetAllLogPartitionsDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get all log partitions default response has a 4xx status code
func (o *GetAllLogPartitionsDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get all log partitions default response has a 5xx status code
func (o *GetAllLogPartitionsDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get all log partitions default response a status code equal to that given
func (o *GetAllLogPartitionsDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get all log partitions default response
func (o *GetAllLogPartitionsDefault) Code() int {
	return o._statusCode
}

func (o *GetAllLogPartitionsDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /log/partitions][%d] getAllLogPartitions default %s", o._statusCode, payload)
}

func (o *GetAllLogPartitionsDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /log/partitions][%d] getAllLogPartitions default %s", o._statusCode, payload)
}

func (o *GetAllLogPartitionsDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAllLogPartitionsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
