// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAPITokenListByAdminIDReader is a Reader for the GetAPITokenListByAdminID structure.
type GetAPITokenListByAdminIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAPITokenListByAdminIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAPITokenListByAdminIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAPITokenListByAdminIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAPITokenListByAdminIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAPITokenListByAdminIDOK creates a GetAPITokenListByAdminIDOK with default headers values
func NewGetAPITokenListByAdminIDOK() *GetAPITokenListByAdminIDOK {
	return &GetAPITokenListByAdminIDOK{}
}

/*
GetAPITokenListByAdminIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAPITokenListByAdminIDOK struct {
	Payload *models.APITokenPaginationResponse
}

// IsSuccess returns true when this get Api token list by admin Id o k response has a 2xx status code
func (o *GetAPITokenListByAdminIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get Api token list by admin Id o k response has a 3xx status code
func (o *GetAPITokenListByAdminIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get Api token list by admin Id o k response has a 4xx status code
func (o *GetAPITokenListByAdminIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get Api token list by admin Id o k response has a 5xx status code
func (o *GetAPITokenListByAdminIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get Api token list by admin Id o k response a status code equal to that given
func (o *GetAPITokenListByAdminIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get Api token list by admin Id o k response
func (o *GetAPITokenListByAdminIDOK) Code() int {
	return 200
}

func (o *GetAPITokenListByAdminIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins/{adminId}/apitokens][%d] getApiTokenListByAdminIdOK %s", 200, payload)
}

func (o *GetAPITokenListByAdminIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins/{adminId}/apitokens][%d] getApiTokenListByAdminIdOK %s", 200, payload)
}

func (o *GetAPITokenListByAdminIDOK) GetPayload() *models.APITokenPaginationResponse {
	return o.Payload
}

func (o *GetAPITokenListByAdminIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.APITokenPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAPITokenListByAdminIDTooManyRequests creates a GetAPITokenListByAdminIDTooManyRequests with default headers values
func NewGetAPITokenListByAdminIDTooManyRequests() *GetAPITokenListByAdminIDTooManyRequests {
	return &GetAPITokenListByAdminIDTooManyRequests{}
}

/*
GetAPITokenListByAdminIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAPITokenListByAdminIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get Api token list by admin Id too many requests response has a 2xx status code
func (o *GetAPITokenListByAdminIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get Api token list by admin Id too many requests response has a 3xx status code
func (o *GetAPITokenListByAdminIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get Api token list by admin Id too many requests response has a 4xx status code
func (o *GetAPITokenListByAdminIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get Api token list by admin Id too many requests response has a 5xx status code
func (o *GetAPITokenListByAdminIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get Api token list by admin Id too many requests response a status code equal to that given
func (o *GetAPITokenListByAdminIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get Api token list by admin Id too many requests response
func (o *GetAPITokenListByAdminIDTooManyRequests) Code() int {
	return 429
}

func (o *GetAPITokenListByAdminIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/admins/{adminId}/apitokens][%d] getApiTokenListByAdminIdTooManyRequests", 429)
}

func (o *GetAPITokenListByAdminIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/admins/{adminId}/apitokens][%d] getApiTokenListByAdminIdTooManyRequests", 429)
}

func (o *GetAPITokenListByAdminIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAPITokenListByAdminIDDefault creates a GetAPITokenListByAdminIDDefault with default headers values
func NewGetAPITokenListByAdminIDDefault(code int) *GetAPITokenListByAdminIDDefault {
	return &GetAPITokenListByAdminIDDefault{
		_statusCode: code,
	}
}

/*
GetAPITokenListByAdminIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetAPITokenListByAdminIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get Api token list by admin Id default response has a 2xx status code
func (o *GetAPITokenListByAdminIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get Api token list by admin Id default response has a 3xx status code
func (o *GetAPITokenListByAdminIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get Api token list by admin Id default response has a 4xx status code
func (o *GetAPITokenListByAdminIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get Api token list by admin Id default response has a 5xx status code
func (o *GetAPITokenListByAdminIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get Api token list by admin Id default response a status code equal to that given
func (o *GetAPITokenListByAdminIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get Api token list by admin Id default response
func (o *GetAPITokenListByAdminIDDefault) Code() int {
	return o._statusCode
}

func (o *GetAPITokenListByAdminIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins/{adminId}/apitokens][%d] getApiTokenListByAdminId default %s", o._statusCode, payload)
}

func (o *GetAPITokenListByAdminIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins/{adminId}/apitokens][%d] getApiTokenListByAdminId default %s", o._statusCode, payload)
}

func (o *GetAPITokenListByAdminIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAPITokenListByAdminIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
