// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAuditLogByIDReader is a Reader for the GetAuditLogByID structure.
type GetAuditLogByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAuditLogByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAuditLogByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAuditLogByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAuditLogByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAuditLogByIDOK creates a GetAuditLogByIDOK with default headers values
func NewGetAuditLogByIDOK() *GetAuditLogByIDOK {
	return &GetAuditLogByIDOK{}
}

/*
GetAuditLogByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAuditLogByIDOK struct {
	Payload *models.AuditLog
}

// IsSuccess returns true when this get audit log by Id o k response has a 2xx status code
func (o *GetAuditLogByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get audit log by Id o k response has a 3xx status code
func (o *GetAuditLogByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get audit log by Id o k response has a 4xx status code
func (o *GetAuditLogByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get audit log by Id o k response has a 5xx status code
func (o *GetAuditLogByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get audit log by Id o k response a status code equal to that given
func (o *GetAuditLogByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get audit log by Id o k response
func (o *GetAuditLogByIDOK) Code() int {
	return 200
}

func (o *GetAuditLogByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accesslogs/{id}][%d] getAuditLogByIdOK %s", 200, payload)
}

func (o *GetAuditLogByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accesslogs/{id}][%d] getAuditLogByIdOK %s", 200, payload)
}

func (o *GetAuditLogByIDOK) GetPayload() *models.AuditLog {
	return o.Payload
}

func (o *GetAuditLogByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AuditLog)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAuditLogByIDTooManyRequests creates a GetAuditLogByIDTooManyRequests with default headers values
func NewGetAuditLogByIDTooManyRequests() *GetAuditLogByIDTooManyRequests {
	return &GetAuditLogByIDTooManyRequests{}
}

/*
GetAuditLogByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAuditLogByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get audit log by Id too many requests response has a 2xx status code
func (o *GetAuditLogByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get audit log by Id too many requests response has a 3xx status code
func (o *GetAuditLogByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get audit log by Id too many requests response has a 4xx status code
func (o *GetAuditLogByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get audit log by Id too many requests response has a 5xx status code
func (o *GetAuditLogByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get audit log by Id too many requests response a status code equal to that given
func (o *GetAuditLogByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get audit log by Id too many requests response
func (o *GetAuditLogByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetAuditLogByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/accesslogs/{id}][%d] getAuditLogByIdTooManyRequests", 429)
}

func (o *GetAuditLogByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/accesslogs/{id}][%d] getAuditLogByIdTooManyRequests", 429)
}

func (o *GetAuditLogByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAuditLogByIDDefault creates a GetAuditLogByIDDefault with default headers values
func NewGetAuditLogByIDDefault(code int) *GetAuditLogByIDDefault {
	return &GetAuditLogByIDDefault{
		_statusCode: code,
	}
}

/*
GetAuditLogByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetAuditLogByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get audit log by Id default response has a 2xx status code
func (o *GetAuditLogByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get audit log by Id default response has a 3xx status code
func (o *GetAuditLogByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get audit log by Id default response has a 4xx status code
func (o *GetAuditLogByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get audit log by Id default response has a 5xx status code
func (o *GetAuditLogByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get audit log by Id default response a status code equal to that given
func (o *GetAuditLogByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get audit log by Id default response
func (o *GetAuditLogByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetAuditLogByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accesslogs/{id}][%d] getAuditLogById default %s", o._statusCode, payload)
}

func (o *GetAuditLogByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accesslogs/{id}][%d] getAuditLogById default %s", o._statusCode, payload)
}

func (o *GetAuditLogByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAuditLogByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
