// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAwsAccountIDReader is a Reader for the GetAwsAccountID structure.
type GetAwsAccountIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAwsAccountIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAwsAccountIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAwsAccountIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAwsAccountIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAwsAccountIDOK creates a GetAwsAccountIDOK with default headers values
func NewGetAwsAccountIDOK() *GetAwsAccountIDOK {
	return &GetAwsAccountIDOK{}
}

/*
GetAwsAccountIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAwsAccountIDOK struct {
	Payload *models.AwsAccountID
}

// IsSuccess returns true when this get aws account Id o k response has a 2xx status code
func (o *GetAwsAccountIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get aws account Id o k response has a 3xx status code
func (o *GetAwsAccountIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get aws account Id o k response has a 4xx status code
func (o *GetAwsAccountIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get aws account Id o k response has a 5xx status code
func (o *GetAwsAccountIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get aws account Id o k response a status code equal to that given
func (o *GetAwsAccountIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get aws account Id o k response
func (o *GetAwsAccountIDOK) Code() int {
	return 200
}

func (o *GetAwsAccountIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /aws/accountId][%d] getAwsAccountIdOK %s", 200, payload)
}

func (o *GetAwsAccountIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /aws/accountId][%d] getAwsAccountIdOK %s", 200, payload)
}

func (o *GetAwsAccountIDOK) GetPayload() *models.AwsAccountID {
	return o.Payload
}

func (o *GetAwsAccountIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AwsAccountID)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAwsAccountIDTooManyRequests creates a GetAwsAccountIDTooManyRequests with default headers values
func NewGetAwsAccountIDTooManyRequests() *GetAwsAccountIDTooManyRequests {
	return &GetAwsAccountIDTooManyRequests{}
}

/*
GetAwsAccountIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAwsAccountIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get aws account Id too many requests response has a 2xx status code
func (o *GetAwsAccountIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get aws account Id too many requests response has a 3xx status code
func (o *GetAwsAccountIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get aws account Id too many requests response has a 4xx status code
func (o *GetAwsAccountIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get aws account Id too many requests response has a 5xx status code
func (o *GetAwsAccountIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get aws account Id too many requests response a status code equal to that given
func (o *GetAwsAccountIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get aws account Id too many requests response
func (o *GetAwsAccountIDTooManyRequests) Code() int {
	return 429
}

func (o *GetAwsAccountIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /aws/accountId][%d] getAwsAccountIdTooManyRequests", 429)
}

func (o *GetAwsAccountIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /aws/accountId][%d] getAwsAccountIdTooManyRequests", 429)
}

func (o *GetAwsAccountIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAwsAccountIDDefault creates a GetAwsAccountIDDefault with default headers values
func NewGetAwsAccountIDDefault(code int) *GetAwsAccountIDDefault {
	return &GetAwsAccountIDDefault{
		_statusCode: code,
	}
}

/*
GetAwsAccountIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetAwsAccountIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get aws account Id default response has a 2xx status code
func (o *GetAwsAccountIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get aws account Id default response has a 3xx status code
func (o *GetAwsAccountIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get aws account Id default response has a 4xx status code
func (o *GetAwsAccountIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get aws account Id default response has a 5xx status code
func (o *GetAwsAccountIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get aws account Id default response a status code equal to that given
func (o *GetAwsAccountIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get aws account Id default response
func (o *GetAwsAccountIDDefault) Code() int {
	return o._statusCode
}

func (o *GetAwsAccountIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /aws/accountId][%d] getAwsAccountId default %s", o._statusCode, payload)
}

func (o *GetAwsAccountIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /aws/accountId][%d] getAwsAccountId default %s", o._statusCode, payload)
}

func (o *GetAwsAccountIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAwsAccountIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
