// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetCollectorByIDJSONReader is a Reader for the GetCollectorByIDJSON structure.
type GetCollectorByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCollectorByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCollectorByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetCollectorByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetCollectorByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetCollectorByIDJSONOK creates a GetCollectorByIDJSONOK with default headers values
func NewGetCollectorByIDJSONOK() *GetCollectorByIDJSONOK {
	return &GetCollectorByIDJSONOK{}
}

/*
GetCollectorByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetCollectorByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get collector by Id Json o k response has a 2xx status code
func (o *GetCollectorByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get collector by Id Json o k response has a 3xx status code
func (o *GetCollectorByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get collector by Id Json o k response has a 4xx status code
func (o *GetCollectorByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get collector by Id Json o k response has a 5xx status code
func (o *GetCollectorByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get collector by Id Json o k response a status code equal to that given
func (o *GetCollectorByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get collector by Id Json o k response
func (o *GetCollectorByIDJSONOK) Code() int {
	return 200
}

func (o *GetCollectorByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}?__json=][%d] getCollectorByIdJsonOK %s", 200, payload)
}

func (o *GetCollectorByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}?__json=][%d] getCollectorByIdJsonOK %s", 200, payload)
}

func (o *GetCollectorByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetCollectorByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCollectorByIDJSONTooManyRequests creates a GetCollectorByIDJSONTooManyRequests with default headers values
func NewGetCollectorByIDJSONTooManyRequests() *GetCollectorByIDJSONTooManyRequests {
	return &GetCollectorByIDJSONTooManyRequests{}
}

/*
GetCollectorByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetCollectorByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get collector by Id Json too many requests response has a 2xx status code
func (o *GetCollectorByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get collector by Id Json too many requests response has a 3xx status code
func (o *GetCollectorByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get collector by Id Json too many requests response has a 4xx status code
func (o *GetCollectorByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get collector by Id Json too many requests response has a 5xx status code
func (o *GetCollectorByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get collector by Id Json too many requests response a status code equal to that given
func (o *GetCollectorByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get collector by Id Json too many requests response
func (o *GetCollectorByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetCollectorByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}?__json=][%d] getCollectorByIdJsonTooManyRequests", 429)
}

func (o *GetCollectorByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}?__json=][%d] getCollectorByIdJsonTooManyRequests", 429)
}

func (o *GetCollectorByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetCollectorByIDJSONDefault creates a GetCollectorByIDJSONDefault with default headers values
func NewGetCollectorByIDJSONDefault(code int) *GetCollectorByIDJSONDefault {
	return &GetCollectorByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetCollectorByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetCollectorByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get collector by Id Json default response has a 2xx status code
func (o *GetCollectorByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get collector by Id Json default response has a 3xx status code
func (o *GetCollectorByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get collector by Id Json default response has a 4xx status code
func (o *GetCollectorByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get collector by Id Json default response has a 5xx status code
func (o *GetCollectorByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get collector by Id Json default response a status code equal to that given
func (o *GetCollectorByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get collector by Id Json default response
func (o *GetCollectorByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetCollectorByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}?__json=][%d] getCollectorByIdJson default %s", o._statusCode, payload)
}

func (o *GetCollectorByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}?__json=][%d] getCollectorByIdJson default %s", o._statusCode, payload)
}

func (o *GetCollectorByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetCollectorByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
