// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetCollectorByIDReader is a Reader for the GetCollectorByID structure.
type GetCollectorByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCollectorByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCollectorByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetCollectorByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetCollectorByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetCollectorByIDOK creates a GetCollectorByIDOK with default headers values
func NewGetCollectorByIDOK() *GetCollectorByIDOK {
	return &GetCollectorByIDOK{}
}

/*
GetCollectorByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetCollectorByIDOK struct {
	Payload *models.Collector
}

// IsSuccess returns true when this get collector by Id o k response has a 2xx status code
func (o *GetCollectorByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get collector by Id o k response has a 3xx status code
func (o *GetCollectorByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get collector by Id o k response has a 4xx status code
func (o *GetCollectorByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get collector by Id o k response has a 5xx status code
func (o *GetCollectorByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get collector by Id o k response a status code equal to that given
func (o *GetCollectorByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get collector by Id o k response
func (o *GetCollectorByIDOK) Code() int {
	return 200
}

func (o *GetCollectorByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}][%d] getCollectorByIdOK %s", 200, payload)
}

func (o *GetCollectorByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}][%d] getCollectorByIdOK %s", 200, payload)
}

func (o *GetCollectorByIDOK) GetPayload() *models.Collector {
	return o.Payload
}

func (o *GetCollectorByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Collector)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCollectorByIDTooManyRequests creates a GetCollectorByIDTooManyRequests with default headers values
func NewGetCollectorByIDTooManyRequests() *GetCollectorByIDTooManyRequests {
	return &GetCollectorByIDTooManyRequests{}
}

/*
GetCollectorByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetCollectorByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get collector by Id too many requests response has a 2xx status code
func (o *GetCollectorByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get collector by Id too many requests response has a 3xx status code
func (o *GetCollectorByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get collector by Id too many requests response has a 4xx status code
func (o *GetCollectorByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get collector by Id too many requests response has a 5xx status code
func (o *GetCollectorByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get collector by Id too many requests response a status code equal to that given
func (o *GetCollectorByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get collector by Id too many requests response
func (o *GetCollectorByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetCollectorByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}][%d] getCollectorByIdTooManyRequests", 429)
}

func (o *GetCollectorByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}][%d] getCollectorByIdTooManyRequests", 429)
}

func (o *GetCollectorByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetCollectorByIDDefault creates a GetCollectorByIDDefault with default headers values
func NewGetCollectorByIDDefault(code int) *GetCollectorByIDDefault {
	return &GetCollectorByIDDefault{
		_statusCode: code,
	}
}

/*
GetCollectorByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetCollectorByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get collector by Id default response has a 2xx status code
func (o *GetCollectorByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get collector by Id default response has a 3xx status code
func (o *GetCollectorByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get collector by Id default response has a 4xx status code
func (o *GetCollectorByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get collector by Id default response has a 5xx status code
func (o *GetCollectorByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get collector by Id default response a status code equal to that given
func (o *GetCollectorByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get collector by Id default response
func (o *GetCollectorByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetCollectorByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}][%d] getCollectorById default %s", o._statusCode, payload)
}

func (o *GetCollectorByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{id}][%d] getCollectorById default %s", o._statusCode, payload)
}

func (o *GetCollectorByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetCollectorByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
