// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetCollectorGroupListReader is a Reader for the GetCollectorGroupList structure.
type GetCollectorGroupListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCollectorGroupListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCollectorGroupListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetCollectorGroupListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetCollectorGroupListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetCollectorGroupListOK creates a GetCollectorGroupListOK with default headers values
func NewGetCollectorGroupListOK() *GetCollectorGroupListOK {
	return &GetCollectorGroupListOK{}
}

/*
GetCollectorGroupListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetCollectorGroupListOK struct {
	Payload *models.CollectorGroupPaginationResponse
}

// IsSuccess returns true when this get collector group list o k response has a 2xx status code
func (o *GetCollectorGroupListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get collector group list o k response has a 3xx status code
func (o *GetCollectorGroupListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get collector group list o k response has a 4xx status code
func (o *GetCollectorGroupListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get collector group list o k response has a 5xx status code
func (o *GetCollectorGroupListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get collector group list o k response a status code equal to that given
func (o *GetCollectorGroupListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get collector group list o k response
func (o *GetCollectorGroupListOK) Code() int {
	return 200
}

func (o *GetCollectorGroupListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/groups][%d] getCollectorGroupListOK %s", 200, payload)
}

func (o *GetCollectorGroupListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/groups][%d] getCollectorGroupListOK %s", 200, payload)
}

func (o *GetCollectorGroupListOK) GetPayload() *models.CollectorGroupPaginationResponse {
	return o.Payload
}

func (o *GetCollectorGroupListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.CollectorGroupPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCollectorGroupListTooManyRequests creates a GetCollectorGroupListTooManyRequests with default headers values
func NewGetCollectorGroupListTooManyRequests() *GetCollectorGroupListTooManyRequests {
	return &GetCollectorGroupListTooManyRequests{}
}

/*
GetCollectorGroupListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetCollectorGroupListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get collector group list too many requests response has a 2xx status code
func (o *GetCollectorGroupListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get collector group list too many requests response has a 3xx status code
func (o *GetCollectorGroupListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get collector group list too many requests response has a 4xx status code
func (o *GetCollectorGroupListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get collector group list too many requests response has a 5xx status code
func (o *GetCollectorGroupListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get collector group list too many requests response a status code equal to that given
func (o *GetCollectorGroupListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get collector group list too many requests response
func (o *GetCollectorGroupListTooManyRequests) Code() int {
	return 429
}

func (o *GetCollectorGroupListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/collector/groups][%d] getCollectorGroupListTooManyRequests", 429)
}

func (o *GetCollectorGroupListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/collector/groups][%d] getCollectorGroupListTooManyRequests", 429)
}

func (o *GetCollectorGroupListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetCollectorGroupListDefault creates a GetCollectorGroupListDefault with default headers values
func NewGetCollectorGroupListDefault(code int) *GetCollectorGroupListDefault {
	return &GetCollectorGroupListDefault{
		_statusCode: code,
	}
}

/*
GetCollectorGroupListDefault describes a response with status code -1, with default header values.

Error
*/
type GetCollectorGroupListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get collector group list default response has a 2xx status code
func (o *GetCollectorGroupListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get collector group list default response has a 3xx status code
func (o *GetCollectorGroupListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get collector group list default response has a 4xx status code
func (o *GetCollectorGroupListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get collector group list default response has a 5xx status code
func (o *GetCollectorGroupListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get collector group list default response a status code equal to that given
func (o *GetCollectorGroupListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get collector group list default response
func (o *GetCollectorGroupListDefault) Code() int {
	return o._statusCode
}

func (o *GetCollectorGroupListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/groups][%d] getCollectorGroupList default %s", o._statusCode, payload)
}

func (o *GetCollectorGroupListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/groups][%d] getCollectorGroupList default %s", o._statusCode, payload)
}

func (o *GetCollectorGroupListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetCollectorGroupListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
