// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetConfigSourceByIDReader is a Reader for the GetConfigSourceByID structure.
type GetConfigSourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetConfigSourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetConfigSourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetConfigSourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetConfigSourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetConfigSourceByIDOK creates a GetConfigSourceByIDOK with default headers values
func NewGetConfigSourceByIDOK() *GetConfigSourceByIDOK {
	return &GetConfigSourceByIDOK{}
}

/*
GetConfigSourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetConfigSourceByIDOK struct {
	Payload *models.ConfigSource
}

// IsSuccess returns true when this get config source by Id o k response has a 2xx status code
func (o *GetConfigSourceByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get config source by Id o k response has a 3xx status code
func (o *GetConfigSourceByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get config source by Id o k response has a 4xx status code
func (o *GetConfigSourceByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get config source by Id o k response has a 5xx status code
func (o *GetConfigSourceByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get config source by Id o k response a status code equal to that given
func (o *GetConfigSourceByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get config source by Id o k response
func (o *GetConfigSourceByIDOK) Code() int {
	return 200
}

func (o *GetConfigSourceByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/configsources/{id}][%d] getConfigSourceByIdOK %s", 200, payload)
}

func (o *GetConfigSourceByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/configsources/{id}][%d] getConfigSourceByIdOK %s", 200, payload)
}

func (o *GetConfigSourceByIDOK) GetPayload() *models.ConfigSource {
	return o.Payload
}

func (o *GetConfigSourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ConfigSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetConfigSourceByIDTooManyRequests creates a GetConfigSourceByIDTooManyRequests with default headers values
func NewGetConfigSourceByIDTooManyRequests() *GetConfigSourceByIDTooManyRequests {
	return &GetConfigSourceByIDTooManyRequests{}
}

/*
GetConfigSourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetConfigSourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get config source by Id too many requests response has a 2xx status code
func (o *GetConfigSourceByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get config source by Id too many requests response has a 3xx status code
func (o *GetConfigSourceByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get config source by Id too many requests response has a 4xx status code
func (o *GetConfigSourceByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get config source by Id too many requests response has a 5xx status code
func (o *GetConfigSourceByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get config source by Id too many requests response a status code equal to that given
func (o *GetConfigSourceByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get config source by Id too many requests response
func (o *GetConfigSourceByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetConfigSourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/configsources/{id}][%d] getConfigSourceByIdTooManyRequests", 429)
}

func (o *GetConfigSourceByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/configsources/{id}][%d] getConfigSourceByIdTooManyRequests", 429)
}

func (o *GetConfigSourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetConfigSourceByIDDefault creates a GetConfigSourceByIDDefault with default headers values
func NewGetConfigSourceByIDDefault(code int) *GetConfigSourceByIDDefault {
	return &GetConfigSourceByIDDefault{
		_statusCode: code,
	}
}

/*
GetConfigSourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetConfigSourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get config source by Id default response has a 2xx status code
func (o *GetConfigSourceByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get config source by Id default response has a 3xx status code
func (o *GetConfigSourceByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get config source by Id default response has a 4xx status code
func (o *GetConfigSourceByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get config source by Id default response has a 5xx status code
func (o *GetConfigSourceByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get config source by Id default response a status code equal to that given
func (o *GetConfigSourceByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get config source by Id default response
func (o *GetConfigSourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetConfigSourceByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/configsources/{id}][%d] getConfigSourceById default %s", o._statusCode, payload)
}

func (o *GetConfigSourceByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/configsources/{id}][%d] getConfigSourceById default %s", o._statusCode, payload)
}

func (o *GetConfigSourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetConfigSourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
