// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetContractInfoByCompanyReader is a Reader for the GetContractInfoByCompany structure.
type GetContractInfoByCompanyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetContractInfoByCompanyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetContractInfoByCompanyOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetContractInfoByCompanyTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetContractInfoByCompanyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetContractInfoByCompanyOK creates a GetContractInfoByCompanyOK with default headers values
func NewGetContractInfoByCompanyOK() *GetContractInfoByCompanyOK {
	return &GetContractInfoByCompanyOK{}
}

/*
GetContractInfoByCompanyOK describes a response with status code 200, with default header values.

successful operation
*/
type GetContractInfoByCompanyOK struct {
	Payload *models.RestContractInfoBaseV3
}

// IsSuccess returns true when this get contract info by company o k response has a 2xx status code
func (o *GetContractInfoByCompanyOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get contract info by company o k response has a 3xx status code
func (o *GetContractInfoByCompanyOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contract info by company o k response has a 4xx status code
func (o *GetContractInfoByCompanyOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get contract info by company o k response has a 5xx status code
func (o *GetContractInfoByCompanyOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get contract info by company o k response a status code equal to that given
func (o *GetContractInfoByCompanyOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get contract info by company o k response
func (o *GetContractInfoByCompanyOK) Code() int {
	return 200
}

func (o *GetContractInfoByCompanyOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /usage/contractInfo][%d] getContractInfoByCompanyOK %s", 200, payload)
}

func (o *GetContractInfoByCompanyOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /usage/contractInfo][%d] getContractInfoByCompanyOK %s", 200, payload)
}

func (o *GetContractInfoByCompanyOK) GetPayload() *models.RestContractInfoBaseV3 {
	return o.Payload
}

func (o *GetContractInfoByCompanyOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RestContractInfoBaseV3)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContractInfoByCompanyTooManyRequests creates a GetContractInfoByCompanyTooManyRequests with default headers values
func NewGetContractInfoByCompanyTooManyRequests() *GetContractInfoByCompanyTooManyRequests {
	return &GetContractInfoByCompanyTooManyRequests{}
}

/*
GetContractInfoByCompanyTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetContractInfoByCompanyTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get contract info by company too many requests response has a 2xx status code
func (o *GetContractInfoByCompanyTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contract info by company too many requests response has a 3xx status code
func (o *GetContractInfoByCompanyTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contract info by company too many requests response has a 4xx status code
func (o *GetContractInfoByCompanyTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get contract info by company too many requests response has a 5xx status code
func (o *GetContractInfoByCompanyTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get contract info by company too many requests response a status code equal to that given
func (o *GetContractInfoByCompanyTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get contract info by company too many requests response
func (o *GetContractInfoByCompanyTooManyRequests) Code() int {
	return 429
}

func (o *GetContractInfoByCompanyTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /usage/contractInfo][%d] getContractInfoByCompanyTooManyRequests", 429)
}

func (o *GetContractInfoByCompanyTooManyRequests) String() string {
	return fmt.Sprintf("[GET /usage/contractInfo][%d] getContractInfoByCompanyTooManyRequests", 429)
}

func (o *GetContractInfoByCompanyTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetContractInfoByCompanyDefault creates a GetContractInfoByCompanyDefault with default headers values
func NewGetContractInfoByCompanyDefault(code int) *GetContractInfoByCompanyDefault {
	return &GetContractInfoByCompanyDefault{
		_statusCode: code,
	}
}

/*
GetContractInfoByCompanyDefault describes a response with status code -1, with default header values.

Error
*/
type GetContractInfoByCompanyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get contract info by company default response has a 2xx status code
func (o *GetContractInfoByCompanyDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get contract info by company default response has a 3xx status code
func (o *GetContractInfoByCompanyDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get contract info by company default response has a 4xx status code
func (o *GetContractInfoByCompanyDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get contract info by company default response has a 5xx status code
func (o *GetContractInfoByCompanyDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get contract info by company default response a status code equal to that given
func (o *GetContractInfoByCompanyDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get contract info by company default response
func (o *GetContractInfoByCompanyDefault) Code() int {
	return o._statusCode
}

func (o *GetContractInfoByCompanyDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /usage/contractInfo][%d] getContractInfoByCompany default %s", o._statusCode, payload)
}

func (o *GetContractInfoByCompanyDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /usage/contractInfo][%d] getContractInfoByCompany default %s", o._statusCode, payload)
}

func (o *GetContractInfoByCompanyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetContractInfoByCompanyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
