// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDashboardByIDJSONReader is a Reader for the GetDashboardByIDJSON structure.
type GetDashboardByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDashboardByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDashboardByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDashboardByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDashboardByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDashboardByIDJSONOK creates a GetDashboardByIDJSONOK with default headers values
func NewGetDashboardByIDJSONOK() *GetDashboardByIDJSONOK {
	return &GetDashboardByIDJSONOK{}
}

/*
GetDashboardByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDashboardByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get dashboard by Id Json o k response has a 2xx status code
func (o *GetDashboardByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get dashboard by Id Json o k response has a 3xx status code
func (o *GetDashboardByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get dashboard by Id Json o k response has a 4xx status code
func (o *GetDashboardByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get dashboard by Id Json o k response has a 5xx status code
func (o *GetDashboardByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get dashboard by Id Json o k response a status code equal to that given
func (o *GetDashboardByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get dashboard by Id Json o k response
func (o *GetDashboardByIDJSONOK) Code() int {
	return 200
}

func (o *GetDashboardByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/dashboards/{id}?__json=][%d] getDashboardByIdJsonOK %s", 200, payload)
}

func (o *GetDashboardByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/dashboards/{id}?__json=][%d] getDashboardByIdJsonOK %s", 200, payload)
}

func (o *GetDashboardByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDashboardByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDashboardByIDJSONTooManyRequests creates a GetDashboardByIDJSONTooManyRequests with default headers values
func NewGetDashboardByIDJSONTooManyRequests() *GetDashboardByIDJSONTooManyRequests {
	return &GetDashboardByIDJSONTooManyRequests{}
}

/*
GetDashboardByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDashboardByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get dashboard by Id Json too many requests response has a 2xx status code
func (o *GetDashboardByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get dashboard by Id Json too many requests response has a 3xx status code
func (o *GetDashboardByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get dashboard by Id Json too many requests response has a 4xx status code
func (o *GetDashboardByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get dashboard by Id Json too many requests response has a 5xx status code
func (o *GetDashboardByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get dashboard by Id Json too many requests response a status code equal to that given
func (o *GetDashboardByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get dashboard by Id Json too many requests response
func (o *GetDashboardByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetDashboardByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /dashboard/dashboards/{id}?__json=][%d] getDashboardByIdJsonTooManyRequests", 429)
}

func (o *GetDashboardByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /dashboard/dashboards/{id}?__json=][%d] getDashboardByIdJsonTooManyRequests", 429)
}

func (o *GetDashboardByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDashboardByIDJSONDefault creates a GetDashboardByIDJSONDefault with default headers values
func NewGetDashboardByIDJSONDefault(code int) *GetDashboardByIDJSONDefault {
	return &GetDashboardByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetDashboardByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDashboardByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get dashboard by Id Json default response has a 2xx status code
func (o *GetDashboardByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get dashboard by Id Json default response has a 3xx status code
func (o *GetDashboardByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get dashboard by Id Json default response has a 4xx status code
func (o *GetDashboardByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get dashboard by Id Json default response has a 5xx status code
func (o *GetDashboardByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get dashboard by Id Json default response a status code equal to that given
func (o *GetDashboardByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get dashboard by Id Json default response
func (o *GetDashboardByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDashboardByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/dashboards/{id}?__json=][%d] getDashboardByIdJson default %s", o._statusCode, payload)
}

func (o *GetDashboardByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/dashboards/{id}?__json=][%d] getDashboardByIdJson default %s", o._statusCode, payload)
}

func (o *GetDashboardByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDashboardByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
