// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDashboardGroupListReader is a Reader for the GetDashboardGroupList structure.
type GetDashboardGroupListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDashboardGroupListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDashboardGroupListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDashboardGroupListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDashboardGroupListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDashboardGroupListOK creates a GetDashboardGroupListOK with default headers values
func NewGetDashboardGroupListOK() *GetDashboardGroupListOK {
	return &GetDashboardGroupListOK{}
}

/*
GetDashboardGroupListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDashboardGroupListOK struct {
	Payload *models.DashboardGroupPaginationResponse
}

// IsSuccess returns true when this get dashboard group list o k response has a 2xx status code
func (o *GetDashboardGroupListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get dashboard group list o k response has a 3xx status code
func (o *GetDashboardGroupListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get dashboard group list o k response has a 4xx status code
func (o *GetDashboardGroupListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get dashboard group list o k response has a 5xx status code
func (o *GetDashboardGroupListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get dashboard group list o k response a status code equal to that given
func (o *GetDashboardGroupListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get dashboard group list o k response
func (o *GetDashboardGroupListOK) Code() int {
	return 200
}

func (o *GetDashboardGroupListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/groups][%d] getDashboardGroupListOK %s", 200, payload)
}

func (o *GetDashboardGroupListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/groups][%d] getDashboardGroupListOK %s", 200, payload)
}

func (o *GetDashboardGroupListOK) GetPayload() *models.DashboardGroupPaginationResponse {
	return o.Payload
}

func (o *GetDashboardGroupListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DashboardGroupPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDashboardGroupListTooManyRequests creates a GetDashboardGroupListTooManyRequests with default headers values
func NewGetDashboardGroupListTooManyRequests() *GetDashboardGroupListTooManyRequests {
	return &GetDashboardGroupListTooManyRequests{}
}

/*
GetDashboardGroupListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDashboardGroupListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get dashboard group list too many requests response has a 2xx status code
func (o *GetDashboardGroupListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get dashboard group list too many requests response has a 3xx status code
func (o *GetDashboardGroupListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get dashboard group list too many requests response has a 4xx status code
func (o *GetDashboardGroupListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get dashboard group list too many requests response has a 5xx status code
func (o *GetDashboardGroupListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get dashboard group list too many requests response a status code equal to that given
func (o *GetDashboardGroupListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get dashboard group list too many requests response
func (o *GetDashboardGroupListTooManyRequests) Code() int {
	return 429
}

func (o *GetDashboardGroupListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /dashboard/groups][%d] getDashboardGroupListTooManyRequests", 429)
}

func (o *GetDashboardGroupListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /dashboard/groups][%d] getDashboardGroupListTooManyRequests", 429)
}

func (o *GetDashboardGroupListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDashboardGroupListDefault creates a GetDashboardGroupListDefault with default headers values
func NewGetDashboardGroupListDefault(code int) *GetDashboardGroupListDefault {
	return &GetDashboardGroupListDefault{
		_statusCode: code,
	}
}

/*
GetDashboardGroupListDefault describes a response with status code -1, with default header values.

Error
*/
type GetDashboardGroupListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get dashboard group list default response has a 2xx status code
func (o *GetDashboardGroupListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get dashboard group list default response has a 3xx status code
func (o *GetDashboardGroupListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get dashboard group list default response has a 4xx status code
func (o *GetDashboardGroupListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get dashboard group list default response has a 5xx status code
func (o *GetDashboardGroupListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get dashboard group list default response a status code equal to that given
func (o *GetDashboardGroupListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get dashboard group list default response
func (o *GetDashboardGroupListDefault) Code() int {
	return o._statusCode
}

func (o *GetDashboardGroupListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/groups][%d] getDashboardGroupList default %s", o._statusCode, payload)
}

func (o *GetDashboardGroupListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/groups][%d] getDashboardGroupList default %s", o._statusCode, payload)
}

func (o *GetDashboardGroupListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDashboardGroupListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
