// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDashboardListReader is a Reader for the GetDashboardList structure.
type GetDashboardListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDashboardListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDashboardListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDashboardListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDashboardListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDashboardListOK creates a GetDashboardListOK with default headers values
func NewGetDashboardListOK() *GetDashboardListOK {
	return &GetDashboardListOK{}
}

/*
GetDashboardListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDashboardListOK struct {
	Payload *models.DashboardPaginationResponse
}

// IsSuccess returns true when this get dashboard list o k response has a 2xx status code
func (o *GetDashboardListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get dashboard list o k response has a 3xx status code
func (o *GetDashboardListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get dashboard list o k response has a 4xx status code
func (o *GetDashboardListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get dashboard list o k response has a 5xx status code
func (o *GetDashboardListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get dashboard list o k response a status code equal to that given
func (o *GetDashboardListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get dashboard list o k response
func (o *GetDashboardListOK) Code() int {
	return 200
}

func (o *GetDashboardListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/dashboards][%d] getDashboardListOK %s", 200, payload)
}

func (o *GetDashboardListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/dashboards][%d] getDashboardListOK %s", 200, payload)
}

func (o *GetDashboardListOK) GetPayload() *models.DashboardPaginationResponse {
	return o.Payload
}

func (o *GetDashboardListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DashboardPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDashboardListTooManyRequests creates a GetDashboardListTooManyRequests with default headers values
func NewGetDashboardListTooManyRequests() *GetDashboardListTooManyRequests {
	return &GetDashboardListTooManyRequests{}
}

/*
GetDashboardListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDashboardListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get dashboard list too many requests response has a 2xx status code
func (o *GetDashboardListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get dashboard list too many requests response has a 3xx status code
func (o *GetDashboardListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get dashboard list too many requests response has a 4xx status code
func (o *GetDashboardListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get dashboard list too many requests response has a 5xx status code
func (o *GetDashboardListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get dashboard list too many requests response a status code equal to that given
func (o *GetDashboardListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get dashboard list too many requests response
func (o *GetDashboardListTooManyRequests) Code() int {
	return 429
}

func (o *GetDashboardListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /dashboard/dashboards][%d] getDashboardListTooManyRequests", 429)
}

func (o *GetDashboardListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /dashboard/dashboards][%d] getDashboardListTooManyRequests", 429)
}

func (o *GetDashboardListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDashboardListDefault creates a GetDashboardListDefault with default headers values
func NewGetDashboardListDefault(code int) *GetDashboardListDefault {
	return &GetDashboardListDefault{
		_statusCode: code,
	}
}

/*
GetDashboardListDefault describes a response with status code -1, with default header values.

Error
*/
type GetDashboardListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get dashboard list default response has a 2xx status code
func (o *GetDashboardListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get dashboard list default response has a 3xx status code
func (o *GetDashboardListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get dashboard list default response has a 4xx status code
func (o *GetDashboardListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get dashboard list default response has a 5xx status code
func (o *GetDashboardListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get dashboard list default response a status code equal to that given
func (o *GetDashboardListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get dashboard list default response
func (o *GetDashboardListDefault) Code() int {
	return o._statusCode
}

func (o *GetDashboardListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/dashboards][%d] getDashboardList default %s", o._statusCode, payload)
}

func (o *GetDashboardListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/dashboards][%d] getDashboardList default %s", o._statusCode, payload)
}

func (o *GetDashboardListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDashboardListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
