// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDatasourceListJSONReader is a Reader for the GetDatasourceListJSON structure.
type GetDatasourceListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDatasourceListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDatasourceListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDatasourceListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDatasourceListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDatasourceListJSONOK creates a GetDatasourceListJSONOK with default headers values
func NewGetDatasourceListJSONOK() *GetDatasourceListJSONOK {
	return &GetDatasourceListJSONOK{}
}

/*
GetDatasourceListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDatasourceListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get datasource list Json o k response has a 2xx status code
func (o *GetDatasourceListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get datasource list Json o k response has a 3xx status code
func (o *GetDatasourceListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get datasource list Json o k response has a 4xx status code
func (o *GetDatasourceListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get datasource list Json o k response has a 5xx status code
func (o *GetDatasourceListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get datasource list Json o k response a status code equal to that given
func (o *GetDatasourceListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get datasource list Json o k response
func (o *GetDatasourceListJSONOK) Code() int {
	return 200
}

func (o *GetDatasourceListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources?__json=][%d] getDatasourceListJsonOK %s", 200, payload)
}

func (o *GetDatasourceListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources?__json=][%d] getDatasourceListJsonOK %s", 200, payload)
}

func (o *GetDatasourceListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDatasourceListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatasourceListJSONTooManyRequests creates a GetDatasourceListJSONTooManyRequests with default headers values
func NewGetDatasourceListJSONTooManyRequests() *GetDatasourceListJSONTooManyRequests {
	return &GetDatasourceListJSONTooManyRequests{}
}

/*
GetDatasourceListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDatasourceListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get datasource list Json too many requests response has a 2xx status code
func (o *GetDatasourceListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get datasource list Json too many requests response has a 3xx status code
func (o *GetDatasourceListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get datasource list Json too many requests response has a 4xx status code
func (o *GetDatasourceListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get datasource list Json too many requests response has a 5xx status code
func (o *GetDatasourceListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get datasource list Json too many requests response a status code equal to that given
func (o *GetDatasourceListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get datasource list Json too many requests response
func (o *GetDatasourceListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetDatasourceListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/datasources?__json=][%d] getDatasourceListJsonTooManyRequests", 429)
}

func (o *GetDatasourceListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/datasources?__json=][%d] getDatasourceListJsonTooManyRequests", 429)
}

func (o *GetDatasourceListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDatasourceListJSONDefault creates a GetDatasourceListJSONDefault with default headers values
func NewGetDatasourceListJSONDefault(code int) *GetDatasourceListJSONDefault {
	return &GetDatasourceListJSONDefault{
		_statusCode: code,
	}
}

/*
GetDatasourceListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDatasourceListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get datasource list Json default response has a 2xx status code
func (o *GetDatasourceListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get datasource list Json default response has a 3xx status code
func (o *GetDatasourceListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get datasource list Json default response has a 4xx status code
func (o *GetDatasourceListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get datasource list Json default response has a 5xx status code
func (o *GetDatasourceListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get datasource list Json default response a status code equal to that given
func (o *GetDatasourceListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get datasource list Json default response
func (o *GetDatasourceListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDatasourceListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources?__json=][%d] getDatasourceListJson default %s", o._statusCode, payload)
}

func (o *GetDatasourceListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources?__json=][%d] getDatasourceListJson default %s", o._statusCode, payload)
}

func (o *GetDatasourceListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDatasourceListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
