// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDatasourceListReader is a Reader for the GetDatasourceList structure.
type GetDatasourceListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDatasourceListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDatasourceListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDatasourceListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDatasourceListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDatasourceListOK creates a GetDatasourceListOK with default headers values
func NewGetDatasourceListOK() *GetDatasourceListOK {
	return &GetDatasourceListOK{}
}

/*
GetDatasourceListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDatasourceListOK struct {
	Payload *models.DatasourcePaginationResponse
}

// IsSuccess returns true when this get datasource list o k response has a 2xx status code
func (o *GetDatasourceListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get datasource list o k response has a 3xx status code
func (o *GetDatasourceListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get datasource list o k response has a 4xx status code
func (o *GetDatasourceListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get datasource list o k response has a 5xx status code
func (o *GetDatasourceListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get datasource list o k response a status code equal to that given
func (o *GetDatasourceListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get datasource list o k response
func (o *GetDatasourceListOK) Code() int {
	return 200
}

func (o *GetDatasourceListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources][%d] getDatasourceListOK %s", 200, payload)
}

func (o *GetDatasourceListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources][%d] getDatasourceListOK %s", 200, payload)
}

func (o *GetDatasourceListOK) GetPayload() *models.DatasourcePaginationResponse {
	return o.Payload
}

func (o *GetDatasourceListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DatasourcePaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatasourceListTooManyRequests creates a GetDatasourceListTooManyRequests with default headers values
func NewGetDatasourceListTooManyRequests() *GetDatasourceListTooManyRequests {
	return &GetDatasourceListTooManyRequests{}
}

/*
GetDatasourceListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDatasourceListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get datasource list too many requests response has a 2xx status code
func (o *GetDatasourceListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get datasource list too many requests response has a 3xx status code
func (o *GetDatasourceListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get datasource list too many requests response has a 4xx status code
func (o *GetDatasourceListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get datasource list too many requests response has a 5xx status code
func (o *GetDatasourceListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get datasource list too many requests response a status code equal to that given
func (o *GetDatasourceListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get datasource list too many requests response
func (o *GetDatasourceListTooManyRequests) Code() int {
	return 429
}

func (o *GetDatasourceListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/datasources][%d] getDatasourceListTooManyRequests", 429)
}

func (o *GetDatasourceListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/datasources][%d] getDatasourceListTooManyRequests", 429)
}

func (o *GetDatasourceListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDatasourceListDefault creates a GetDatasourceListDefault with default headers values
func NewGetDatasourceListDefault(code int) *GetDatasourceListDefault {
	return &GetDatasourceListDefault{
		_statusCode: code,
	}
}

/*
GetDatasourceListDefault describes a response with status code -1, with default header values.

Error
*/
type GetDatasourceListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get datasource list default response has a 2xx status code
func (o *GetDatasourceListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get datasource list default response has a 3xx status code
func (o *GetDatasourceListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get datasource list default response has a 4xx status code
func (o *GetDatasourceListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get datasource list default response has a 5xx status code
func (o *GetDatasourceListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get datasource list default response a status code equal to that given
func (o *GetDatasourceListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get datasource list default response
func (o *GetDatasourceListDefault) Code() int {
	return o._statusCode
}

func (o *GetDatasourceListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources][%d] getDatasourceList default %s", o._statusCode, payload)
}

func (o *GetDatasourceListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources][%d] getDatasourceList default %s", o._statusCode, payload)
}

func (o *GetDatasourceListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDatasourceListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
