// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDebugCommandResultJSONReader is a Reader for the GetDebugCommandResultJSON structure.
type GetDebugCommandResultJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDebugCommandResultJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDebugCommandResultJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDebugCommandResultJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDebugCommandResultJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDebugCommandResultJSONOK creates a GetDebugCommandResultJSONOK with default headers values
func NewGetDebugCommandResultJSONOK() *GetDebugCommandResultJSONOK {
	return &GetDebugCommandResultJSONOK{}
}

/*
GetDebugCommandResultJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDebugCommandResultJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get debug command result Json o k response has a 2xx status code
func (o *GetDebugCommandResultJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get debug command result Json o k response has a 3xx status code
func (o *GetDebugCommandResultJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get debug command result Json o k response has a 4xx status code
func (o *GetDebugCommandResultJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get debug command result Json o k response has a 5xx status code
func (o *GetDebugCommandResultJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get debug command result Json o k response a status code equal to that given
func (o *GetDebugCommandResultJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get debug command result Json o k response
func (o *GetDebugCommandResultJSONOK) Code() int {
	return 200
}

func (o *GetDebugCommandResultJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /debug/{id}?__json=][%d] getDebugCommandResultJsonOK %s", 200, payload)
}

func (o *GetDebugCommandResultJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /debug/{id}?__json=][%d] getDebugCommandResultJsonOK %s", 200, payload)
}

func (o *GetDebugCommandResultJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDebugCommandResultJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDebugCommandResultJSONTooManyRequests creates a GetDebugCommandResultJSONTooManyRequests with default headers values
func NewGetDebugCommandResultJSONTooManyRequests() *GetDebugCommandResultJSONTooManyRequests {
	return &GetDebugCommandResultJSONTooManyRequests{}
}

/*
GetDebugCommandResultJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDebugCommandResultJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get debug command result Json too many requests response has a 2xx status code
func (o *GetDebugCommandResultJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get debug command result Json too many requests response has a 3xx status code
func (o *GetDebugCommandResultJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get debug command result Json too many requests response has a 4xx status code
func (o *GetDebugCommandResultJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get debug command result Json too many requests response has a 5xx status code
func (o *GetDebugCommandResultJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get debug command result Json too many requests response a status code equal to that given
func (o *GetDebugCommandResultJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get debug command result Json too many requests response
func (o *GetDebugCommandResultJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetDebugCommandResultJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /debug/{id}?__json=][%d] getDebugCommandResultJsonTooManyRequests", 429)
}

func (o *GetDebugCommandResultJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /debug/{id}?__json=][%d] getDebugCommandResultJsonTooManyRequests", 429)
}

func (o *GetDebugCommandResultJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDebugCommandResultJSONDefault creates a GetDebugCommandResultJSONDefault with default headers values
func NewGetDebugCommandResultJSONDefault(code int) *GetDebugCommandResultJSONDefault {
	return &GetDebugCommandResultJSONDefault{
		_statusCode: code,
	}
}

/*
GetDebugCommandResultJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDebugCommandResultJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get debug command result Json default response has a 2xx status code
func (o *GetDebugCommandResultJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get debug command result Json default response has a 3xx status code
func (o *GetDebugCommandResultJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get debug command result Json default response has a 4xx status code
func (o *GetDebugCommandResultJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get debug command result Json default response has a 5xx status code
func (o *GetDebugCommandResultJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get debug command result Json default response a status code equal to that given
func (o *GetDebugCommandResultJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get debug command result Json default response
func (o *GetDebugCommandResultJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDebugCommandResultJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /debug/{id}?__json=][%d] getDebugCommandResultJson default %s", o._statusCode, payload)
}

func (o *GetDebugCommandResultJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /debug/{id}?__json=][%d] getDebugCommandResultJson default %s", o._statusCode, payload)
}

func (o *GetDebugCommandResultJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDebugCommandResultJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
