// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDeltaDevicesJSONReader is a Reader for the GetDeltaDevicesJSON structure.
type GetDeltaDevicesJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeltaDevicesJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeltaDevicesJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeltaDevicesJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeltaDevicesJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeltaDevicesJSONOK creates a GetDeltaDevicesJSONOK with default headers values
func NewGetDeltaDevicesJSONOK() *GetDeltaDevicesJSONOK {
	return &GetDeltaDevicesJSONOK{}
}

/*
GetDeltaDevicesJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeltaDevicesJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get delta devices Json o k response has a 2xx status code
func (o *GetDeltaDevicesJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get delta devices Json o k response has a 3xx status code
func (o *GetDeltaDevicesJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get delta devices Json o k response has a 4xx status code
func (o *GetDeltaDevicesJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get delta devices Json o k response has a 5xx status code
func (o *GetDeltaDevicesJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get delta devices Json o k response a status code equal to that given
func (o *GetDeltaDevicesJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get delta devices Json o k response
func (o *GetDeltaDevicesJSONOK) Code() int {
	return 200
}

func (o *GetDeltaDevicesJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/delta/{deltaId}?__json=][%d] getDeltaDevicesJsonOK %s", 200, payload)
}

func (o *GetDeltaDevicesJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/delta/{deltaId}?__json=][%d] getDeltaDevicesJsonOK %s", 200, payload)
}

func (o *GetDeltaDevicesJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDeltaDevicesJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeltaDevicesJSONTooManyRequests creates a GetDeltaDevicesJSONTooManyRequests with default headers values
func NewGetDeltaDevicesJSONTooManyRequests() *GetDeltaDevicesJSONTooManyRequests {
	return &GetDeltaDevicesJSONTooManyRequests{}
}

/*
GetDeltaDevicesJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeltaDevicesJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get delta devices Json too many requests response has a 2xx status code
func (o *GetDeltaDevicesJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get delta devices Json too many requests response has a 3xx status code
func (o *GetDeltaDevicesJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get delta devices Json too many requests response has a 4xx status code
func (o *GetDeltaDevicesJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get delta devices Json too many requests response has a 5xx status code
func (o *GetDeltaDevicesJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get delta devices Json too many requests response a status code equal to that given
func (o *GetDeltaDevicesJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get delta devices Json too many requests response
func (o *GetDeltaDevicesJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetDeltaDevicesJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/delta/{deltaId}?__json=][%d] getDeltaDevicesJsonTooManyRequests", 429)
}

func (o *GetDeltaDevicesJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices/delta/{deltaId}?__json=][%d] getDeltaDevicesJsonTooManyRequests", 429)
}

func (o *GetDeltaDevicesJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeltaDevicesJSONDefault creates a GetDeltaDevicesJSONDefault with default headers values
func NewGetDeltaDevicesJSONDefault(code int) *GetDeltaDevicesJSONDefault {
	return &GetDeltaDevicesJSONDefault{
		_statusCode: code,
	}
}

/*
GetDeltaDevicesJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeltaDevicesJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get delta devices Json default response has a 2xx status code
func (o *GetDeltaDevicesJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get delta devices Json default response has a 3xx status code
func (o *GetDeltaDevicesJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get delta devices Json default response has a 4xx status code
func (o *GetDeltaDevicesJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get delta devices Json default response has a 5xx status code
func (o *GetDeltaDevicesJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get delta devices Json default response a status code equal to that given
func (o *GetDeltaDevicesJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get delta devices Json default response
func (o *GetDeltaDevicesJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDeltaDevicesJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/delta/{deltaId}?__json=][%d] getDeltaDevicesJson default %s", o._statusCode, payload)
}

func (o *GetDeltaDevicesJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/delta/{deltaId}?__json=][%d] getDeltaDevicesJson default %s", o._statusCode, payload)
}

func (o *GetDeltaDevicesJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeltaDevicesJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
