// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDeviceByIDReader is a Reader for the GetDeviceByID structure.
type GetDeviceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceByIDOK creates a GetDeviceByIDOK with default headers values
func NewGetDeviceByIDOK() *GetDeviceByIDOK {
	return &GetDeviceByIDOK{}
}

/*
GetDeviceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceByIDOK struct {
	Payload *models.Device
}

// IsSuccess returns true when this get device by Id o k response has a 2xx status code
func (o *GetDeviceByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get device by Id o k response has a 3xx status code
func (o *GetDeviceByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device by Id o k response has a 4xx status code
func (o *GetDeviceByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get device by Id o k response has a 5xx status code
func (o *GetDeviceByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get device by Id o k response a status code equal to that given
func (o *GetDeviceByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get device by Id o k response
func (o *GetDeviceByIDOK) Code() int {
	return 200
}

func (o *GetDeviceByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}][%d] getDeviceByIdOK %s", 200, payload)
}

func (o *GetDeviceByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}][%d] getDeviceByIdOK %s", 200, payload)
}

func (o *GetDeviceByIDOK) GetPayload() *models.Device {
	return o.Payload
}

func (o *GetDeviceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Device)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceByIDTooManyRequests creates a GetDeviceByIDTooManyRequests with default headers values
func NewGetDeviceByIDTooManyRequests() *GetDeviceByIDTooManyRequests {
	return &GetDeviceByIDTooManyRequests{}
}

/*
GetDeviceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get device by Id too many requests response has a 2xx status code
func (o *GetDeviceByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get device by Id too many requests response has a 3xx status code
func (o *GetDeviceByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device by Id too many requests response has a 4xx status code
func (o *GetDeviceByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get device by Id too many requests response has a 5xx status code
func (o *GetDeviceByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get device by Id too many requests response a status code equal to that given
func (o *GetDeviceByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get device by Id too many requests response
func (o *GetDeviceByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetDeviceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}][%d] getDeviceByIdTooManyRequests", 429)
}

func (o *GetDeviceByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices/{id}][%d] getDeviceByIdTooManyRequests", 429)
}

func (o *GetDeviceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceByIDDefault creates a GetDeviceByIDDefault with default headers values
func NewGetDeviceByIDDefault(code int) *GetDeviceByIDDefault {
	return &GetDeviceByIDDefault{
		_statusCode: code,
	}
}

/*
GetDeviceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get device by Id default response has a 2xx status code
func (o *GetDeviceByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get device by Id default response has a 3xx status code
func (o *GetDeviceByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get device by Id default response has a 4xx status code
func (o *GetDeviceByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get device by Id default response has a 5xx status code
func (o *GetDeviceByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get device by Id default response a status code equal to that given
func (o *GetDeviceByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get device by Id default response
func (o *GetDeviceByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}][%d] getDeviceById default %s", o._statusCode, payload)
}

func (o *GetDeviceByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}][%d] getDeviceById default %s", o._statusCode, payload)
}

func (o *GetDeviceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
