// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDeviceGroupByIDReader is a Reader for the GetDeviceGroupByID structure.
type GetDeviceGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceGroupByIDOK creates a GetDeviceGroupByIDOK with default headers values
func NewGetDeviceGroupByIDOK() *GetDeviceGroupByIDOK {
	return &GetDeviceGroupByIDOK{}
}

/*
GetDeviceGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceGroupByIDOK struct {
	Payload *models.DeviceGroup
}

// IsSuccess returns true when this get device group by Id o k response has a 2xx status code
func (o *GetDeviceGroupByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get device group by Id o k response has a 3xx status code
func (o *GetDeviceGroupByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device group by Id o k response has a 4xx status code
func (o *GetDeviceGroupByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get device group by Id o k response has a 5xx status code
func (o *GetDeviceGroupByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get device group by Id o k response a status code equal to that given
func (o *GetDeviceGroupByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get device group by Id o k response
func (o *GetDeviceGroupByIDOK) Code() int {
	return 200
}

func (o *GetDeviceGroupByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{id}][%d] getDeviceGroupByIdOK %s", 200, payload)
}

func (o *GetDeviceGroupByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{id}][%d] getDeviceGroupByIdOK %s", 200, payload)
}

func (o *GetDeviceGroupByIDOK) GetPayload() *models.DeviceGroup {
	return o.Payload
}

func (o *GetDeviceGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceGroupByIDTooManyRequests creates a GetDeviceGroupByIDTooManyRequests with default headers values
func NewGetDeviceGroupByIDTooManyRequests() *GetDeviceGroupByIDTooManyRequests {
	return &GetDeviceGroupByIDTooManyRequests{}
}

/*
GetDeviceGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get device group by Id too many requests response has a 2xx status code
func (o *GetDeviceGroupByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get device group by Id too many requests response has a 3xx status code
func (o *GetDeviceGroupByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device group by Id too many requests response has a 4xx status code
func (o *GetDeviceGroupByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get device group by Id too many requests response has a 5xx status code
func (o *GetDeviceGroupByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get device group by Id too many requests response a status code equal to that given
func (o *GetDeviceGroupByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get device group by Id too many requests response
func (o *GetDeviceGroupByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetDeviceGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}][%d] getDeviceGroupByIdTooManyRequests", 429)
}

func (o *GetDeviceGroupByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/groups/{id}][%d] getDeviceGroupByIdTooManyRequests", 429)
}

func (o *GetDeviceGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceGroupByIDDefault creates a GetDeviceGroupByIDDefault with default headers values
func NewGetDeviceGroupByIDDefault(code int) *GetDeviceGroupByIDDefault {
	return &GetDeviceGroupByIDDefault{
		_statusCode: code,
	}
}

/*
GetDeviceGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get device group by Id default response has a 2xx status code
func (o *GetDeviceGroupByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get device group by Id default response has a 3xx status code
func (o *GetDeviceGroupByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get device group by Id default response has a 4xx status code
func (o *GetDeviceGroupByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get device group by Id default response has a 5xx status code
func (o *GetDeviceGroupByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get device group by Id default response a status code equal to that given
func (o *GetDeviceGroupByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get device group by Id default response
func (o *GetDeviceGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceGroupByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{id}][%d] getDeviceGroupById default %s", o._statusCode, payload)
}

func (o *GetDeviceGroupByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{id}][%d] getDeviceGroupById default %s", o._statusCode, payload)
}

func (o *GetDeviceGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
