// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDeviceInstanceListJSONReader is a Reader for the GetDeviceInstanceListJSON structure.
type GetDeviceInstanceListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceInstanceListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceInstanceListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceInstanceListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceInstanceListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceInstanceListJSONOK creates a GetDeviceInstanceListJSONOK with default headers values
func NewGetDeviceInstanceListJSONOK() *GetDeviceInstanceListJSONOK {
	return &GetDeviceInstanceListJSONOK{}
}

/*
GetDeviceInstanceListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceInstanceListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get device instance list Json o k response has a 2xx status code
func (o *GetDeviceInstanceListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get device instance list Json o k response has a 3xx status code
func (o *GetDeviceInstanceListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device instance list Json o k response has a 4xx status code
func (o *GetDeviceInstanceListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get device instance list Json o k response has a 5xx status code
func (o *GetDeviceInstanceListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get device instance list Json o k response a status code equal to that given
func (o *GetDeviceInstanceListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get device instance list Json o k response
func (o *GetDeviceInstanceListJSONOK) Code() int {
	return 200
}

func (o *GetDeviceInstanceListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/instances?__json=][%d] getDeviceInstanceListJsonOK %s", 200, payload)
}

func (o *GetDeviceInstanceListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/instances?__json=][%d] getDeviceInstanceListJsonOK %s", 200, payload)
}

func (o *GetDeviceInstanceListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDeviceInstanceListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceInstanceListJSONTooManyRequests creates a GetDeviceInstanceListJSONTooManyRequests with default headers values
func NewGetDeviceInstanceListJSONTooManyRequests() *GetDeviceInstanceListJSONTooManyRequests {
	return &GetDeviceInstanceListJSONTooManyRequests{}
}

/*
GetDeviceInstanceListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceInstanceListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get device instance list Json too many requests response has a 2xx status code
func (o *GetDeviceInstanceListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get device instance list Json too many requests response has a 3xx status code
func (o *GetDeviceInstanceListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device instance list Json too many requests response has a 4xx status code
func (o *GetDeviceInstanceListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get device instance list Json too many requests response has a 5xx status code
func (o *GetDeviceInstanceListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get device instance list Json too many requests response a status code equal to that given
func (o *GetDeviceInstanceListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get device instance list Json too many requests response
func (o *GetDeviceInstanceListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetDeviceInstanceListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/instances?__json=][%d] getDeviceInstanceListJsonTooManyRequests", 429)
}

func (o *GetDeviceInstanceListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices/{id}/instances?__json=][%d] getDeviceInstanceListJsonTooManyRequests", 429)
}

func (o *GetDeviceInstanceListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceInstanceListJSONDefault creates a GetDeviceInstanceListJSONDefault with default headers values
func NewGetDeviceInstanceListJSONDefault(code int) *GetDeviceInstanceListJSONDefault {
	return &GetDeviceInstanceListJSONDefault{
		_statusCode: code,
	}
}

/*
GetDeviceInstanceListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceInstanceListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get device instance list Json default response has a 2xx status code
func (o *GetDeviceInstanceListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get device instance list Json default response has a 3xx status code
func (o *GetDeviceInstanceListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get device instance list Json default response has a 4xx status code
func (o *GetDeviceInstanceListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get device instance list Json default response has a 5xx status code
func (o *GetDeviceInstanceListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get device instance list Json default response a status code equal to that given
func (o *GetDeviceInstanceListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get device instance list Json default response
func (o *GetDeviceInstanceListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceInstanceListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/instances?__json=][%d] getDeviceInstanceListJson default %s", o._statusCode, payload)
}

func (o *GetDeviceInstanceListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/instances?__json=][%d] getDeviceInstanceListJson default %s", o._statusCode, payload)
}

func (o *GetDeviceInstanceListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceInstanceListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
