// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDeviceListJSONReader is a Reader for the GetDeviceListJSON structure.
type GetDeviceListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceListJSONOK creates a GetDeviceListJSONOK with default headers values
func NewGetDeviceListJSONOK() *GetDeviceListJSONOK {
	return &GetDeviceListJSONOK{}
}

/*
GetDeviceListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get device list Json o k response has a 2xx status code
func (o *GetDeviceListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get device list Json o k response has a 3xx status code
func (o *GetDeviceListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device list Json o k response has a 4xx status code
func (o *GetDeviceListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get device list Json o k response has a 5xx status code
func (o *GetDeviceListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get device list Json o k response a status code equal to that given
func (o *GetDeviceListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get device list Json o k response
func (o *GetDeviceListJSONOK) Code() int {
	return 200
}

func (o *GetDeviceListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices?__json=][%d] getDeviceListJsonOK %s", 200, payload)
}

func (o *GetDeviceListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices?__json=][%d] getDeviceListJsonOK %s", 200, payload)
}

func (o *GetDeviceListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDeviceListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceListJSONTooManyRequests creates a GetDeviceListJSONTooManyRequests with default headers values
func NewGetDeviceListJSONTooManyRequests() *GetDeviceListJSONTooManyRequests {
	return &GetDeviceListJSONTooManyRequests{}
}

/*
GetDeviceListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get device list Json too many requests response has a 2xx status code
func (o *GetDeviceListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get device list Json too many requests response has a 3xx status code
func (o *GetDeviceListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device list Json too many requests response has a 4xx status code
func (o *GetDeviceListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get device list Json too many requests response has a 5xx status code
func (o *GetDeviceListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get device list Json too many requests response a status code equal to that given
func (o *GetDeviceListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get device list Json too many requests response
func (o *GetDeviceListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetDeviceListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices?__json=][%d] getDeviceListJsonTooManyRequests", 429)
}

func (o *GetDeviceListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices?__json=][%d] getDeviceListJsonTooManyRequests", 429)
}

func (o *GetDeviceListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceListJSONDefault creates a GetDeviceListJSONDefault with default headers values
func NewGetDeviceListJSONDefault(code int) *GetDeviceListJSONDefault {
	return &GetDeviceListJSONDefault{
		_statusCode: code,
	}
}

/*
GetDeviceListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get device list Json default response has a 2xx status code
func (o *GetDeviceListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get device list Json default response has a 3xx status code
func (o *GetDeviceListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get device list Json default response has a 4xx status code
func (o *GetDeviceListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get device list Json default response has a 5xx status code
func (o *GetDeviceListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get device list Json default response a status code equal to that given
func (o *GetDeviceListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get device list Json default response
func (o *GetDeviceListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices?__json=][%d] getDeviceListJson default %s", o._statusCode, payload)
}

func (o *GetDeviceListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices?__json=][%d] getDeviceListJson default %s", o._statusCode, payload)
}

func (o *GetDeviceListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
