// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetEventSourceByIDJSONParams creates a new GetEventSourceByIDJSONParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetEventSourceByIDJSONParams() *GetEventSourceByIDJSONParams {
	return &GetEventSourceByIDJSONParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetEventSourceByIDJSONParamsWithTimeout creates a new GetEventSourceByIDJSONParams object
// with the ability to set a timeout on a request.
func NewGetEventSourceByIDJSONParamsWithTimeout(timeout time.Duration) *GetEventSourceByIDJSONParams {
	return &GetEventSourceByIDJSONParams{
		timeout: timeout,
	}
}

// NewGetEventSourceByIDJSONParamsWithContext creates a new GetEventSourceByIDJSONParams object
// with the ability to set a context for a request.
func NewGetEventSourceByIDJSONParamsWithContext(ctx context.Context) *GetEventSourceByIDJSONParams {
	return &GetEventSourceByIDJSONParams{
		Context: ctx,
	}
}

// NewGetEventSourceByIDJSONParamsWithHTTPClient creates a new GetEventSourceByIDJSONParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetEventSourceByIDJSONParamsWithHTTPClient(client *http.Client) *GetEventSourceByIDJSONParams {
	return &GetEventSourceByIDJSONParams{
		HTTPClient: client,
	}
}

/*
GetEventSourceByIDJSONParams contains all the parameters to send to the API endpoint

	for the get event source by Id Json operation.

	Typically these are written to a http.Request.
*/
type GetEventSourceByIDJSONParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Format.
	//
	// Default: "json"
	Format *string

	// ID.
	//
	// Format: int32
	ID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get event source by Id Json params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetEventSourceByIDJSONParams) WithDefaults() *GetEventSourceByIDJSONParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get event source by Id Json params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetEventSourceByIDJSONParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")

		formatDefault = string("json")
	)

	val := GetEventSourceByIDJSONParams{
		UserAgent: &userAgentDefault,
		Format:    &formatDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) WithTimeout(timeout time.Duration) *GetEventSourceByIDJSONParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) WithContext(ctx context.Context) *GetEventSourceByIDJSONParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) WithHTTPClient(client *http.Client) *GetEventSourceByIDJSONParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) WithUserAgent(userAgent *string) *GetEventSourceByIDJSONParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithFormat adds the format to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) WithFormat(format *string) *GetEventSourceByIDJSONParams {
	o.SetFormat(format)
	return o
}

// SetFormat adds the format to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) SetFormat(format *string) {
	o.Format = format
}

// WithID adds the id to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) WithID(id int32) *GetEventSourceByIDJSONParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get event source by Id Json params
func (o *GetEventSourceByIDJSONParams) SetID(id int32) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *GetEventSourceByIDJSONParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	if o.Format != nil {

		// query param format
		var qrFormat string

		if o.Format != nil {
			qrFormat = *o.Format
		}
		qFormat := qrFormat
		if qFormat != "" {

			if err := r.SetQueryParam("format", qFormat); err != nil {
				return err
			}
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
