// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetEventSourceByIDJSONReader is a Reader for the GetEventSourceByIDJSON structure.
type GetEventSourceByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetEventSourceByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetEventSourceByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetEventSourceByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetEventSourceByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetEventSourceByIDJSONOK creates a GetEventSourceByIDJSONOK with default headers values
func NewGetEventSourceByIDJSONOK() *GetEventSourceByIDJSONOK {
	return &GetEventSourceByIDJSONOK{}
}

/*
GetEventSourceByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetEventSourceByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get event source by Id Json o k response has a 2xx status code
func (o *GetEventSourceByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get event source by Id Json o k response has a 3xx status code
func (o *GetEventSourceByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get event source by Id Json o k response has a 4xx status code
func (o *GetEventSourceByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get event source by Id Json o k response has a 5xx status code
func (o *GetEventSourceByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get event source by Id Json o k response a status code equal to that given
func (o *GetEventSourceByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get event source by Id Json o k response
func (o *GetEventSourceByIDJSONOK) Code() int {
	return 200
}

func (o *GetEventSourceByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/eventsources/{id}?__json=][%d] getEventSourceByIdJsonOK %s", 200, payload)
}

func (o *GetEventSourceByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/eventsources/{id}?__json=][%d] getEventSourceByIdJsonOK %s", 200, payload)
}

func (o *GetEventSourceByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetEventSourceByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEventSourceByIDJSONTooManyRequests creates a GetEventSourceByIDJSONTooManyRequests with default headers values
func NewGetEventSourceByIDJSONTooManyRequests() *GetEventSourceByIDJSONTooManyRequests {
	return &GetEventSourceByIDJSONTooManyRequests{}
}

/*
GetEventSourceByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetEventSourceByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get event source by Id Json too many requests response has a 2xx status code
func (o *GetEventSourceByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get event source by Id Json too many requests response has a 3xx status code
func (o *GetEventSourceByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get event source by Id Json too many requests response has a 4xx status code
func (o *GetEventSourceByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get event source by Id Json too many requests response has a 5xx status code
func (o *GetEventSourceByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get event source by Id Json too many requests response a status code equal to that given
func (o *GetEventSourceByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get event source by Id Json too many requests response
func (o *GetEventSourceByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetEventSourceByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/eventsources/{id}?__json=][%d] getEventSourceByIdJsonTooManyRequests", 429)
}

func (o *GetEventSourceByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/eventsources/{id}?__json=][%d] getEventSourceByIdJsonTooManyRequests", 429)
}

func (o *GetEventSourceByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetEventSourceByIDJSONDefault creates a GetEventSourceByIDJSONDefault with default headers values
func NewGetEventSourceByIDJSONDefault(code int) *GetEventSourceByIDJSONDefault {
	return &GetEventSourceByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetEventSourceByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetEventSourceByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get event source by Id Json default response has a 2xx status code
func (o *GetEventSourceByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get event source by Id Json default response has a 3xx status code
func (o *GetEventSourceByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get event source by Id Json default response has a 4xx status code
func (o *GetEventSourceByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get event source by Id Json default response has a 5xx status code
func (o *GetEventSourceByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get event source by Id Json default response a status code equal to that given
func (o *GetEventSourceByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get event source by Id Json default response
func (o *GetEventSourceByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetEventSourceByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/eventsources/{id}?__json=][%d] getEventSourceByIdJson default %s", o._statusCode, payload)
}

func (o *GetEventSourceByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/eventsources/{id}?__json=][%d] getEventSourceByIdJson default %s", o._statusCode, payload)
}

func (o *GetEventSourceByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetEventSourceByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
