// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetJobMonitorByIDReader is a Reader for the GetJobMonitorByID structure.
type GetJobMonitorByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetJobMonitorByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetJobMonitorByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetJobMonitorByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetJobMonitorByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetJobMonitorByIDOK creates a GetJobMonitorByIDOK with default headers values
func NewGetJobMonitorByIDOK() *GetJobMonitorByIDOK {
	return &GetJobMonitorByIDOK{}
}

/*
GetJobMonitorByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetJobMonitorByIDOK struct {
	Payload *models.BatchJob
}

// IsSuccess returns true when this get job monitor by Id o k response has a 2xx status code
func (o *GetJobMonitorByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get job monitor by Id o k response has a 3xx status code
func (o *GetJobMonitorByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get job monitor by Id o k response has a 4xx status code
func (o *GetJobMonitorByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get job monitor by Id o k response has a 5xx status code
func (o *GetJobMonitorByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get job monitor by Id o k response a status code equal to that given
func (o *GetJobMonitorByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get job monitor by Id o k response
func (o *GetJobMonitorByIDOK) Code() int {
	return 200
}

func (o *GetJobMonitorByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/batchjobs/{id}][%d] getJobMonitorByIdOK %s", 200, payload)
}

func (o *GetJobMonitorByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/batchjobs/{id}][%d] getJobMonitorByIdOK %s", 200, payload)
}

func (o *GetJobMonitorByIDOK) GetPayload() *models.BatchJob {
	return o.Payload
}

func (o *GetJobMonitorByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.BatchJob)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobMonitorByIDTooManyRequests creates a GetJobMonitorByIDTooManyRequests with default headers values
func NewGetJobMonitorByIDTooManyRequests() *GetJobMonitorByIDTooManyRequests {
	return &GetJobMonitorByIDTooManyRequests{}
}

/*
GetJobMonitorByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetJobMonitorByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get job monitor by Id too many requests response has a 2xx status code
func (o *GetJobMonitorByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get job monitor by Id too many requests response has a 3xx status code
func (o *GetJobMonitorByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get job monitor by Id too many requests response has a 4xx status code
func (o *GetJobMonitorByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get job monitor by Id too many requests response has a 5xx status code
func (o *GetJobMonitorByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get job monitor by Id too many requests response a status code equal to that given
func (o *GetJobMonitorByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get job monitor by Id too many requests response
func (o *GetJobMonitorByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetJobMonitorByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/batchjobs/{id}][%d] getJobMonitorByIdTooManyRequests", 429)
}

func (o *GetJobMonitorByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/batchjobs/{id}][%d] getJobMonitorByIdTooManyRequests", 429)
}

func (o *GetJobMonitorByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetJobMonitorByIDDefault creates a GetJobMonitorByIDDefault with default headers values
func NewGetJobMonitorByIDDefault(code int) *GetJobMonitorByIDDefault {
	return &GetJobMonitorByIDDefault{
		_statusCode: code,
	}
}

/*
GetJobMonitorByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetJobMonitorByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get job monitor by Id default response has a 2xx status code
func (o *GetJobMonitorByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get job monitor by Id default response has a 3xx status code
func (o *GetJobMonitorByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get job monitor by Id default response has a 4xx status code
func (o *GetJobMonitorByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get job monitor by Id default response has a 5xx status code
func (o *GetJobMonitorByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get job monitor by Id default response a status code equal to that given
func (o *GetJobMonitorByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get job monitor by Id default response
func (o *GetJobMonitorByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetJobMonitorByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/batchjobs/{id}][%d] getJobMonitorById default %s", o._statusCode, payload)
}

func (o *GetJobMonitorByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/batchjobs/{id}][%d] getJobMonitorById default %s", o._statusCode, payload)
}

func (o *GetJobMonitorByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetJobMonitorByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
