// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetLogSourceByIDJSONParams creates a new GetLogSourceByIDJSONParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetLogSourceByIDJSONParams() *GetLogSourceByIDJSONParams {
	return &GetLogSourceByIDJSONParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetLogSourceByIDJSONParamsWithTimeout creates a new GetLogSourceByIDJSONParams object
// with the ability to set a timeout on a request.
func NewGetLogSourceByIDJSONParamsWithTimeout(timeout time.Duration) *GetLogSourceByIDJSONParams {
	return &GetLogSourceByIDJSONParams{
		timeout: timeout,
	}
}

// NewGetLogSourceByIDJSONParamsWithContext creates a new GetLogSourceByIDJSONParams object
// with the ability to set a context for a request.
func NewGetLogSourceByIDJSONParamsWithContext(ctx context.Context) *GetLogSourceByIDJSONParams {
	return &GetLogSourceByIDJSONParams{
		Context: ctx,
	}
}

// NewGetLogSourceByIDJSONParamsWithHTTPClient creates a new GetLogSourceByIDJSONParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetLogSourceByIDJSONParamsWithHTTPClient(client *http.Client) *GetLogSourceByIDJSONParams {
	return &GetLogSourceByIDJSONParams{
		HTTPClient: client,
	}
}

/*
GetLogSourceByIDJSONParams contains all the parameters to send to the API endpoint

	for the get log source by Id Json operation.

	Typically these are written to a http.Request.
*/
type GetLogSourceByIDJSONParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Format.
	//
	// Default: "json"
	Format *string

	// ID.
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get log source by Id Json params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogSourceByIDJSONParams) WithDefaults() *GetLogSourceByIDJSONParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get log source by Id Json params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogSourceByIDJSONParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")

		formatDefault = string("json")
	)

	val := GetLogSourceByIDJSONParams{
		UserAgent: &userAgentDefault,
		Format:    &formatDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) WithTimeout(timeout time.Duration) *GetLogSourceByIDJSONParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) WithContext(ctx context.Context) *GetLogSourceByIDJSONParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) WithHTTPClient(client *http.Client) *GetLogSourceByIDJSONParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) WithUserAgent(userAgent *string) *GetLogSourceByIDJSONParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithFormat adds the format to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) WithFormat(format *string) *GetLogSourceByIDJSONParams {
	o.SetFormat(format)
	return o
}

// SetFormat adds the format to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) SetFormat(format *string) {
	o.Format = format
}

// WithID adds the id to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) WithID(id string) *GetLogSourceByIDJSONParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get log source by Id Json params
func (o *GetLogSourceByIDJSONParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *GetLogSourceByIDJSONParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	if o.Format != nil {

		// query param format
		var qrFormat string

		if o.Format != nil {
			qrFormat = *o.Format
		}
		qFormat := qrFormat
		if qFormat != "" {

			if err := r.SetQueryParam("format", qFormat); err != nil {
				return err
			}
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
