// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetLogSourceByIDJSONReader is a Reader for the GetLogSourceByIDJSON structure.
type GetLogSourceByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetLogSourceByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetLogSourceByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetLogSourceByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetLogSourceByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetLogSourceByIDJSONOK creates a GetLogSourceByIDJSONOK with default headers values
func NewGetLogSourceByIDJSONOK() *GetLogSourceByIDJSONOK {
	return &GetLogSourceByIDJSONOK{}
}

/*
GetLogSourceByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetLogSourceByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get log source by Id Json o k response has a 2xx status code
func (o *GetLogSourceByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get log source by Id Json o k response has a 3xx status code
func (o *GetLogSourceByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get log source by Id Json o k response has a 4xx status code
func (o *GetLogSourceByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get log source by Id Json o k response has a 5xx status code
func (o *GetLogSourceByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get log source by Id Json o k response a status code equal to that given
func (o *GetLogSourceByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get log source by Id Json o k response
func (o *GetLogSourceByIDJSONOK) Code() int {
	return 200
}

func (o *GetLogSourceByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources/{id}?__json=][%d] getLogSourceByIdJsonOK %s", 200, payload)
}

func (o *GetLogSourceByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources/{id}?__json=][%d] getLogSourceByIdJsonOK %s", 200, payload)
}

func (o *GetLogSourceByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetLogSourceByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLogSourceByIDJSONTooManyRequests creates a GetLogSourceByIDJSONTooManyRequests with default headers values
func NewGetLogSourceByIDJSONTooManyRequests() *GetLogSourceByIDJSONTooManyRequests {
	return &GetLogSourceByIDJSONTooManyRequests{}
}

/*
GetLogSourceByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetLogSourceByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get log source by Id Json too many requests response has a 2xx status code
func (o *GetLogSourceByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get log source by Id Json too many requests response has a 3xx status code
func (o *GetLogSourceByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get log source by Id Json too many requests response has a 4xx status code
func (o *GetLogSourceByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get log source by Id Json too many requests response has a 5xx status code
func (o *GetLogSourceByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get log source by Id Json too many requests response a status code equal to that given
func (o *GetLogSourceByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get log source by Id Json too many requests response
func (o *GetLogSourceByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetLogSourceByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/logsources/{id}?__json=][%d] getLogSourceByIdJsonTooManyRequests", 429)
}

func (o *GetLogSourceByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/logsources/{id}?__json=][%d] getLogSourceByIdJsonTooManyRequests", 429)
}

func (o *GetLogSourceByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetLogSourceByIDJSONDefault creates a GetLogSourceByIDJSONDefault with default headers values
func NewGetLogSourceByIDJSONDefault(code int) *GetLogSourceByIDJSONDefault {
	return &GetLogSourceByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetLogSourceByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetLogSourceByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get log source by Id Json default response has a 2xx status code
func (o *GetLogSourceByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get log source by Id Json default response has a 3xx status code
func (o *GetLogSourceByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get log source by Id Json default response has a 4xx status code
func (o *GetLogSourceByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get log source by Id Json default response has a 5xx status code
func (o *GetLogSourceByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get log source by Id Json default response a status code equal to that given
func (o *GetLogSourceByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get log source by Id Json default response
func (o *GetLogSourceByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetLogSourceByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources/{id}?__json=][%d] getLogSourceByIdJson default %s", o._statusCode, payload)
}

func (o *GetLogSourceByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources/{id}?__json=][%d] getLogSourceByIdJson default %s", o._statusCode, payload)
}

func (o *GetLogSourceByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetLogSourceByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
