// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetLogSourceByIDParams creates a new GetLogSourceByIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetLogSourceByIDParams() *GetLogSourceByIDParams {
	return &GetLogSourceByIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetLogSourceByIDParamsWithTimeout creates a new GetLogSourceByIDParams object
// with the ability to set a timeout on a request.
func NewGetLogSourceByIDParamsWithTimeout(timeout time.Duration) *GetLogSourceByIDParams {
	return &GetLogSourceByIDParams{
		timeout: timeout,
	}
}

// NewGetLogSourceByIDParamsWithContext creates a new GetLogSourceByIDParams object
// with the ability to set a context for a request.
func NewGetLogSourceByIDParamsWithContext(ctx context.Context) *GetLogSourceByIDParams {
	return &GetLogSourceByIDParams{
		Context: ctx,
	}
}

// NewGetLogSourceByIDParamsWithHTTPClient creates a new GetLogSourceByIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetLogSourceByIDParamsWithHTTPClient(client *http.Client) *GetLogSourceByIDParams {
	return &GetLogSourceByIDParams{
		HTTPClient: client,
	}
}

/*
GetLogSourceByIDParams contains all the parameters to send to the API endpoint

	for the get log source by Id operation.

	Typically these are written to a http.Request.
*/
type GetLogSourceByIDParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Format.
	//
	// Default: "json"
	Format *string

	// ID.
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get log source by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogSourceByIDParams) WithDefaults() *GetLogSourceByIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get log source by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogSourceByIDParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")

		formatDefault = string("json")
	)

	val := GetLogSourceByIDParams{
		UserAgent: &userAgentDefault,
		Format:    &formatDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get log source by Id params
func (o *GetLogSourceByIDParams) WithTimeout(timeout time.Duration) *GetLogSourceByIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get log source by Id params
func (o *GetLogSourceByIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get log source by Id params
func (o *GetLogSourceByIDParams) WithContext(ctx context.Context) *GetLogSourceByIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get log source by Id params
func (o *GetLogSourceByIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get log source by Id params
func (o *GetLogSourceByIDParams) WithHTTPClient(client *http.Client) *GetLogSourceByIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get log source by Id params
func (o *GetLogSourceByIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the get log source by Id params
func (o *GetLogSourceByIDParams) WithUserAgent(userAgent *string) *GetLogSourceByIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get log source by Id params
func (o *GetLogSourceByIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithFormat adds the format to the get log source by Id params
func (o *GetLogSourceByIDParams) WithFormat(format *string) *GetLogSourceByIDParams {
	o.SetFormat(format)
	return o
}

// SetFormat adds the format to the get log source by Id params
func (o *GetLogSourceByIDParams) SetFormat(format *string) {
	o.Format = format
}

// WithID adds the id to the get log source by Id params
func (o *GetLogSourceByIDParams) WithID(id string) *GetLogSourceByIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get log source by Id params
func (o *GetLogSourceByIDParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *GetLogSourceByIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	if o.Format != nil {

		// query param format
		var qrFormat string

		if o.Format != nil {
			qrFormat = *o.Format
		}
		qFormat := qrFormat
		if qFormat != "" {

			if err := r.SetQueryParam("format", qFormat); err != nil {
				return err
			}
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
