// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetLogSourceByIDReader is a Reader for the GetLogSourceByID structure.
type GetLogSourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetLogSourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetLogSourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetLogSourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetLogSourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetLogSourceByIDOK creates a GetLogSourceByIDOK with default headers values
func NewGetLogSourceByIDOK() *GetLogSourceByIDOK {
	return &GetLogSourceByIDOK{}
}

/*
GetLogSourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetLogSourceByIDOK struct {
	Payload *models.LogSource
}

// IsSuccess returns true when this get log source by Id o k response has a 2xx status code
func (o *GetLogSourceByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get log source by Id o k response has a 3xx status code
func (o *GetLogSourceByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get log source by Id o k response has a 4xx status code
func (o *GetLogSourceByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get log source by Id o k response has a 5xx status code
func (o *GetLogSourceByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get log source by Id o k response a status code equal to that given
func (o *GetLogSourceByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get log source by Id o k response
func (o *GetLogSourceByIDOK) Code() int {
	return 200
}

func (o *GetLogSourceByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources/{id}][%d] getLogSourceByIdOK %s", 200, payload)
}

func (o *GetLogSourceByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources/{id}][%d] getLogSourceByIdOK %s", 200, payload)
}

func (o *GetLogSourceByIDOK) GetPayload() *models.LogSource {
	return o.Payload
}

func (o *GetLogSourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LogSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLogSourceByIDTooManyRequests creates a GetLogSourceByIDTooManyRequests with default headers values
func NewGetLogSourceByIDTooManyRequests() *GetLogSourceByIDTooManyRequests {
	return &GetLogSourceByIDTooManyRequests{}
}

/*
GetLogSourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetLogSourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get log source by Id too many requests response has a 2xx status code
func (o *GetLogSourceByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get log source by Id too many requests response has a 3xx status code
func (o *GetLogSourceByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get log source by Id too many requests response has a 4xx status code
func (o *GetLogSourceByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get log source by Id too many requests response has a 5xx status code
func (o *GetLogSourceByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get log source by Id too many requests response a status code equal to that given
func (o *GetLogSourceByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get log source by Id too many requests response
func (o *GetLogSourceByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetLogSourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/logsources/{id}][%d] getLogSourceByIdTooManyRequests", 429)
}

func (o *GetLogSourceByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/logsources/{id}][%d] getLogSourceByIdTooManyRequests", 429)
}

func (o *GetLogSourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetLogSourceByIDDefault creates a GetLogSourceByIDDefault with default headers values
func NewGetLogSourceByIDDefault(code int) *GetLogSourceByIDDefault {
	return &GetLogSourceByIDDefault{
		_statusCode: code,
	}
}

/*
GetLogSourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetLogSourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get log source by Id default response has a 2xx status code
func (o *GetLogSourceByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get log source by Id default response has a 3xx status code
func (o *GetLogSourceByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get log source by Id default response has a 4xx status code
func (o *GetLogSourceByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get log source by Id default response has a 5xx status code
func (o *GetLogSourceByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get log source by Id default response a status code equal to that given
func (o *GetLogSourceByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get log source by Id default response
func (o *GetLogSourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetLogSourceByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources/{id}][%d] getLogSourceById default %s", o._statusCode, payload)
}

func (o *GetLogSourceByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources/{id}][%d] getLogSourceById default %s", o._statusCode, payload)
}

func (o *GetLogSourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetLogSourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
