// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetLogSourceListReader is a Reader for the GetLogSourceList structure.
type GetLogSourceListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetLogSourceListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetLogSourceListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetLogSourceListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetLogSourceListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetLogSourceListOK creates a GetLogSourceListOK with default headers values
func NewGetLogSourceListOK() *GetLogSourceListOK {
	return &GetLogSourceListOK{}
}

/*
GetLogSourceListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetLogSourceListOK struct {
	Payload *models.LogSourcePaginationResponse
}

// IsSuccess returns true when this get log source list o k response has a 2xx status code
func (o *GetLogSourceListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get log source list o k response has a 3xx status code
func (o *GetLogSourceListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get log source list o k response has a 4xx status code
func (o *GetLogSourceListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get log source list o k response has a 5xx status code
func (o *GetLogSourceListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get log source list o k response a status code equal to that given
func (o *GetLogSourceListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get log source list o k response
func (o *GetLogSourceListOK) Code() int {
	return 200
}

func (o *GetLogSourceListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources][%d] getLogSourceListOK %s", 200, payload)
}

func (o *GetLogSourceListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources][%d] getLogSourceListOK %s", 200, payload)
}

func (o *GetLogSourceListOK) GetPayload() *models.LogSourcePaginationResponse {
	return o.Payload
}

func (o *GetLogSourceListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LogSourcePaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLogSourceListTooManyRequests creates a GetLogSourceListTooManyRequests with default headers values
func NewGetLogSourceListTooManyRequests() *GetLogSourceListTooManyRequests {
	return &GetLogSourceListTooManyRequests{}
}

/*
GetLogSourceListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetLogSourceListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get log source list too many requests response has a 2xx status code
func (o *GetLogSourceListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get log source list too many requests response has a 3xx status code
func (o *GetLogSourceListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get log source list too many requests response has a 4xx status code
func (o *GetLogSourceListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get log source list too many requests response has a 5xx status code
func (o *GetLogSourceListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get log source list too many requests response a status code equal to that given
func (o *GetLogSourceListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get log source list too many requests response
func (o *GetLogSourceListTooManyRequests) Code() int {
	return 429
}

func (o *GetLogSourceListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/logsources][%d] getLogSourceListTooManyRequests", 429)
}

func (o *GetLogSourceListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/logsources][%d] getLogSourceListTooManyRequests", 429)
}

func (o *GetLogSourceListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetLogSourceListDefault creates a GetLogSourceListDefault with default headers values
func NewGetLogSourceListDefault(code int) *GetLogSourceListDefault {
	return &GetLogSourceListDefault{
		_statusCode: code,
	}
}

/*
GetLogSourceListDefault describes a response with status code -1, with default header values.

Error
*/
type GetLogSourceListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get log source list default response has a 2xx status code
func (o *GetLogSourceListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get log source list default response has a 3xx status code
func (o *GetLogSourceListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get log source list default response has a 4xx status code
func (o *GetLogSourceListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get log source list default response has a 5xx status code
func (o *GetLogSourceListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get log source list default response a status code equal to that given
func (o *GetLogSourceListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get log source list default response
func (o *GetLogSourceListDefault) Code() int {
	return o._statusCode
}

func (o *GetLogSourceListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources][%d] getLogSourceList default %s", o._statusCode, payload)
}

func (o *GetLogSourceListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources][%d] getLogSourceList default %s", o._statusCode, payload)
}

func (o *GetLogSourceListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetLogSourceListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
