// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetNetflowEndpointListReader is a Reader for the GetNetflowEndpointList structure.
type GetNetflowEndpointListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetNetflowEndpointListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetNetflowEndpointListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetNetflowEndpointListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetNetflowEndpointListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetNetflowEndpointListOK creates a GetNetflowEndpointListOK with default headers values
func NewGetNetflowEndpointListOK() *GetNetflowEndpointListOK {
	return &GetNetflowEndpointListOK{}
}

/*
GetNetflowEndpointListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetNetflowEndpointListOK struct {
	Payload *models.EndpointPaginationResponse
}

// IsSuccess returns true when this get netflow endpoint list o k response has a 2xx status code
func (o *GetNetflowEndpointListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get netflow endpoint list o k response has a 3xx status code
func (o *GetNetflowEndpointListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netflow endpoint list o k response has a 4xx status code
func (o *GetNetflowEndpointListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get netflow endpoint list o k response has a 5xx status code
func (o *GetNetflowEndpointListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get netflow endpoint list o k response a status code equal to that given
func (o *GetNetflowEndpointListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get netflow endpoint list o k response
func (o *GetNetflowEndpointListOK) Code() int {
	return 200
}

func (o *GetNetflowEndpointListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/endpoints][%d] getNetflowEndpointListOK %s", 200, payload)
}

func (o *GetNetflowEndpointListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/endpoints][%d] getNetflowEndpointListOK %s", 200, payload)
}

func (o *GetNetflowEndpointListOK) GetPayload() *models.EndpointPaginationResponse {
	return o.Payload
}

func (o *GetNetflowEndpointListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.EndpointPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetNetflowEndpointListTooManyRequests creates a GetNetflowEndpointListTooManyRequests with default headers values
func NewGetNetflowEndpointListTooManyRequests() *GetNetflowEndpointListTooManyRequests {
	return &GetNetflowEndpointListTooManyRequests{}
}

/*
GetNetflowEndpointListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetNetflowEndpointListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get netflow endpoint list too many requests response has a 2xx status code
func (o *GetNetflowEndpointListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get netflow endpoint list too many requests response has a 3xx status code
func (o *GetNetflowEndpointListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netflow endpoint list too many requests response has a 4xx status code
func (o *GetNetflowEndpointListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get netflow endpoint list too many requests response has a 5xx status code
func (o *GetNetflowEndpointListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get netflow endpoint list too many requests response a status code equal to that given
func (o *GetNetflowEndpointListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get netflow endpoint list too many requests response
func (o *GetNetflowEndpointListTooManyRequests) Code() int {
	return 429
}

func (o *GetNetflowEndpointListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/endpoints][%d] getNetflowEndpointListTooManyRequests", 429)
}

func (o *GetNetflowEndpointListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices/{id}/endpoints][%d] getNetflowEndpointListTooManyRequests", 429)
}

func (o *GetNetflowEndpointListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetNetflowEndpointListDefault creates a GetNetflowEndpointListDefault with default headers values
func NewGetNetflowEndpointListDefault(code int) *GetNetflowEndpointListDefault {
	return &GetNetflowEndpointListDefault{
		_statusCode: code,
	}
}

/*
GetNetflowEndpointListDefault describes a response with status code -1, with default header values.

Error
*/
type GetNetflowEndpointListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get netflow endpoint list default response has a 2xx status code
func (o *GetNetflowEndpointListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get netflow endpoint list default response has a 3xx status code
func (o *GetNetflowEndpointListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get netflow endpoint list default response has a 4xx status code
func (o *GetNetflowEndpointListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get netflow endpoint list default response has a 5xx status code
func (o *GetNetflowEndpointListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get netflow endpoint list default response a status code equal to that given
func (o *GetNetflowEndpointListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get netflow endpoint list default response
func (o *GetNetflowEndpointListDefault) Code() int {
	return o._statusCode
}

func (o *GetNetflowEndpointListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/endpoints][%d] getNetflowEndpointList default %s", o._statusCode, payload)
}

func (o *GetNetflowEndpointListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/endpoints][%d] getNetflowEndpointList default %s", o._statusCode, payload)
}

func (o *GetNetflowEndpointListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetNetflowEndpointListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
