// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetNetflowFlowListJSONReader is a Reader for the GetNetflowFlowListJSON structure.
type GetNetflowFlowListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetNetflowFlowListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetNetflowFlowListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetNetflowFlowListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetNetflowFlowListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetNetflowFlowListJSONOK creates a GetNetflowFlowListJSONOK with default headers values
func NewGetNetflowFlowListJSONOK() *GetNetflowFlowListJSONOK {
	return &GetNetflowFlowListJSONOK{}
}

/*
GetNetflowFlowListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetNetflowFlowListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get netflow flow list Json o k response has a 2xx status code
func (o *GetNetflowFlowListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get netflow flow list Json o k response has a 3xx status code
func (o *GetNetflowFlowListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netflow flow list Json o k response has a 4xx status code
func (o *GetNetflowFlowListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get netflow flow list Json o k response has a 5xx status code
func (o *GetNetflowFlowListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get netflow flow list Json o k response a status code equal to that given
func (o *GetNetflowFlowListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get netflow flow list Json o k response
func (o *GetNetflowFlowListJSONOK) Code() int {
	return 200
}

func (o *GetNetflowFlowListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/flows?__json=][%d] getNetflowFlowListJsonOK %s", 200, payload)
}

func (o *GetNetflowFlowListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/flows?__json=][%d] getNetflowFlowListJsonOK %s", 200, payload)
}

func (o *GetNetflowFlowListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetNetflowFlowListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetNetflowFlowListJSONTooManyRequests creates a GetNetflowFlowListJSONTooManyRequests with default headers values
func NewGetNetflowFlowListJSONTooManyRequests() *GetNetflowFlowListJSONTooManyRequests {
	return &GetNetflowFlowListJSONTooManyRequests{}
}

/*
GetNetflowFlowListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetNetflowFlowListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get netflow flow list Json too many requests response has a 2xx status code
func (o *GetNetflowFlowListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get netflow flow list Json too many requests response has a 3xx status code
func (o *GetNetflowFlowListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netflow flow list Json too many requests response has a 4xx status code
func (o *GetNetflowFlowListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get netflow flow list Json too many requests response has a 5xx status code
func (o *GetNetflowFlowListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get netflow flow list Json too many requests response a status code equal to that given
func (o *GetNetflowFlowListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get netflow flow list Json too many requests response
func (o *GetNetflowFlowListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetNetflowFlowListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/flows?__json=][%d] getNetflowFlowListJsonTooManyRequests", 429)
}

func (o *GetNetflowFlowListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices/{id}/flows?__json=][%d] getNetflowFlowListJsonTooManyRequests", 429)
}

func (o *GetNetflowFlowListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetNetflowFlowListJSONDefault creates a GetNetflowFlowListJSONDefault with default headers values
func NewGetNetflowFlowListJSONDefault(code int) *GetNetflowFlowListJSONDefault {
	return &GetNetflowFlowListJSONDefault{
		_statusCode: code,
	}
}

/*
GetNetflowFlowListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetNetflowFlowListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get netflow flow list Json default response has a 2xx status code
func (o *GetNetflowFlowListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get netflow flow list Json default response has a 3xx status code
func (o *GetNetflowFlowListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get netflow flow list Json default response has a 4xx status code
func (o *GetNetflowFlowListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get netflow flow list Json default response has a 5xx status code
func (o *GetNetflowFlowListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get netflow flow list Json default response a status code equal to that given
func (o *GetNetflowFlowListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get netflow flow list Json default response
func (o *GetNetflowFlowListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetNetflowFlowListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/flows?__json=][%d] getNetflowFlowListJson default %s", o._statusCode, payload)
}

func (o *GetNetflowFlowListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/flows?__json=][%d] getNetflowFlowListJson default %s", o._statusCode, payload)
}

func (o *GetNetflowFlowListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetNetflowFlowListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
