// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetNetflowPortListReader is a Reader for the GetNetflowPortList structure.
type GetNetflowPortListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetNetflowPortListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetNetflowPortListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetNetflowPortListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetNetflowPortListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetNetflowPortListOK creates a GetNetflowPortListOK with default headers values
func NewGetNetflowPortListOK() *GetNetflowPortListOK {
	return &GetNetflowPortListOK{}
}

/*
GetNetflowPortListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetNetflowPortListOK struct {
	Payload *models.PortPaginationResponse
}

// IsSuccess returns true when this get netflow port list o k response has a 2xx status code
func (o *GetNetflowPortListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get netflow port list o k response has a 3xx status code
func (o *GetNetflowPortListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netflow port list o k response has a 4xx status code
func (o *GetNetflowPortListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get netflow port list o k response has a 5xx status code
func (o *GetNetflowPortListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get netflow port list o k response a status code equal to that given
func (o *GetNetflowPortListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get netflow port list o k response
func (o *GetNetflowPortListOK) Code() int {
	return 200
}

func (o *GetNetflowPortListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/ports][%d] getNetflowPortListOK %s", 200, payload)
}

func (o *GetNetflowPortListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/ports][%d] getNetflowPortListOK %s", 200, payload)
}

func (o *GetNetflowPortListOK) GetPayload() *models.PortPaginationResponse {
	return o.Payload
}

func (o *GetNetflowPortListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.PortPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetNetflowPortListTooManyRequests creates a GetNetflowPortListTooManyRequests with default headers values
func NewGetNetflowPortListTooManyRequests() *GetNetflowPortListTooManyRequests {
	return &GetNetflowPortListTooManyRequests{}
}

/*
GetNetflowPortListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetNetflowPortListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get netflow port list too many requests response has a 2xx status code
func (o *GetNetflowPortListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get netflow port list too many requests response has a 3xx status code
func (o *GetNetflowPortListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netflow port list too many requests response has a 4xx status code
func (o *GetNetflowPortListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get netflow port list too many requests response has a 5xx status code
func (o *GetNetflowPortListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get netflow port list too many requests response a status code equal to that given
func (o *GetNetflowPortListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get netflow port list too many requests response
func (o *GetNetflowPortListTooManyRequests) Code() int {
	return 429
}

func (o *GetNetflowPortListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/ports][%d] getNetflowPortListTooManyRequests", 429)
}

func (o *GetNetflowPortListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices/{id}/ports][%d] getNetflowPortListTooManyRequests", 429)
}

func (o *GetNetflowPortListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetNetflowPortListDefault creates a GetNetflowPortListDefault with default headers values
func NewGetNetflowPortListDefault(code int) *GetNetflowPortListDefault {
	return &GetNetflowPortListDefault{
		_statusCode: code,
	}
}

/*
GetNetflowPortListDefault describes a response with status code -1, with default header values.

Error
*/
type GetNetflowPortListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get netflow port list default response has a 2xx status code
func (o *GetNetflowPortListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get netflow port list default response has a 3xx status code
func (o *GetNetflowPortListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get netflow port list default response has a 4xx status code
func (o *GetNetflowPortListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get netflow port list default response has a 5xx status code
func (o *GetNetflowPortListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get netflow port list default response a status code equal to that given
func (o *GetNetflowPortListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get netflow port list default response
func (o *GetNetflowPortListDefault) Code() int {
	return o._statusCode
}

func (o *GetNetflowPortListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/ports][%d] getNetflowPortList default %s", o._statusCode, payload)
}

func (o *GetNetflowPortListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/ports][%d] getNetflowPortList default %s", o._statusCode, payload)
}

func (o *GetNetflowPortListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetNetflowPortListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
