// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetNetscanListJSONReader is a Reader for the GetNetscanListJSON structure.
type GetNetscanListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetNetscanListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetNetscanListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetNetscanListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetNetscanListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetNetscanListJSONOK creates a GetNetscanListJSONOK with default headers values
func NewGetNetscanListJSONOK() *GetNetscanListJSONOK {
	return &GetNetscanListJSONOK{}
}

/*
GetNetscanListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetNetscanListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get netscan list Json o k response has a 2xx status code
func (o *GetNetscanListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get netscan list Json o k response has a 3xx status code
func (o *GetNetscanListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netscan list Json o k response has a 4xx status code
func (o *GetNetscanListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get netscan list Json o k response has a 5xx status code
func (o *GetNetscanListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get netscan list Json o k response a status code equal to that given
func (o *GetNetscanListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get netscan list Json o k response
func (o *GetNetscanListJSONOK) Code() int {
	return 200
}

func (o *GetNetscanListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans?__json=][%d] getNetscanListJsonOK %s", 200, payload)
}

func (o *GetNetscanListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans?__json=][%d] getNetscanListJsonOK %s", 200, payload)
}

func (o *GetNetscanListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetNetscanListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetNetscanListJSONTooManyRequests creates a GetNetscanListJSONTooManyRequests with default headers values
func NewGetNetscanListJSONTooManyRequests() *GetNetscanListJSONTooManyRequests {
	return &GetNetscanListJSONTooManyRequests{}
}

/*
GetNetscanListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetNetscanListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get netscan list Json too many requests response has a 2xx status code
func (o *GetNetscanListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get netscan list Json too many requests response has a 3xx status code
func (o *GetNetscanListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netscan list Json too many requests response has a 4xx status code
func (o *GetNetscanListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get netscan list Json too many requests response has a 5xx status code
func (o *GetNetscanListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get netscan list Json too many requests response a status code equal to that given
func (o *GetNetscanListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get netscan list Json too many requests response
func (o *GetNetscanListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetNetscanListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/netscans?__json=][%d] getNetscanListJsonTooManyRequests", 429)
}

func (o *GetNetscanListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/netscans?__json=][%d] getNetscanListJsonTooManyRequests", 429)
}

func (o *GetNetscanListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetNetscanListJSONDefault creates a GetNetscanListJSONDefault with default headers values
func NewGetNetscanListJSONDefault(code int) *GetNetscanListJSONDefault {
	return &GetNetscanListJSONDefault{
		_statusCode: code,
	}
}

/*
GetNetscanListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetNetscanListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get netscan list Json default response has a 2xx status code
func (o *GetNetscanListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get netscan list Json default response has a 3xx status code
func (o *GetNetscanListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get netscan list Json default response has a 4xx status code
func (o *GetNetscanListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get netscan list Json default response has a 5xx status code
func (o *GetNetscanListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get netscan list Json default response a status code equal to that given
func (o *GetNetscanListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get netscan list Json default response
func (o *GetNetscanListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetNetscanListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans?__json=][%d] getNetscanListJson default %s", o._statusCode, payload)
}

func (o *GetNetscanListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans?__json=][%d] getNetscanListJson default %s", o._statusCode, payload)
}

func (o *GetNetscanListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetNetscanListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
