// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetNetscanListReader is a Reader for the GetNetscanList structure.
type GetNetscanListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetNetscanListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetNetscanListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetNetscanListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetNetscanListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetNetscanListOK creates a GetNetscanListOK with default headers values
func NewGetNetscanListOK() *GetNetscanListOK {
	return &GetNetscanListOK{}
}

/*
GetNetscanListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetNetscanListOK struct {
	Payload *models.NetscanPaginationResponse
}

// IsSuccess returns true when this get netscan list o k response has a 2xx status code
func (o *GetNetscanListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get netscan list o k response has a 3xx status code
func (o *GetNetscanListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netscan list o k response has a 4xx status code
func (o *GetNetscanListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get netscan list o k response has a 5xx status code
func (o *GetNetscanListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get netscan list o k response a status code equal to that given
func (o *GetNetscanListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get netscan list o k response
func (o *GetNetscanListOK) Code() int {
	return 200
}

func (o *GetNetscanListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans][%d] getNetscanListOK %s", 200, payload)
}

func (o *GetNetscanListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans][%d] getNetscanListOK %s", 200, payload)
}

func (o *GetNetscanListOK) GetPayload() *models.NetscanPaginationResponse {
	return o.Payload
}

func (o *GetNetscanListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.NetscanPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetNetscanListTooManyRequests creates a GetNetscanListTooManyRequests with default headers values
func NewGetNetscanListTooManyRequests() *GetNetscanListTooManyRequests {
	return &GetNetscanListTooManyRequests{}
}

/*
GetNetscanListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetNetscanListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get netscan list too many requests response has a 2xx status code
func (o *GetNetscanListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get netscan list too many requests response has a 3xx status code
func (o *GetNetscanListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netscan list too many requests response has a 4xx status code
func (o *GetNetscanListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get netscan list too many requests response has a 5xx status code
func (o *GetNetscanListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get netscan list too many requests response a status code equal to that given
func (o *GetNetscanListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get netscan list too many requests response
func (o *GetNetscanListTooManyRequests) Code() int {
	return 429
}

func (o *GetNetscanListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/netscans][%d] getNetscanListTooManyRequests", 429)
}

func (o *GetNetscanListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/netscans][%d] getNetscanListTooManyRequests", 429)
}

func (o *GetNetscanListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetNetscanListDefault creates a GetNetscanListDefault with default headers values
func NewGetNetscanListDefault(code int) *GetNetscanListDefault {
	return &GetNetscanListDefault{
		_statusCode: code,
	}
}

/*
GetNetscanListDefault describes a response with status code -1, with default header values.

Error
*/
type GetNetscanListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get netscan list default response has a 2xx status code
func (o *GetNetscanListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get netscan list default response has a 3xx status code
func (o *GetNetscanListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get netscan list default response has a 4xx status code
func (o *GetNetscanListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get netscan list default response has a 5xx status code
func (o *GetNetscanListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get netscan list default response a status code equal to that given
func (o *GetNetscanListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get netscan list default response
func (o *GetNetscanListDefault) Code() int {
	return o._statusCode
}

func (o *GetNetscanListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans][%d] getNetscanList default %s", o._statusCode, payload)
}

func (o *GetNetscanListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans][%d] getNetscanList default %s", o._statusCode, payload)
}

func (o *GetNetscanListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetNetscanListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
