// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetOIDListReader is a Reader for the GetOIDList structure.
type GetOIDListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetOIDListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetOIDListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetOIDListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetOIDListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetOIDListOK creates a GetOIDListOK with default headers values
func NewGetOIDListOK() *GetOIDListOK {
	return &GetOIDListOK{}
}

/*
GetOIDListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetOIDListOK struct {
	Payload *models.OidSourcePaginationResponse
}

// IsSuccess returns true when this get o Id list o k response has a 2xx status code
func (o *GetOIDListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get o Id list o k response has a 3xx status code
func (o *GetOIDListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get o Id list o k response has a 4xx status code
func (o *GetOIDListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get o Id list o k response has a 5xx status code
func (o *GetOIDListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get o Id list o k response a status code equal to that given
func (o *GetOIDListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get o Id list o k response
func (o *GetOIDListOK) Code() int {
	return 200
}

func (o *GetOIDListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids][%d] getOIdListOK %s", 200, payload)
}

func (o *GetOIDListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids][%d] getOIdListOK %s", 200, payload)
}

func (o *GetOIDListOK) GetPayload() *models.OidSourcePaginationResponse {
	return o.Payload
}

func (o *GetOIDListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.OidSourcePaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetOIDListTooManyRequests creates a GetOIDListTooManyRequests with default headers values
func NewGetOIDListTooManyRequests() *GetOIDListTooManyRequests {
	return &GetOIDListTooManyRequests{}
}

/*
GetOIDListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetOIDListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get o Id list too many requests response has a 2xx status code
func (o *GetOIDListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get o Id list too many requests response has a 3xx status code
func (o *GetOIDListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get o Id list too many requests response has a 4xx status code
func (o *GetOIDListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get o Id list too many requests response has a 5xx status code
func (o *GetOIDListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get o Id list too many requests response a status code equal to that given
func (o *GetOIDListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get o Id list too many requests response
func (o *GetOIDListTooManyRequests) Code() int {
	return 429
}

func (o *GetOIDListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/oids][%d] getOIdListTooManyRequests", 429)
}

func (o *GetOIDListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/oids][%d] getOIdListTooManyRequests", 429)
}

func (o *GetOIDListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetOIDListDefault creates a GetOIDListDefault with default headers values
func NewGetOIDListDefault(code int) *GetOIDListDefault {
	return &GetOIDListDefault{
		_statusCode: code,
	}
}

/*
GetOIDListDefault describes a response with status code -1, with default header values.

Error
*/
type GetOIDListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get o ID list default response has a 2xx status code
func (o *GetOIDListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get o ID list default response has a 3xx status code
func (o *GetOIDListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get o ID list default response has a 4xx status code
func (o *GetOIDListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get o ID list default response has a 5xx status code
func (o *GetOIDListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get o ID list default response a status code equal to that given
func (o *GetOIDListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get o ID list default response
func (o *GetOIDListDefault) Code() int {
	return o._statusCode
}

func (o *GetOIDListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids][%d] getOIDList default %s", o._statusCode, payload)
}

func (o *GetOIDListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids][%d] getOIDList default %s", o._statusCode, payload)
}

func (o *GetOIDListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetOIDListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
