// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetOidByIDJSONReader is a Reader for the GetOidByIDJSON structure.
type GetOidByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetOidByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetOidByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetOidByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetOidByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetOidByIDJSONOK creates a GetOidByIDJSONOK with default headers values
func NewGetOidByIDJSONOK() *GetOidByIDJSONOK {
	return &GetOidByIDJSONOK{}
}

/*
GetOidByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetOidByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get oid by Id Json o k response has a 2xx status code
func (o *GetOidByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get oid by Id Json o k response has a 3xx status code
func (o *GetOidByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get oid by Id Json o k response has a 4xx status code
func (o *GetOidByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get oid by Id Json o k response has a 5xx status code
func (o *GetOidByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get oid by Id Json o k response a status code equal to that given
func (o *GetOidByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get oid by Id Json o k response
func (o *GetOidByIDJSONOK) Code() int {
	return 200
}

func (o *GetOidByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids/{id}?__json=][%d] getOidByIdJsonOK %s", 200, payload)
}

func (o *GetOidByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids/{id}?__json=][%d] getOidByIdJsonOK %s", 200, payload)
}

func (o *GetOidByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetOidByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetOidByIDJSONTooManyRequests creates a GetOidByIDJSONTooManyRequests with default headers values
func NewGetOidByIDJSONTooManyRequests() *GetOidByIDJSONTooManyRequests {
	return &GetOidByIDJSONTooManyRequests{}
}

/*
GetOidByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetOidByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get oid by Id Json too many requests response has a 2xx status code
func (o *GetOidByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get oid by Id Json too many requests response has a 3xx status code
func (o *GetOidByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get oid by Id Json too many requests response has a 4xx status code
func (o *GetOidByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get oid by Id Json too many requests response has a 5xx status code
func (o *GetOidByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get oid by Id Json too many requests response a status code equal to that given
func (o *GetOidByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get oid by Id Json too many requests response
func (o *GetOidByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetOidByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/oids/{id}?__json=][%d] getOidByIdJsonTooManyRequests", 429)
}

func (o *GetOidByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/oids/{id}?__json=][%d] getOidByIdJsonTooManyRequests", 429)
}

func (o *GetOidByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetOidByIDJSONDefault creates a GetOidByIDJSONDefault with default headers values
func NewGetOidByIDJSONDefault(code int) *GetOidByIDJSONDefault {
	return &GetOidByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetOidByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetOidByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get oid by Id Json default response has a 2xx status code
func (o *GetOidByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get oid by Id Json default response has a 3xx status code
func (o *GetOidByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get oid by Id Json default response has a 4xx status code
func (o *GetOidByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get oid by Id Json default response has a 5xx status code
func (o *GetOidByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get oid by Id Json default response a status code equal to that given
func (o *GetOidByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get oid by Id Json default response
func (o *GetOidByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetOidByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids/{id}?__json=][%d] getOidByIdJson default %s", o._statusCode, payload)
}

func (o *GetOidByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids/{id}?__json=][%d] getOidByIdJson default %s", o._statusCode, payload)
}

func (o *GetOidByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetOidByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
