// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetOpsNoteByIDReader is a Reader for the GetOpsNoteByID structure.
type GetOpsNoteByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetOpsNoteByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetOpsNoteByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetOpsNoteByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetOpsNoteByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetOpsNoteByIDOK creates a GetOpsNoteByIDOK with default headers values
func NewGetOpsNoteByIDOK() *GetOpsNoteByIDOK {
	return &GetOpsNoteByIDOK{}
}

/*
GetOpsNoteByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetOpsNoteByIDOK struct {
	Payload *models.OpsNote
}

// IsSuccess returns true when this get ops note by Id o k response has a 2xx status code
func (o *GetOpsNoteByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get ops note by Id o k response has a 3xx status code
func (o *GetOpsNoteByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get ops note by Id o k response has a 4xx status code
func (o *GetOpsNoteByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get ops note by Id o k response has a 5xx status code
func (o *GetOpsNoteByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get ops note by Id o k response a status code equal to that given
func (o *GetOpsNoteByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get ops note by Id o k response
func (o *GetOpsNoteByIDOK) Code() int {
	return 200
}

func (o *GetOpsNoteByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/opsnotes/{id}][%d] getOpsNoteByIdOK %s", 200, payload)
}

func (o *GetOpsNoteByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/opsnotes/{id}][%d] getOpsNoteByIdOK %s", 200, payload)
}

func (o *GetOpsNoteByIDOK) GetPayload() *models.OpsNote {
	return o.Payload
}

func (o *GetOpsNoteByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.OpsNote)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetOpsNoteByIDTooManyRequests creates a GetOpsNoteByIDTooManyRequests with default headers values
func NewGetOpsNoteByIDTooManyRequests() *GetOpsNoteByIDTooManyRequests {
	return &GetOpsNoteByIDTooManyRequests{}
}

/*
GetOpsNoteByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetOpsNoteByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get ops note by Id too many requests response has a 2xx status code
func (o *GetOpsNoteByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get ops note by Id too many requests response has a 3xx status code
func (o *GetOpsNoteByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get ops note by Id too many requests response has a 4xx status code
func (o *GetOpsNoteByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get ops note by Id too many requests response has a 5xx status code
func (o *GetOpsNoteByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get ops note by Id too many requests response a status code equal to that given
func (o *GetOpsNoteByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get ops note by Id too many requests response
func (o *GetOpsNoteByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetOpsNoteByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/opsnotes/{id}][%d] getOpsNoteByIdTooManyRequests", 429)
}

func (o *GetOpsNoteByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/opsnotes/{id}][%d] getOpsNoteByIdTooManyRequests", 429)
}

func (o *GetOpsNoteByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetOpsNoteByIDDefault creates a GetOpsNoteByIDDefault with default headers values
func NewGetOpsNoteByIDDefault(code int) *GetOpsNoteByIDDefault {
	return &GetOpsNoteByIDDefault{
		_statusCode: code,
	}
}

/*
GetOpsNoteByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetOpsNoteByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get ops note by Id default response has a 2xx status code
func (o *GetOpsNoteByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get ops note by Id default response has a 3xx status code
func (o *GetOpsNoteByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get ops note by Id default response has a 4xx status code
func (o *GetOpsNoteByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get ops note by Id default response has a 5xx status code
func (o *GetOpsNoteByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get ops note by Id default response a status code equal to that given
func (o *GetOpsNoteByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get ops note by Id default response
func (o *GetOpsNoteByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetOpsNoteByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/opsnotes/{id}][%d] getOpsNoteById default %s", o._statusCode, payload)
}

func (o *GetOpsNoteByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/opsnotes/{id}][%d] getOpsNoteById default %s", o._statusCode, payload)
}

func (o *GetOpsNoteByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetOpsNoteByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
