// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetOpsNoteListReader is a Reader for the GetOpsNoteList structure.
type GetOpsNoteListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetOpsNoteListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetOpsNoteListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetOpsNoteListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetOpsNoteListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetOpsNoteListOK creates a GetOpsNoteListOK with default headers values
func NewGetOpsNoteListOK() *GetOpsNoteListOK {
	return &GetOpsNoteListOK{}
}

/*
GetOpsNoteListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetOpsNoteListOK struct {
	Payload *models.OpsNotePaginationResponse
}

// IsSuccess returns true when this get ops note list o k response has a 2xx status code
func (o *GetOpsNoteListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get ops note list o k response has a 3xx status code
func (o *GetOpsNoteListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get ops note list o k response has a 4xx status code
func (o *GetOpsNoteListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get ops note list o k response has a 5xx status code
func (o *GetOpsNoteListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get ops note list o k response a status code equal to that given
func (o *GetOpsNoteListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get ops note list o k response
func (o *GetOpsNoteListOK) Code() int {
	return 200
}

func (o *GetOpsNoteListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/opsnotes][%d] getOpsNoteListOK %s", 200, payload)
}

func (o *GetOpsNoteListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/opsnotes][%d] getOpsNoteListOK %s", 200, payload)
}

func (o *GetOpsNoteListOK) GetPayload() *models.OpsNotePaginationResponse {
	return o.Payload
}

func (o *GetOpsNoteListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.OpsNotePaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetOpsNoteListTooManyRequests creates a GetOpsNoteListTooManyRequests with default headers values
func NewGetOpsNoteListTooManyRequests() *GetOpsNoteListTooManyRequests {
	return &GetOpsNoteListTooManyRequests{}
}

/*
GetOpsNoteListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetOpsNoteListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get ops note list too many requests response has a 2xx status code
func (o *GetOpsNoteListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get ops note list too many requests response has a 3xx status code
func (o *GetOpsNoteListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get ops note list too many requests response has a 4xx status code
func (o *GetOpsNoteListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get ops note list too many requests response has a 5xx status code
func (o *GetOpsNoteListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get ops note list too many requests response a status code equal to that given
func (o *GetOpsNoteListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get ops note list too many requests response
func (o *GetOpsNoteListTooManyRequests) Code() int {
	return 429
}

func (o *GetOpsNoteListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/opsnotes][%d] getOpsNoteListTooManyRequests", 429)
}

func (o *GetOpsNoteListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/opsnotes][%d] getOpsNoteListTooManyRequests", 429)
}

func (o *GetOpsNoteListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetOpsNoteListDefault creates a GetOpsNoteListDefault with default headers values
func NewGetOpsNoteListDefault(code int) *GetOpsNoteListDefault {
	return &GetOpsNoteListDefault{
		_statusCode: code,
	}
}

/*
GetOpsNoteListDefault describes a response with status code -1, with default header values.

Error
*/
type GetOpsNoteListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get ops note list default response has a 2xx status code
func (o *GetOpsNoteListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get ops note list default response has a 3xx status code
func (o *GetOpsNoteListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get ops note list default response has a 4xx status code
func (o *GetOpsNoteListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get ops note list default response has a 5xx status code
func (o *GetOpsNoteListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get ops note list default response a status code equal to that given
func (o *GetOpsNoteListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get ops note list default response
func (o *GetOpsNoteListDefault) Code() int {
	return o._statusCode
}

func (o *GetOpsNoteListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/opsnotes][%d] getOpsNoteList default %s", o._statusCode, payload)
}

func (o *GetOpsNoteListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/opsnotes][%d] getOpsNoteList default %s", o._statusCode, payload)
}

func (o *GetOpsNoteListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetOpsNoteListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
