// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetPartitionByIDReader is a Reader for the GetPartitionByID structure.
type GetPartitionByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPartitionByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPartitionByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetPartitionByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetPartitionByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetPartitionByIDOK creates a GetPartitionByIDOK with default headers values
func NewGetPartitionByIDOK() *GetPartitionByIDOK {
	return &GetPartitionByIDOK{}
}

/*
GetPartitionByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetPartitionByIDOK struct {
	Payload *models.LogPartition
}

// IsSuccess returns true when this get partition by Id o k response has a 2xx status code
func (o *GetPartitionByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get partition by Id o k response has a 3xx status code
func (o *GetPartitionByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get partition by Id o k response has a 4xx status code
func (o *GetPartitionByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get partition by Id o k response has a 5xx status code
func (o *GetPartitionByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get partition by Id o k response a status code equal to that given
func (o *GetPartitionByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get partition by Id o k response
func (o *GetPartitionByIDOK) Code() int {
	return 200
}

func (o *GetPartitionByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /log/partitions/{id}][%d] getPartitionByIdOK %s", 200, payload)
}

func (o *GetPartitionByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /log/partitions/{id}][%d] getPartitionByIdOK %s", 200, payload)
}

func (o *GetPartitionByIDOK) GetPayload() *models.LogPartition {
	return o.Payload
}

func (o *GetPartitionByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LogPartition)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPartitionByIDTooManyRequests creates a GetPartitionByIDTooManyRequests with default headers values
func NewGetPartitionByIDTooManyRequests() *GetPartitionByIDTooManyRequests {
	return &GetPartitionByIDTooManyRequests{}
}

/*
GetPartitionByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetPartitionByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get partition by Id too many requests response has a 2xx status code
func (o *GetPartitionByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get partition by Id too many requests response has a 3xx status code
func (o *GetPartitionByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get partition by Id too many requests response has a 4xx status code
func (o *GetPartitionByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get partition by Id too many requests response has a 5xx status code
func (o *GetPartitionByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get partition by Id too many requests response a status code equal to that given
func (o *GetPartitionByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get partition by Id too many requests response
func (o *GetPartitionByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetPartitionByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /log/partitions/{id}][%d] getPartitionByIdTooManyRequests", 429)
}

func (o *GetPartitionByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /log/partitions/{id}][%d] getPartitionByIdTooManyRequests", 429)
}

func (o *GetPartitionByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetPartitionByIDDefault creates a GetPartitionByIDDefault with default headers values
func NewGetPartitionByIDDefault(code int) *GetPartitionByIDDefault {
	return &GetPartitionByIDDefault{
		_statusCode: code,
	}
}

/*
GetPartitionByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetPartitionByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get partition by Id default response has a 2xx status code
func (o *GetPartitionByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get partition by Id default response has a 3xx status code
func (o *GetPartitionByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get partition by Id default response has a 4xx status code
func (o *GetPartitionByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get partition by Id default response has a 5xx status code
func (o *GetPartitionByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get partition by Id default response a status code equal to that given
func (o *GetPartitionByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get partition by Id default response
func (o *GetPartitionByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetPartitionByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /log/partitions/{id}][%d] getPartitionById default %s", o._statusCode, payload)
}

func (o *GetPartitionByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /log/partitions/{id}][%d] getPartitionById default %s", o._statusCode, payload)
}

func (o *GetPartitionByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetPartitionByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
