// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetPropertyRulesByIDReader is a Reader for the GetPropertyRulesByID structure.
type GetPropertyRulesByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPropertyRulesByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPropertyRulesByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetPropertyRulesByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetPropertyRulesByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetPropertyRulesByIDOK creates a GetPropertyRulesByIDOK with default headers values
func NewGetPropertyRulesByIDOK() *GetPropertyRulesByIDOK {
	return &GetPropertyRulesByIDOK{}
}

/*
GetPropertyRulesByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetPropertyRulesByIDOK struct {
	Payload *models.PropertyRule
}

// IsSuccess returns true when this get property rules by Id o k response has a 2xx status code
func (o *GetPropertyRulesByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get property rules by Id o k response has a 3xx status code
func (o *GetPropertyRulesByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get property rules by Id o k response has a 4xx status code
func (o *GetPropertyRulesByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get property rules by Id o k response has a 5xx status code
func (o *GetPropertyRulesByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get property rules by Id o k response a status code equal to that given
func (o *GetPropertyRulesByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get property rules by Id o k response
func (o *GetPropertyRulesByIDOK) Code() int {
	return 200
}

func (o *GetPropertyRulesByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules/{id}][%d] getPropertyRulesByIdOK %s", 200, payload)
}

func (o *GetPropertyRulesByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules/{id}][%d] getPropertyRulesByIdOK %s", 200, payload)
}

func (o *GetPropertyRulesByIDOK) GetPayload() *models.PropertyRule {
	return o.Payload
}

func (o *GetPropertyRulesByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.PropertyRule)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPropertyRulesByIDTooManyRequests creates a GetPropertyRulesByIDTooManyRequests with default headers values
func NewGetPropertyRulesByIDTooManyRequests() *GetPropertyRulesByIDTooManyRequests {
	return &GetPropertyRulesByIDTooManyRequests{}
}

/*
GetPropertyRulesByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetPropertyRulesByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get property rules by Id too many requests response has a 2xx status code
func (o *GetPropertyRulesByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get property rules by Id too many requests response has a 3xx status code
func (o *GetPropertyRulesByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get property rules by Id too many requests response has a 4xx status code
func (o *GetPropertyRulesByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get property rules by Id too many requests response has a 5xx status code
func (o *GetPropertyRulesByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get property rules by Id too many requests response a status code equal to that given
func (o *GetPropertyRulesByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get property rules by Id too many requests response
func (o *GetPropertyRulesByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetPropertyRulesByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/propertyrules/{id}][%d] getPropertyRulesByIdTooManyRequests", 429)
}

func (o *GetPropertyRulesByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/propertyrules/{id}][%d] getPropertyRulesByIdTooManyRequests", 429)
}

func (o *GetPropertyRulesByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetPropertyRulesByIDDefault creates a GetPropertyRulesByIDDefault with default headers values
func NewGetPropertyRulesByIDDefault(code int) *GetPropertyRulesByIDDefault {
	return &GetPropertyRulesByIDDefault{
		_statusCode: code,
	}
}

/*
GetPropertyRulesByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetPropertyRulesByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get property rules by Id default response has a 2xx status code
func (o *GetPropertyRulesByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get property rules by Id default response has a 3xx status code
func (o *GetPropertyRulesByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get property rules by Id default response has a 4xx status code
func (o *GetPropertyRulesByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get property rules by Id default response has a 5xx status code
func (o *GetPropertyRulesByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get property rules by Id default response a status code equal to that given
func (o *GetPropertyRulesByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get property rules by Id default response
func (o *GetPropertyRulesByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetPropertyRulesByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules/{id}][%d] getPropertyRulesById default %s", o._statusCode, payload)
}

func (o *GetPropertyRulesByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules/{id}][%d] getPropertyRulesById default %s", o._statusCode, payload)
}

func (o *GetPropertyRulesByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetPropertyRulesByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
