// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetPropertyRulesListJSONReader is a Reader for the GetPropertyRulesListJSON structure.
type GetPropertyRulesListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPropertyRulesListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPropertyRulesListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetPropertyRulesListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetPropertyRulesListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetPropertyRulesListJSONOK creates a GetPropertyRulesListJSONOK with default headers values
func NewGetPropertyRulesListJSONOK() *GetPropertyRulesListJSONOK {
	return &GetPropertyRulesListJSONOK{}
}

/*
GetPropertyRulesListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetPropertyRulesListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get property rules list Json o k response has a 2xx status code
func (o *GetPropertyRulesListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get property rules list Json o k response has a 3xx status code
func (o *GetPropertyRulesListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get property rules list Json o k response has a 4xx status code
func (o *GetPropertyRulesListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get property rules list Json o k response has a 5xx status code
func (o *GetPropertyRulesListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get property rules list Json o k response a status code equal to that given
func (o *GetPropertyRulesListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get property rules list Json o k response
func (o *GetPropertyRulesListJSONOK) Code() int {
	return 200
}

func (o *GetPropertyRulesListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules?__json=][%d] getPropertyRulesListJsonOK %s", 200, payload)
}

func (o *GetPropertyRulesListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules?__json=][%d] getPropertyRulesListJsonOK %s", 200, payload)
}

func (o *GetPropertyRulesListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetPropertyRulesListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPropertyRulesListJSONTooManyRequests creates a GetPropertyRulesListJSONTooManyRequests with default headers values
func NewGetPropertyRulesListJSONTooManyRequests() *GetPropertyRulesListJSONTooManyRequests {
	return &GetPropertyRulesListJSONTooManyRequests{}
}

/*
GetPropertyRulesListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetPropertyRulesListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get property rules list Json too many requests response has a 2xx status code
func (o *GetPropertyRulesListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get property rules list Json too many requests response has a 3xx status code
func (o *GetPropertyRulesListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get property rules list Json too many requests response has a 4xx status code
func (o *GetPropertyRulesListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get property rules list Json too many requests response has a 5xx status code
func (o *GetPropertyRulesListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get property rules list Json too many requests response a status code equal to that given
func (o *GetPropertyRulesListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get property rules list Json too many requests response
func (o *GetPropertyRulesListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetPropertyRulesListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/propertyrules?__json=][%d] getPropertyRulesListJsonTooManyRequests", 429)
}

func (o *GetPropertyRulesListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/propertyrules?__json=][%d] getPropertyRulesListJsonTooManyRequests", 429)
}

func (o *GetPropertyRulesListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetPropertyRulesListJSONDefault creates a GetPropertyRulesListJSONDefault with default headers values
func NewGetPropertyRulesListJSONDefault(code int) *GetPropertyRulesListJSONDefault {
	return &GetPropertyRulesListJSONDefault{
		_statusCode: code,
	}
}

/*
GetPropertyRulesListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetPropertyRulesListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get property rules list Json default response has a 2xx status code
func (o *GetPropertyRulesListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get property rules list Json default response has a 3xx status code
func (o *GetPropertyRulesListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get property rules list Json default response has a 4xx status code
func (o *GetPropertyRulesListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get property rules list Json default response has a 5xx status code
func (o *GetPropertyRulesListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get property rules list Json default response a status code equal to that given
func (o *GetPropertyRulesListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get property rules list Json default response
func (o *GetPropertyRulesListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetPropertyRulesListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules?__json=][%d] getPropertyRulesListJson default %s", o._statusCode, payload)
}

func (o *GetPropertyRulesListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules?__json=][%d] getPropertyRulesListJson default %s", o._statusCode, payload)
}

func (o *GetPropertyRulesListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetPropertyRulesListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
