// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetPropertyRulesListReader is a Reader for the GetPropertyRulesList structure.
type GetPropertyRulesListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPropertyRulesListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPropertyRulesListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetPropertyRulesListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetPropertyRulesListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetPropertyRulesListOK creates a GetPropertyRulesListOK with default headers values
func NewGetPropertyRulesListOK() *GetPropertyRulesListOK {
	return &GetPropertyRulesListOK{}
}

/*
GetPropertyRulesListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetPropertyRulesListOK struct {
	Payload *models.PropertyRulePaginationResponse
}

// IsSuccess returns true when this get property rules list o k response has a 2xx status code
func (o *GetPropertyRulesListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get property rules list o k response has a 3xx status code
func (o *GetPropertyRulesListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get property rules list o k response has a 4xx status code
func (o *GetPropertyRulesListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get property rules list o k response has a 5xx status code
func (o *GetPropertyRulesListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get property rules list o k response a status code equal to that given
func (o *GetPropertyRulesListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get property rules list o k response
func (o *GetPropertyRulesListOK) Code() int {
	return 200
}

func (o *GetPropertyRulesListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules][%d] getPropertyRulesListOK %s", 200, payload)
}

func (o *GetPropertyRulesListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules][%d] getPropertyRulesListOK %s", 200, payload)
}

func (o *GetPropertyRulesListOK) GetPayload() *models.PropertyRulePaginationResponse {
	return o.Payload
}

func (o *GetPropertyRulesListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.PropertyRulePaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPropertyRulesListTooManyRequests creates a GetPropertyRulesListTooManyRequests with default headers values
func NewGetPropertyRulesListTooManyRequests() *GetPropertyRulesListTooManyRequests {
	return &GetPropertyRulesListTooManyRequests{}
}

/*
GetPropertyRulesListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetPropertyRulesListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get property rules list too many requests response has a 2xx status code
func (o *GetPropertyRulesListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get property rules list too many requests response has a 3xx status code
func (o *GetPropertyRulesListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get property rules list too many requests response has a 4xx status code
func (o *GetPropertyRulesListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get property rules list too many requests response has a 5xx status code
func (o *GetPropertyRulesListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get property rules list too many requests response a status code equal to that given
func (o *GetPropertyRulesListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get property rules list too many requests response
func (o *GetPropertyRulesListTooManyRequests) Code() int {
	return 429
}

func (o *GetPropertyRulesListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/propertyrules][%d] getPropertyRulesListTooManyRequests", 429)
}

func (o *GetPropertyRulesListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/propertyrules][%d] getPropertyRulesListTooManyRequests", 429)
}

func (o *GetPropertyRulesListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetPropertyRulesListDefault creates a GetPropertyRulesListDefault with default headers values
func NewGetPropertyRulesListDefault(code int) *GetPropertyRulesListDefault {
	return &GetPropertyRulesListDefault{
		_statusCode: code,
	}
}

/*
GetPropertyRulesListDefault describes a response with status code -1, with default header values.

Error
*/
type GetPropertyRulesListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get property rules list default response has a 2xx status code
func (o *GetPropertyRulesListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get property rules list default response has a 3xx status code
func (o *GetPropertyRulesListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get property rules list default response has a 4xx status code
func (o *GetPropertyRulesListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get property rules list default response has a 5xx status code
func (o *GetPropertyRulesListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get property rules list default response a status code equal to that given
func (o *GetPropertyRulesListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get property rules list default response
func (o *GetPropertyRulesListDefault) Code() int {
	return o._statusCode
}

func (o *GetPropertyRulesListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules][%d] getPropertyRulesList default %s", o._statusCode, payload)
}

func (o *GetPropertyRulesListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/propertyrules][%d] getPropertyRulesList default %s", o._statusCode, payload)
}

func (o *GetPropertyRulesListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetPropertyRulesListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
