// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetRecipientGroupByIDReader is a Reader for the GetRecipientGroupByID structure.
type GetRecipientGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRecipientGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRecipientGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetRecipientGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetRecipientGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetRecipientGroupByIDOK creates a GetRecipientGroupByIDOK with default headers values
func NewGetRecipientGroupByIDOK() *GetRecipientGroupByIDOK {
	return &GetRecipientGroupByIDOK{}
}

/*
GetRecipientGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetRecipientGroupByIDOK struct {
	Payload *models.RecipientGroup
}

// IsSuccess returns true when this get recipient group by Id o k response has a 2xx status code
func (o *GetRecipientGroupByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get recipient group by Id o k response has a 3xx status code
func (o *GetRecipientGroupByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get recipient group by Id o k response has a 4xx status code
func (o *GetRecipientGroupByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get recipient group by Id o k response has a 5xx status code
func (o *GetRecipientGroupByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get recipient group by Id o k response a status code equal to that given
func (o *GetRecipientGroupByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get recipient group by Id o k response
func (o *GetRecipientGroupByIDOK) Code() int {
	return 200
}

func (o *GetRecipientGroupByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/recipientgroups/{id}][%d] getRecipientGroupByIdOK %s", 200, payload)
}

func (o *GetRecipientGroupByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/recipientgroups/{id}][%d] getRecipientGroupByIdOK %s", 200, payload)
}

func (o *GetRecipientGroupByIDOK) GetPayload() *models.RecipientGroup {
	return o.Payload
}

func (o *GetRecipientGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RecipientGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRecipientGroupByIDTooManyRequests creates a GetRecipientGroupByIDTooManyRequests with default headers values
func NewGetRecipientGroupByIDTooManyRequests() *GetRecipientGroupByIDTooManyRequests {
	return &GetRecipientGroupByIDTooManyRequests{}
}

/*
GetRecipientGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetRecipientGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get recipient group by Id too many requests response has a 2xx status code
func (o *GetRecipientGroupByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get recipient group by Id too many requests response has a 3xx status code
func (o *GetRecipientGroupByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get recipient group by Id too many requests response has a 4xx status code
func (o *GetRecipientGroupByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get recipient group by Id too many requests response has a 5xx status code
func (o *GetRecipientGroupByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get recipient group by Id too many requests response a status code equal to that given
func (o *GetRecipientGroupByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get recipient group by Id too many requests response
func (o *GetRecipientGroupByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetRecipientGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/recipientgroups/{id}][%d] getRecipientGroupByIdTooManyRequests", 429)
}

func (o *GetRecipientGroupByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/recipientgroups/{id}][%d] getRecipientGroupByIdTooManyRequests", 429)
}

func (o *GetRecipientGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetRecipientGroupByIDDefault creates a GetRecipientGroupByIDDefault with default headers values
func NewGetRecipientGroupByIDDefault(code int) *GetRecipientGroupByIDDefault {
	return &GetRecipientGroupByIDDefault{
		_statusCode: code,
	}
}

/*
GetRecipientGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetRecipientGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get recipient group by Id default response has a 2xx status code
func (o *GetRecipientGroupByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get recipient group by Id default response has a 3xx status code
func (o *GetRecipientGroupByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get recipient group by Id default response has a 4xx status code
func (o *GetRecipientGroupByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get recipient group by Id default response has a 5xx status code
func (o *GetRecipientGroupByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get recipient group by Id default response a status code equal to that given
func (o *GetRecipientGroupByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get recipient group by Id default response
func (o *GetRecipientGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetRecipientGroupByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/recipientgroups/{id}][%d] getRecipientGroupById default %s", o._statusCode, payload)
}

func (o *GetRecipientGroupByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/recipientgroups/{id}][%d] getRecipientGroupById default %s", o._statusCode, payload)
}

func (o *GetRecipientGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetRecipientGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
