// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetReportGroupByIDReader is a Reader for the GetReportGroupByID structure.
type GetReportGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetReportGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetReportGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetReportGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetReportGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetReportGroupByIDOK creates a GetReportGroupByIDOK with default headers values
func NewGetReportGroupByIDOK() *GetReportGroupByIDOK {
	return &GetReportGroupByIDOK{}
}

/*
GetReportGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetReportGroupByIDOK struct {
	Payload *models.ReportGroup
}

// IsSuccess returns true when this get report group by Id o k response has a 2xx status code
func (o *GetReportGroupByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get report group by Id o k response has a 3xx status code
func (o *GetReportGroupByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get report group by Id o k response has a 4xx status code
func (o *GetReportGroupByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get report group by Id o k response has a 5xx status code
func (o *GetReportGroupByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get report group by Id o k response a status code equal to that given
func (o *GetReportGroupByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get report group by Id o k response
func (o *GetReportGroupByIDOK) Code() int {
	return 200
}

func (o *GetReportGroupByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/groups/{id}][%d] getReportGroupByIdOK %s", 200, payload)
}

func (o *GetReportGroupByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/groups/{id}][%d] getReportGroupByIdOK %s", 200, payload)
}

func (o *GetReportGroupByIDOK) GetPayload() *models.ReportGroup {
	return o.Payload
}

func (o *GetReportGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ReportGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetReportGroupByIDTooManyRequests creates a GetReportGroupByIDTooManyRequests with default headers values
func NewGetReportGroupByIDTooManyRequests() *GetReportGroupByIDTooManyRequests {
	return &GetReportGroupByIDTooManyRequests{}
}

/*
GetReportGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetReportGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get report group by Id too many requests response has a 2xx status code
func (o *GetReportGroupByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get report group by Id too many requests response has a 3xx status code
func (o *GetReportGroupByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get report group by Id too many requests response has a 4xx status code
func (o *GetReportGroupByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get report group by Id too many requests response has a 5xx status code
func (o *GetReportGroupByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get report group by Id too many requests response a status code equal to that given
func (o *GetReportGroupByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get report group by Id too many requests response
func (o *GetReportGroupByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetReportGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /report/groups/{id}][%d] getReportGroupByIdTooManyRequests", 429)
}

func (o *GetReportGroupByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /report/groups/{id}][%d] getReportGroupByIdTooManyRequests", 429)
}

func (o *GetReportGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetReportGroupByIDDefault creates a GetReportGroupByIDDefault with default headers values
func NewGetReportGroupByIDDefault(code int) *GetReportGroupByIDDefault {
	return &GetReportGroupByIDDefault{
		_statusCode: code,
	}
}

/*
GetReportGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetReportGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get report group by Id default response has a 2xx status code
func (o *GetReportGroupByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get report group by Id default response has a 3xx status code
func (o *GetReportGroupByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get report group by Id default response has a 4xx status code
func (o *GetReportGroupByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get report group by Id default response has a 5xx status code
func (o *GetReportGroupByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get report group by Id default response a status code equal to that given
func (o *GetReportGroupByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get report group by Id default response
func (o *GetReportGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetReportGroupByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/groups/{id}][%d] getReportGroupById default %s", o._statusCode, payload)
}

func (o *GetReportGroupByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/groups/{id}][%d] getReportGroupById default %s", o._statusCode, payload)
}

func (o *GetReportGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetReportGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
