// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetReportListJSONReader is a Reader for the GetReportListJSON structure.
type GetReportListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetReportListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetReportListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetReportListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetReportListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetReportListJSONOK creates a GetReportListJSONOK with default headers values
func NewGetReportListJSONOK() *GetReportListJSONOK {
	return &GetReportListJSONOK{}
}

/*
GetReportListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetReportListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get report list Json o k response has a 2xx status code
func (o *GetReportListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get report list Json o k response has a 3xx status code
func (o *GetReportListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get report list Json o k response has a 4xx status code
func (o *GetReportListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get report list Json o k response has a 5xx status code
func (o *GetReportListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get report list Json o k response a status code equal to that given
func (o *GetReportListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get report list Json o k response
func (o *GetReportListJSONOK) Code() int {
	return 200
}

func (o *GetReportListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports?__json=][%d] getReportListJsonOK %s", 200, payload)
}

func (o *GetReportListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports?__json=][%d] getReportListJsonOK %s", 200, payload)
}

func (o *GetReportListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetReportListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetReportListJSONTooManyRequests creates a GetReportListJSONTooManyRequests with default headers values
func NewGetReportListJSONTooManyRequests() *GetReportListJSONTooManyRequests {
	return &GetReportListJSONTooManyRequests{}
}

/*
GetReportListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetReportListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get report list Json too many requests response has a 2xx status code
func (o *GetReportListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get report list Json too many requests response has a 3xx status code
func (o *GetReportListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get report list Json too many requests response has a 4xx status code
func (o *GetReportListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get report list Json too many requests response has a 5xx status code
func (o *GetReportListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get report list Json too many requests response a status code equal to that given
func (o *GetReportListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get report list Json too many requests response
func (o *GetReportListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetReportListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /report/reports?__json=][%d] getReportListJsonTooManyRequests", 429)
}

func (o *GetReportListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /report/reports?__json=][%d] getReportListJsonTooManyRequests", 429)
}

func (o *GetReportListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetReportListJSONDefault creates a GetReportListJSONDefault with default headers values
func NewGetReportListJSONDefault(code int) *GetReportListJSONDefault {
	return &GetReportListJSONDefault{
		_statusCode: code,
	}
}

/*
GetReportListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetReportListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get report list Json default response has a 2xx status code
func (o *GetReportListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get report list Json default response has a 3xx status code
func (o *GetReportListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get report list Json default response has a 4xx status code
func (o *GetReportListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get report list Json default response has a 5xx status code
func (o *GetReportListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get report list Json default response a status code equal to that given
func (o *GetReportListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get report list Json default response
func (o *GetReportListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetReportListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports?__json=][%d] getReportListJson default %s", o._statusCode, payload)
}

func (o *GetReportListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports?__json=][%d] getReportListJson default %s", o._statusCode, payload)
}

func (o *GetReportListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetReportListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
