// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetRoleByIDJSONReader is a Reader for the GetRoleByIDJSON structure.
type GetRoleByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRoleByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRoleByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetRoleByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetRoleByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetRoleByIDJSONOK creates a GetRoleByIDJSONOK with default headers values
func NewGetRoleByIDJSONOK() *GetRoleByIDJSONOK {
	return &GetRoleByIDJSONOK{}
}

/*
GetRoleByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetRoleByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get role by Id Json o k response has a 2xx status code
func (o *GetRoleByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get role by Id Json o k response has a 3xx status code
func (o *GetRoleByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get role by Id Json o k response has a 4xx status code
func (o *GetRoleByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get role by Id Json o k response has a 5xx status code
func (o *GetRoleByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get role by Id Json o k response a status code equal to that given
func (o *GetRoleByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get role by Id Json o k response
func (o *GetRoleByIDJSONOK) Code() int {
	return 200
}

func (o *GetRoleByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/roles/{id}?__json=][%d] getRoleByIdJsonOK %s", 200, payload)
}

func (o *GetRoleByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/roles/{id}?__json=][%d] getRoleByIdJsonOK %s", 200, payload)
}

func (o *GetRoleByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetRoleByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRoleByIDJSONTooManyRequests creates a GetRoleByIDJSONTooManyRequests with default headers values
func NewGetRoleByIDJSONTooManyRequests() *GetRoleByIDJSONTooManyRequests {
	return &GetRoleByIDJSONTooManyRequests{}
}

/*
GetRoleByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetRoleByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get role by Id Json too many requests response has a 2xx status code
func (o *GetRoleByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get role by Id Json too many requests response has a 3xx status code
func (o *GetRoleByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get role by Id Json too many requests response has a 4xx status code
func (o *GetRoleByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get role by Id Json too many requests response has a 5xx status code
func (o *GetRoleByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get role by Id Json too many requests response a status code equal to that given
func (o *GetRoleByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get role by Id Json too many requests response
func (o *GetRoleByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetRoleByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/roles/{id}?__json=][%d] getRoleByIdJsonTooManyRequests", 429)
}

func (o *GetRoleByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/roles/{id}?__json=][%d] getRoleByIdJsonTooManyRequests", 429)
}

func (o *GetRoleByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetRoleByIDJSONDefault creates a GetRoleByIDJSONDefault with default headers values
func NewGetRoleByIDJSONDefault(code int) *GetRoleByIDJSONDefault {
	return &GetRoleByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetRoleByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetRoleByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get role by Id Json default response has a 2xx status code
func (o *GetRoleByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get role by Id Json default response has a 3xx status code
func (o *GetRoleByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get role by Id Json default response has a 4xx status code
func (o *GetRoleByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get role by Id Json default response has a 5xx status code
func (o *GetRoleByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get role by Id Json default response a status code equal to that given
func (o *GetRoleByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get role by Id Json default response
func (o *GetRoleByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetRoleByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/roles/{id}?__json=][%d] getRoleByIdJson default %s", o._statusCode, payload)
}

func (o *GetRoleByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/roles/{id}?__json=][%d] getRoleByIdJson default %s", o._statusCode, payload)
}

func (o *GetRoleByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetRoleByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
