// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetTopologySourceByIDReader is a Reader for the GetTopologySourceByID structure.
type GetTopologySourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTopologySourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTopologySourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetTopologySourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetTopologySourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetTopologySourceByIDOK creates a GetTopologySourceByIDOK with default headers values
func NewGetTopologySourceByIDOK() *GetTopologySourceByIDOK {
	return &GetTopologySourceByIDOK{}
}

/*
GetTopologySourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetTopologySourceByIDOK struct {
	Payload *models.TopologySource
}

// IsSuccess returns true when this get topology source by Id o k response has a 2xx status code
func (o *GetTopologySourceByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get topology source by Id o k response has a 3xx status code
func (o *GetTopologySourceByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get topology source by Id o k response has a 4xx status code
func (o *GetTopologySourceByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get topology source by Id o k response has a 5xx status code
func (o *GetTopologySourceByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get topology source by Id o k response a status code equal to that given
func (o *GetTopologySourceByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get topology source by Id o k response
func (o *GetTopologySourceByIDOK) Code() int {
	return 200
}

func (o *GetTopologySourceByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/topologysources/{id}][%d] getTopologySourceByIdOK %s", 200, payload)
}

func (o *GetTopologySourceByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/topologysources/{id}][%d] getTopologySourceByIdOK %s", 200, payload)
}

func (o *GetTopologySourceByIDOK) GetPayload() *models.TopologySource {
	return o.Payload
}

func (o *GetTopologySourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.TopologySource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTopologySourceByIDTooManyRequests creates a GetTopologySourceByIDTooManyRequests with default headers values
func NewGetTopologySourceByIDTooManyRequests() *GetTopologySourceByIDTooManyRequests {
	return &GetTopologySourceByIDTooManyRequests{}
}

/*
GetTopologySourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetTopologySourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get topology source by Id too many requests response has a 2xx status code
func (o *GetTopologySourceByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get topology source by Id too many requests response has a 3xx status code
func (o *GetTopologySourceByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get topology source by Id too many requests response has a 4xx status code
func (o *GetTopologySourceByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get topology source by Id too many requests response has a 5xx status code
func (o *GetTopologySourceByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get topology source by Id too many requests response a status code equal to that given
func (o *GetTopologySourceByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get topology source by Id too many requests response
func (o *GetTopologySourceByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetTopologySourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/topologysources/{id}][%d] getTopologySourceByIdTooManyRequests", 429)
}

func (o *GetTopologySourceByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/topologysources/{id}][%d] getTopologySourceByIdTooManyRequests", 429)
}

func (o *GetTopologySourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetTopologySourceByIDDefault creates a GetTopologySourceByIDDefault with default headers values
func NewGetTopologySourceByIDDefault(code int) *GetTopologySourceByIDDefault {
	return &GetTopologySourceByIDDefault{
		_statusCode: code,
	}
}

/*
GetTopologySourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetTopologySourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get topology source by Id default response has a 2xx status code
func (o *GetTopologySourceByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get topology source by Id default response has a 3xx status code
func (o *GetTopologySourceByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get topology source by Id default response has a 4xx status code
func (o *GetTopologySourceByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get topology source by Id default response has a 5xx status code
func (o *GetTopologySourceByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get topology source by Id default response a status code equal to that given
func (o *GetTopologySourceByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get topology source by Id default response
func (o *GetTopologySourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetTopologySourceByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/topologysources/{id}][%d] getTopologySourceById default %s", o._statusCode, payload)
}

func (o *GetTopologySourceByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/topologysources/{id}][%d] getTopologySourceById default %s", o._statusCode, payload)
}

func (o *GetTopologySourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetTopologySourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
