// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetV4MetadataParams creates a new GetV4MetadataParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetV4MetadataParams() *GetV4MetadataParams {
	return &GetV4MetadataParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetV4MetadataParamsWithTimeout creates a new GetV4MetadataParams object
// with the ability to set a timeout on a request.
func NewGetV4MetadataParamsWithTimeout(timeout time.Duration) *GetV4MetadataParams {
	return &GetV4MetadataParams{
		timeout: timeout,
	}
}

// NewGetV4MetadataParamsWithContext creates a new GetV4MetadataParams object
// with the ability to set a context for a request.
func NewGetV4MetadataParamsWithContext(ctx context.Context) *GetV4MetadataParams {
	return &GetV4MetadataParams{
		Context: ctx,
	}
}

// NewGetV4MetadataParamsWithHTTPClient creates a new GetV4MetadataParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetV4MetadataParamsWithHTTPClient(client *http.Client) *GetV4MetadataParams {
	return &GetV4MetadataParams{
		HTTPClient: client,
	}
}

/*
GetV4MetadataParams contains all the parameters to send to the API endpoint

	for the get v4 metadata operation.

	Typically these are written to a http.Request.
*/
type GetV4MetadataParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get v4 metadata params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetV4MetadataParams) WithDefaults() *GetV4MetadataParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get v4 metadata params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetV4MetadataParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := GetV4MetadataParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get v4 metadata params
func (o *GetV4MetadataParams) WithTimeout(timeout time.Duration) *GetV4MetadataParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get v4 metadata params
func (o *GetV4MetadataParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get v4 metadata params
func (o *GetV4MetadataParams) WithContext(ctx context.Context) *GetV4MetadataParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get v4 metadata params
func (o *GetV4MetadataParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get v4 metadata params
func (o *GetV4MetadataParams) WithHTTPClient(client *http.Client) *GetV4MetadataParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get v4 metadata params
func (o *GetV4MetadataParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the get v4 metadata params
func (o *GetV4MetadataParams) WithUserAgent(userAgent *string) *GetV4MetadataParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get v4 metadata params
func (o *GetV4MetadataParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetV4MetadataParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
