// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetWebsiteByIDJSONReader is a Reader for the GetWebsiteByIDJSON structure.
type GetWebsiteByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWebsiteByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetWebsiteByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetWebsiteByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetWebsiteByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetWebsiteByIDJSONOK creates a GetWebsiteByIDJSONOK with default headers values
func NewGetWebsiteByIDJSONOK() *GetWebsiteByIDJSONOK {
	return &GetWebsiteByIDJSONOK{}
}

/*
GetWebsiteByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetWebsiteByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get website by Id Json o k response has a 2xx status code
func (o *GetWebsiteByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get website by Id Json o k response has a 3xx status code
func (o *GetWebsiteByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get website by Id Json o k response has a 4xx status code
func (o *GetWebsiteByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get website by Id Json o k response has a 5xx status code
func (o *GetWebsiteByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get website by Id Json o k response a status code equal to that given
func (o *GetWebsiteByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get website by Id Json o k response
func (o *GetWebsiteByIDJSONOK) Code() int {
	return 200
}

func (o *GetWebsiteByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites/{id}?__json=][%d] getWebsiteByIdJsonOK %s", 200, payload)
}

func (o *GetWebsiteByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites/{id}?__json=][%d] getWebsiteByIdJsonOK %s", 200, payload)
}

func (o *GetWebsiteByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetWebsiteByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWebsiteByIDJSONTooManyRequests creates a GetWebsiteByIDJSONTooManyRequests with default headers values
func NewGetWebsiteByIDJSONTooManyRequests() *GetWebsiteByIDJSONTooManyRequests {
	return &GetWebsiteByIDJSONTooManyRequests{}
}

/*
GetWebsiteByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetWebsiteByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get website by Id Json too many requests response has a 2xx status code
func (o *GetWebsiteByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get website by Id Json too many requests response has a 3xx status code
func (o *GetWebsiteByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get website by Id Json too many requests response has a 4xx status code
func (o *GetWebsiteByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get website by Id Json too many requests response has a 5xx status code
func (o *GetWebsiteByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get website by Id Json too many requests response a status code equal to that given
func (o *GetWebsiteByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get website by Id Json too many requests response
func (o *GetWebsiteByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetWebsiteByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /website/websites/{id}?__json=][%d] getWebsiteByIdJsonTooManyRequests", 429)
}

func (o *GetWebsiteByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /website/websites/{id}?__json=][%d] getWebsiteByIdJsonTooManyRequests", 429)
}

func (o *GetWebsiteByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetWebsiteByIDJSONDefault creates a GetWebsiteByIDJSONDefault with default headers values
func NewGetWebsiteByIDJSONDefault(code int) *GetWebsiteByIDJSONDefault {
	return &GetWebsiteByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetWebsiteByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetWebsiteByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get website by Id Json default response has a 2xx status code
func (o *GetWebsiteByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get website by Id Json default response has a 3xx status code
func (o *GetWebsiteByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get website by Id Json default response has a 4xx status code
func (o *GetWebsiteByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get website by Id Json default response has a 5xx status code
func (o *GetWebsiteByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get website by Id Json default response a status code equal to that given
func (o *GetWebsiteByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get website by Id Json default response
func (o *GetWebsiteByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetWebsiteByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites/{id}?__json=][%d] getWebsiteByIdJson default %s", o._statusCode, payload)
}

func (o *GetWebsiteByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites/{id}?__json=][%d] getWebsiteByIdJson default %s", o._statusCode, payload)
}

func (o *GetWebsiteByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetWebsiteByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
