// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetWebsiteGraphDataReader is a Reader for the GetWebsiteGraphData structure.
type GetWebsiteGraphDataReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWebsiteGraphDataReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetWebsiteGraphDataOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetWebsiteGraphDataTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetWebsiteGraphDataDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetWebsiteGraphDataOK creates a GetWebsiteGraphDataOK with default headers values
func NewGetWebsiteGraphDataOK() *GetWebsiteGraphDataOK {
	return &GetWebsiteGraphDataOK{}
}

/*
GetWebsiteGraphDataOK describes a response with status code 200, with default header values.

successful operation
*/
type GetWebsiteGraphDataOK struct {
	Payload *models.GraphPlot
}

// IsSuccess returns true when this get website graph data o k response has a 2xx status code
func (o *GetWebsiteGraphDataOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get website graph data o k response has a 3xx status code
func (o *GetWebsiteGraphDataOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get website graph data o k response has a 4xx status code
func (o *GetWebsiteGraphDataOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get website graph data o k response has a 5xx status code
func (o *GetWebsiteGraphDataOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get website graph data o k response a status code equal to that given
func (o *GetWebsiteGraphDataOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get website graph data o k response
func (o *GetWebsiteGraphDataOK) Code() int {
	return 200
}

func (o *GetWebsiteGraphDataOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data][%d] getWebsiteGraphDataOK %s", 200, payload)
}

func (o *GetWebsiteGraphDataOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data][%d] getWebsiteGraphDataOK %s", 200, payload)
}

func (o *GetWebsiteGraphDataOK) GetPayload() *models.GraphPlot {
	return o.Payload
}

func (o *GetWebsiteGraphDataOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.GraphPlot)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWebsiteGraphDataTooManyRequests creates a GetWebsiteGraphDataTooManyRequests with default headers values
func NewGetWebsiteGraphDataTooManyRequests() *GetWebsiteGraphDataTooManyRequests {
	return &GetWebsiteGraphDataTooManyRequests{}
}

/*
GetWebsiteGraphDataTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetWebsiteGraphDataTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get website graph data too many requests response has a 2xx status code
func (o *GetWebsiteGraphDataTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get website graph data too many requests response has a 3xx status code
func (o *GetWebsiteGraphDataTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get website graph data too many requests response has a 4xx status code
func (o *GetWebsiteGraphDataTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get website graph data too many requests response has a 5xx status code
func (o *GetWebsiteGraphDataTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get website graph data too many requests response a status code equal to that given
func (o *GetWebsiteGraphDataTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get website graph data too many requests response
func (o *GetWebsiteGraphDataTooManyRequests) Code() int {
	return 429
}

func (o *GetWebsiteGraphDataTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data][%d] getWebsiteGraphDataTooManyRequests", 429)
}

func (o *GetWebsiteGraphDataTooManyRequests) String() string {
	return fmt.Sprintf("[GET /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data][%d] getWebsiteGraphDataTooManyRequests", 429)
}

func (o *GetWebsiteGraphDataTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetWebsiteGraphDataDefault creates a GetWebsiteGraphDataDefault with default headers values
func NewGetWebsiteGraphDataDefault(code int) *GetWebsiteGraphDataDefault {
	return &GetWebsiteGraphDataDefault{
		_statusCode: code,
	}
}

/*
GetWebsiteGraphDataDefault describes a response with status code -1, with default header values.

Error
*/
type GetWebsiteGraphDataDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get website graph data default response has a 2xx status code
func (o *GetWebsiteGraphDataDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get website graph data default response has a 3xx status code
func (o *GetWebsiteGraphDataDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get website graph data default response has a 4xx status code
func (o *GetWebsiteGraphDataDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get website graph data default response has a 5xx status code
func (o *GetWebsiteGraphDataDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get website graph data default response a status code equal to that given
func (o *GetWebsiteGraphDataDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get website graph data default response
func (o *GetWebsiteGraphDataDefault) Code() int {
	return o._statusCode
}

func (o *GetWebsiteGraphDataDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data][%d] getWebsiteGraphData default %s", o._statusCode, payload)
}

func (o *GetWebsiteGraphDataDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites/{websiteId}/checkpoints/{checkpointId}/graphs/{graphName}/data][%d] getWebsiteGraphData default %s", o._statusCode, payload)
}

func (o *GetWebsiteGraphDataDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetWebsiteGraphDataDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
