// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetWebsiteListReader is a Reader for the GetWebsiteList structure.
type GetWebsiteListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWebsiteListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetWebsiteListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetWebsiteListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetWebsiteListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetWebsiteListOK creates a GetWebsiteListOK with default headers values
func NewGetWebsiteListOK() *GetWebsiteListOK {
	return &GetWebsiteListOK{}
}

/*
GetWebsiteListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetWebsiteListOK struct {
	Payload *models.WebsitePaginationResponse
}

// IsSuccess returns true when this get website list o k response has a 2xx status code
func (o *GetWebsiteListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get website list o k response has a 3xx status code
func (o *GetWebsiteListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get website list o k response has a 4xx status code
func (o *GetWebsiteListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get website list o k response has a 5xx status code
func (o *GetWebsiteListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get website list o k response a status code equal to that given
func (o *GetWebsiteListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get website list o k response
func (o *GetWebsiteListOK) Code() int {
	return 200
}

func (o *GetWebsiteListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites][%d] getWebsiteListOK %s", 200, payload)
}

func (o *GetWebsiteListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites][%d] getWebsiteListOK %s", 200, payload)
}

func (o *GetWebsiteListOK) GetPayload() *models.WebsitePaginationResponse {
	return o.Payload
}

func (o *GetWebsiteListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.WebsitePaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWebsiteListTooManyRequests creates a GetWebsiteListTooManyRequests with default headers values
func NewGetWebsiteListTooManyRequests() *GetWebsiteListTooManyRequests {
	return &GetWebsiteListTooManyRequests{}
}

/*
GetWebsiteListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetWebsiteListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get website list too many requests response has a 2xx status code
func (o *GetWebsiteListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get website list too many requests response has a 3xx status code
func (o *GetWebsiteListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get website list too many requests response has a 4xx status code
func (o *GetWebsiteListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get website list too many requests response has a 5xx status code
func (o *GetWebsiteListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get website list too many requests response a status code equal to that given
func (o *GetWebsiteListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get website list too many requests response
func (o *GetWebsiteListTooManyRequests) Code() int {
	return 429
}

func (o *GetWebsiteListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /website/websites][%d] getWebsiteListTooManyRequests", 429)
}

func (o *GetWebsiteListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /website/websites][%d] getWebsiteListTooManyRequests", 429)
}

func (o *GetWebsiteListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetWebsiteListDefault creates a GetWebsiteListDefault with default headers values
func NewGetWebsiteListDefault(code int) *GetWebsiteListDefault {
	return &GetWebsiteListDefault{
		_statusCode: code,
	}
}

/*
GetWebsiteListDefault describes a response with status code -1, with default header values.

Error
*/
type GetWebsiteListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get website list default response has a 2xx status code
func (o *GetWebsiteListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get website list default response has a 3xx status code
func (o *GetWebsiteListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get website list default response has a 4xx status code
func (o *GetWebsiteListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get website list default response has a 5xx status code
func (o *GetWebsiteListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get website list default response a status code equal to that given
func (o *GetWebsiteListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get website list default response
func (o *GetWebsiteListDefault) Code() int {
	return o._statusCode
}

func (o *GetWebsiteListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites][%d] getWebsiteList default %s", o._statusCode, payload)
}

func (o *GetWebsiteListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/websites][%d] getWebsiteList default %s", o._statusCode, payload)
}

func (o *GetWebsiteListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetWebsiteListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
