// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetWidgetListJSONReader is a Reader for the GetWidgetListJSON structure.
type GetWidgetListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWidgetListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetWidgetListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetWidgetListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetWidgetListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetWidgetListJSONOK creates a GetWidgetListJSONOK with default headers values
func NewGetWidgetListJSONOK() *GetWidgetListJSONOK {
	return &GetWidgetListJSONOK{}
}

/*
GetWidgetListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetWidgetListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get widget list Json o k response has a 2xx status code
func (o *GetWidgetListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get widget list Json o k response has a 3xx status code
func (o *GetWidgetListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get widget list Json o k response has a 4xx status code
func (o *GetWidgetListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get widget list Json o k response has a 5xx status code
func (o *GetWidgetListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get widget list Json o k response a status code equal to that given
func (o *GetWidgetListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get widget list Json o k response
func (o *GetWidgetListJSONOK) Code() int {
	return 200
}

func (o *GetWidgetListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets?__json=][%d] getWidgetListJsonOK %s", 200, payload)
}

func (o *GetWidgetListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets?__json=][%d] getWidgetListJsonOK %s", 200, payload)
}

func (o *GetWidgetListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetWidgetListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWidgetListJSONTooManyRequests creates a GetWidgetListJSONTooManyRequests with default headers values
func NewGetWidgetListJSONTooManyRequests() *GetWidgetListJSONTooManyRequests {
	return &GetWidgetListJSONTooManyRequests{}
}

/*
GetWidgetListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetWidgetListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get widget list Json too many requests response has a 2xx status code
func (o *GetWidgetListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get widget list Json too many requests response has a 3xx status code
func (o *GetWidgetListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get widget list Json too many requests response has a 4xx status code
func (o *GetWidgetListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get widget list Json too many requests response has a 5xx status code
func (o *GetWidgetListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get widget list Json too many requests response a status code equal to that given
func (o *GetWidgetListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get widget list Json too many requests response
func (o *GetWidgetListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetWidgetListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /dashboard/widgets?__json=][%d] getWidgetListJsonTooManyRequests", 429)
}

func (o *GetWidgetListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /dashboard/widgets?__json=][%d] getWidgetListJsonTooManyRequests", 429)
}

func (o *GetWidgetListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetWidgetListJSONDefault creates a GetWidgetListJSONDefault with default headers values
func NewGetWidgetListJSONDefault(code int) *GetWidgetListJSONDefault {
	return &GetWidgetListJSONDefault{
		_statusCode: code,
	}
}

/*
GetWidgetListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetWidgetListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get widget list Json default response has a 2xx status code
func (o *GetWidgetListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get widget list Json default response has a 3xx status code
func (o *GetWidgetListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get widget list Json default response has a 4xx status code
func (o *GetWidgetListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get widget list Json default response has a 5xx status code
func (o *GetWidgetListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get widget list Json default response a status code equal to that given
func (o *GetWidgetListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get widget list Json default response
func (o *GetWidgetListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetWidgetListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets?__json=][%d] getWidgetListJson default %s", o._statusCode, payload)
}

func (o *GetWidgetListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets?__json=][%d] getWidgetListJson default %s", o._statusCode, payload)
}

func (o *GetWidgetListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetWidgetListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
