// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// ImportDataSourceReader is a Reader for the ImportDataSource structure.
type ImportDataSourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ImportDataSourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewImportDataSourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewImportDataSourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewImportDataSourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewImportDataSourceOK creates a ImportDataSourceOK with default headers values
func NewImportDataSourceOK() *ImportDataSourceOK {
	return &ImportDataSourceOK{}
}

/*
ImportDataSourceOK describes a response with status code 200, with default header values.

successful operation
*/
type ImportDataSourceOK struct {
	Payload interface{}
}

// IsSuccess returns true when this import data source o k response has a 2xx status code
func (o *ImportDataSourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this import data source o k response has a 3xx status code
func (o *ImportDataSourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this import data source o k response has a 4xx status code
func (o *ImportDataSourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this import data source o k response has a 5xx status code
func (o *ImportDataSourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this import data source o k response a status code equal to that given
func (o *ImportDataSourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the import data source o k response
func (o *ImportDataSourceOK) Code() int {
	return 200
}

func (o *ImportDataSourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/datasources/importxml][%d] importDataSourceOK %s", 200, payload)
}

func (o *ImportDataSourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/datasources/importxml][%d] importDataSourceOK %s", 200, payload)
}

func (o *ImportDataSourceOK) GetPayload() interface{} {
	return o.Payload
}

func (o *ImportDataSourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewImportDataSourceTooManyRequests creates a ImportDataSourceTooManyRequests with default headers values
func NewImportDataSourceTooManyRequests() *ImportDataSourceTooManyRequests {
	return &ImportDataSourceTooManyRequests{}
}

/*
ImportDataSourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type ImportDataSourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this import data source too many requests response has a 2xx status code
func (o *ImportDataSourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this import data source too many requests response has a 3xx status code
func (o *ImportDataSourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this import data source too many requests response has a 4xx status code
func (o *ImportDataSourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this import data source too many requests response has a 5xx status code
func (o *ImportDataSourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this import data source too many requests response a status code equal to that given
func (o *ImportDataSourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the import data source too many requests response
func (o *ImportDataSourceTooManyRequests) Code() int {
	return 429
}

func (o *ImportDataSourceTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/datasources/importxml][%d] importDataSourceTooManyRequests", 429)
}

func (o *ImportDataSourceTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/datasources/importxml][%d] importDataSourceTooManyRequests", 429)
}

func (o *ImportDataSourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewImportDataSourceDefault creates a ImportDataSourceDefault with default headers values
func NewImportDataSourceDefault(code int) *ImportDataSourceDefault {
	return &ImportDataSourceDefault{
		_statusCode: code,
	}
}

/*
ImportDataSourceDefault describes a response with status code -1, with default header values.

Error
*/
type ImportDataSourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this import data source default response has a 2xx status code
func (o *ImportDataSourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this import data source default response has a 3xx status code
func (o *ImportDataSourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this import data source default response has a 4xx status code
func (o *ImportDataSourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this import data source default response has a 5xx status code
func (o *ImportDataSourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this import data source default response a status code equal to that given
func (o *ImportDataSourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the import data source default response
func (o *ImportDataSourceDefault) Code() int {
	return o._statusCode
}

func (o *ImportDataSourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/datasources/importxml][%d] importDataSource default %s", o._statusCode, payload)
}

func (o *ImportDataSourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/datasources/importxml][%d] importDataSource default %s", o._statusCode, payload)
}

func (o *ImportDataSourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ImportDataSourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
