// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// ImportEventSourceReader is a Reader for the ImportEventSource structure.
type ImportEventSourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ImportEventSourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewImportEventSourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewImportEventSourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewImportEventSourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewImportEventSourceOK creates a ImportEventSourceOK with default headers values
func NewImportEventSourceOK() *ImportEventSourceOK {
	return &ImportEventSourceOK{}
}

/*
ImportEventSourceOK describes a response with status code 200, with default header values.

successful operation
*/
type ImportEventSourceOK struct {
	Payload interface{}
}

// IsSuccess returns true when this import event source o k response has a 2xx status code
func (o *ImportEventSourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this import event source o k response has a 3xx status code
func (o *ImportEventSourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this import event source o k response has a 4xx status code
func (o *ImportEventSourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this import event source o k response has a 5xx status code
func (o *ImportEventSourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this import event source o k response a status code equal to that given
func (o *ImportEventSourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the import event source o k response
func (o *ImportEventSourceOK) Code() int {
	return 200
}

func (o *ImportEventSourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/eventsources/importxml][%d] importEventSourceOK %s", 200, payload)
}

func (o *ImportEventSourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/eventsources/importxml][%d] importEventSourceOK %s", 200, payload)
}

func (o *ImportEventSourceOK) GetPayload() interface{} {
	return o.Payload
}

func (o *ImportEventSourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewImportEventSourceTooManyRequests creates a ImportEventSourceTooManyRequests with default headers values
func NewImportEventSourceTooManyRequests() *ImportEventSourceTooManyRequests {
	return &ImportEventSourceTooManyRequests{}
}

/*
ImportEventSourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type ImportEventSourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this import event source too many requests response has a 2xx status code
func (o *ImportEventSourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this import event source too many requests response has a 3xx status code
func (o *ImportEventSourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this import event source too many requests response has a 4xx status code
func (o *ImportEventSourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this import event source too many requests response has a 5xx status code
func (o *ImportEventSourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this import event source too many requests response a status code equal to that given
func (o *ImportEventSourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the import event source too many requests response
func (o *ImportEventSourceTooManyRequests) Code() int {
	return 429
}

func (o *ImportEventSourceTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/eventsources/importxml][%d] importEventSourceTooManyRequests", 429)
}

func (o *ImportEventSourceTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/eventsources/importxml][%d] importEventSourceTooManyRequests", 429)
}

func (o *ImportEventSourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewImportEventSourceDefault creates a ImportEventSourceDefault with default headers values
func NewImportEventSourceDefault(code int) *ImportEventSourceDefault {
	return &ImportEventSourceDefault{
		_statusCode: code,
	}
}

/*
ImportEventSourceDefault describes a response with status code -1, with default header values.

Error
*/
type ImportEventSourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this import event source default response has a 2xx status code
func (o *ImportEventSourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this import event source default response has a 3xx status code
func (o *ImportEventSourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this import event source default response has a 4xx status code
func (o *ImportEventSourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this import event source default response has a 5xx status code
func (o *ImportEventSourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this import event source default response a status code equal to that given
func (o *ImportEventSourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the import event source default response
func (o *ImportEventSourceDefault) Code() int {
	return o._statusCode
}

func (o *ImportEventSourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/eventsources/importxml][%d] importEventSource default %s", o._statusCode, payload)
}

func (o *ImportEventSourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/eventsources/importxml][%d] importEventSource default %s", o._statusCode, payload)
}

func (o *ImportEventSourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ImportEventSourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
