// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchAppliesToFunctionReader is a Reader for the PatchAppliesToFunction structure.
type PatchAppliesToFunctionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchAppliesToFunctionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchAppliesToFunctionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchAppliesToFunctionTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchAppliesToFunctionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchAppliesToFunctionOK creates a PatchAppliesToFunctionOK with default headers values
func NewPatchAppliesToFunctionOK() *PatchAppliesToFunctionOK {
	return &PatchAppliesToFunctionOK{}
}

/*
PatchAppliesToFunctionOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchAppliesToFunctionOK struct {
	Payload *models.AppliesToFunction
}

// IsSuccess returns true when this patch applies to function o k response has a 2xx status code
func (o *PatchAppliesToFunctionOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch applies to function o k response has a 3xx status code
func (o *PatchAppliesToFunctionOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch applies to function o k response has a 4xx status code
func (o *PatchAppliesToFunctionOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch applies to function o k response has a 5xx status code
func (o *PatchAppliesToFunctionOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch applies to function o k response a status code equal to that given
func (o *PatchAppliesToFunctionOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch applies to function o k response
func (o *PatchAppliesToFunctionOK) Code() int {
	return 200
}

func (o *PatchAppliesToFunctionOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/functions/{id}][%d] patchAppliesToFunctionOK %s", 200, payload)
}

func (o *PatchAppliesToFunctionOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/functions/{id}][%d] patchAppliesToFunctionOK %s", 200, payload)
}

func (o *PatchAppliesToFunctionOK) GetPayload() *models.AppliesToFunction {
	return o.Payload
}

func (o *PatchAppliesToFunctionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AppliesToFunction)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchAppliesToFunctionTooManyRequests creates a PatchAppliesToFunctionTooManyRequests with default headers values
func NewPatchAppliesToFunctionTooManyRequests() *PatchAppliesToFunctionTooManyRequests {
	return &PatchAppliesToFunctionTooManyRequests{}
}

/*
PatchAppliesToFunctionTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchAppliesToFunctionTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch applies to function too many requests response has a 2xx status code
func (o *PatchAppliesToFunctionTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch applies to function too many requests response has a 3xx status code
func (o *PatchAppliesToFunctionTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch applies to function too many requests response has a 4xx status code
func (o *PatchAppliesToFunctionTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch applies to function too many requests response has a 5xx status code
func (o *PatchAppliesToFunctionTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch applies to function too many requests response a status code equal to that given
func (o *PatchAppliesToFunctionTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch applies to function too many requests response
func (o *PatchAppliesToFunctionTooManyRequests) Code() int {
	return 429
}

func (o *PatchAppliesToFunctionTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/functions/{id}][%d] patchAppliesToFunctionTooManyRequests", 429)
}

func (o *PatchAppliesToFunctionTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /setting/functions/{id}][%d] patchAppliesToFunctionTooManyRequests", 429)
}

func (o *PatchAppliesToFunctionTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchAppliesToFunctionDefault creates a PatchAppliesToFunctionDefault with default headers values
func NewPatchAppliesToFunctionDefault(code int) *PatchAppliesToFunctionDefault {
	return &PatchAppliesToFunctionDefault{
		_statusCode: code,
	}
}

/*
PatchAppliesToFunctionDefault describes a response with status code -1, with default header values.

Error
*/
type PatchAppliesToFunctionDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch applies to function default response has a 2xx status code
func (o *PatchAppliesToFunctionDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch applies to function default response has a 3xx status code
func (o *PatchAppliesToFunctionDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch applies to function default response has a 4xx status code
func (o *PatchAppliesToFunctionDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch applies to function default response has a 5xx status code
func (o *PatchAppliesToFunctionDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch applies to function default response a status code equal to that given
func (o *PatchAppliesToFunctionDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch applies to function default response
func (o *PatchAppliesToFunctionDefault) Code() int {
	return o._statusCode
}

func (o *PatchAppliesToFunctionDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/functions/{id}][%d] patchAppliesToFunction default %s", o._statusCode, payload)
}

func (o *PatchAppliesToFunctionDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/functions/{id}][%d] patchAppliesToFunction default %s", o._statusCode, payload)
}

func (o *PatchAppliesToFunctionDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchAppliesToFunctionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
