// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchConfigSourceByIDReader is a Reader for the PatchConfigSourceByID structure.
type PatchConfigSourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchConfigSourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchConfigSourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchConfigSourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchConfigSourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchConfigSourceByIDOK creates a PatchConfigSourceByIDOK with default headers values
func NewPatchConfigSourceByIDOK() *PatchConfigSourceByIDOK {
	return &PatchConfigSourceByIDOK{}
}

/*
PatchConfigSourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchConfigSourceByIDOK struct {
	Payload *models.ConfigSource
}

// IsSuccess returns true when this patch config source by Id o k response has a 2xx status code
func (o *PatchConfigSourceByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch config source by Id o k response has a 3xx status code
func (o *PatchConfigSourceByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch config source by Id o k response has a 4xx status code
func (o *PatchConfigSourceByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch config source by Id o k response has a 5xx status code
func (o *PatchConfigSourceByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch config source by Id o k response a status code equal to that given
func (o *PatchConfigSourceByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch config source by Id o k response
func (o *PatchConfigSourceByIDOK) Code() int {
	return 200
}

func (o *PatchConfigSourceByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/configsources/{id}][%d] patchConfigSourceByIdOK %s", 200, payload)
}

func (o *PatchConfigSourceByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/configsources/{id}][%d] patchConfigSourceByIdOK %s", 200, payload)
}

func (o *PatchConfigSourceByIDOK) GetPayload() *models.ConfigSource {
	return o.Payload
}

func (o *PatchConfigSourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ConfigSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchConfigSourceByIDTooManyRequests creates a PatchConfigSourceByIDTooManyRequests with default headers values
func NewPatchConfigSourceByIDTooManyRequests() *PatchConfigSourceByIDTooManyRequests {
	return &PatchConfigSourceByIDTooManyRequests{}
}

/*
PatchConfigSourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchConfigSourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch config source by Id too many requests response has a 2xx status code
func (o *PatchConfigSourceByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch config source by Id too many requests response has a 3xx status code
func (o *PatchConfigSourceByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch config source by Id too many requests response has a 4xx status code
func (o *PatchConfigSourceByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch config source by Id too many requests response has a 5xx status code
func (o *PatchConfigSourceByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch config source by Id too many requests response a status code equal to that given
func (o *PatchConfigSourceByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch config source by Id too many requests response
func (o *PatchConfigSourceByIDTooManyRequests) Code() int {
	return 429
}

func (o *PatchConfigSourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/configsources/{id}][%d] patchConfigSourceByIdTooManyRequests", 429)
}

func (o *PatchConfigSourceByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /setting/configsources/{id}][%d] patchConfigSourceByIdTooManyRequests", 429)
}

func (o *PatchConfigSourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchConfigSourceByIDDefault creates a PatchConfigSourceByIDDefault with default headers values
func NewPatchConfigSourceByIDDefault(code int) *PatchConfigSourceByIDDefault {
	return &PatchConfigSourceByIDDefault{
		_statusCode: code,
	}
}

/*
PatchConfigSourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type PatchConfigSourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch config source by Id default response has a 2xx status code
func (o *PatchConfigSourceByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch config source by Id default response has a 3xx status code
func (o *PatchConfigSourceByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch config source by Id default response has a 4xx status code
func (o *PatchConfigSourceByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch config source by Id default response has a 5xx status code
func (o *PatchConfigSourceByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch config source by Id default response a status code equal to that given
func (o *PatchConfigSourceByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch config source by Id default response
func (o *PatchConfigSourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *PatchConfigSourceByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/configsources/{id}][%d] patchConfigSourceById default %s", o._statusCode, payload)
}

func (o *PatchConfigSourceByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/configsources/{id}][%d] patchConfigSourceById default %s", o._statusCode, payload)
}

func (o *PatchConfigSourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchConfigSourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
