// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchDeviceGroupPropertyByNameReader is a Reader for the PatchDeviceGroupPropertyByName structure.
type PatchDeviceGroupPropertyByNameReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchDeviceGroupPropertyByNameReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchDeviceGroupPropertyByNameOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchDeviceGroupPropertyByNameTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchDeviceGroupPropertyByNameDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchDeviceGroupPropertyByNameOK creates a PatchDeviceGroupPropertyByNameOK with default headers values
func NewPatchDeviceGroupPropertyByNameOK() *PatchDeviceGroupPropertyByNameOK {
	return &PatchDeviceGroupPropertyByNameOK{}
}

/*
PatchDeviceGroupPropertyByNameOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchDeviceGroupPropertyByNameOK struct {
	Payload *models.EntityProperty
}

// IsSuccess returns true when this patch device group property by name o k response has a 2xx status code
func (o *PatchDeviceGroupPropertyByNameOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch device group property by name o k response has a 3xx status code
func (o *PatchDeviceGroupPropertyByNameOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch device group property by name o k response has a 4xx status code
func (o *PatchDeviceGroupPropertyByNameOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch device group property by name o k response has a 5xx status code
func (o *PatchDeviceGroupPropertyByNameOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch device group property by name o k response a status code equal to that given
func (o *PatchDeviceGroupPropertyByNameOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch device group property by name o k response
func (o *PatchDeviceGroupPropertyByNameOK) Code() int {
	return 200
}

func (o *PatchDeviceGroupPropertyByNameOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /device/groups/{gid}/properties/{name}][%d] patchDeviceGroupPropertyByNameOK %s", 200, payload)
}

func (o *PatchDeviceGroupPropertyByNameOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /device/groups/{gid}/properties/{name}][%d] patchDeviceGroupPropertyByNameOK %s", 200, payload)
}

func (o *PatchDeviceGroupPropertyByNameOK) GetPayload() *models.EntityProperty {
	return o.Payload
}

func (o *PatchDeviceGroupPropertyByNameOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.EntityProperty)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchDeviceGroupPropertyByNameTooManyRequests creates a PatchDeviceGroupPropertyByNameTooManyRequests with default headers values
func NewPatchDeviceGroupPropertyByNameTooManyRequests() *PatchDeviceGroupPropertyByNameTooManyRequests {
	return &PatchDeviceGroupPropertyByNameTooManyRequests{}
}

/*
PatchDeviceGroupPropertyByNameTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchDeviceGroupPropertyByNameTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch device group property by name too many requests response has a 2xx status code
func (o *PatchDeviceGroupPropertyByNameTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch device group property by name too many requests response has a 3xx status code
func (o *PatchDeviceGroupPropertyByNameTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch device group property by name too many requests response has a 4xx status code
func (o *PatchDeviceGroupPropertyByNameTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch device group property by name too many requests response has a 5xx status code
func (o *PatchDeviceGroupPropertyByNameTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch device group property by name too many requests response a status code equal to that given
func (o *PatchDeviceGroupPropertyByNameTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch device group property by name too many requests response
func (o *PatchDeviceGroupPropertyByNameTooManyRequests) Code() int {
	return 429
}

func (o *PatchDeviceGroupPropertyByNameTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /device/groups/{gid}/properties/{name}][%d] patchDeviceGroupPropertyByNameTooManyRequests", 429)
}

func (o *PatchDeviceGroupPropertyByNameTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /device/groups/{gid}/properties/{name}][%d] patchDeviceGroupPropertyByNameTooManyRequests", 429)
}

func (o *PatchDeviceGroupPropertyByNameTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchDeviceGroupPropertyByNameDefault creates a PatchDeviceGroupPropertyByNameDefault with default headers values
func NewPatchDeviceGroupPropertyByNameDefault(code int) *PatchDeviceGroupPropertyByNameDefault {
	return &PatchDeviceGroupPropertyByNameDefault{
		_statusCode: code,
	}
}

/*
PatchDeviceGroupPropertyByNameDefault describes a response with status code -1, with default header values.

Error
*/
type PatchDeviceGroupPropertyByNameDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch device group property by name default response has a 2xx status code
func (o *PatchDeviceGroupPropertyByNameDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch device group property by name default response has a 3xx status code
func (o *PatchDeviceGroupPropertyByNameDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch device group property by name default response has a 4xx status code
func (o *PatchDeviceGroupPropertyByNameDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch device group property by name default response has a 5xx status code
func (o *PatchDeviceGroupPropertyByNameDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch device group property by name default response a status code equal to that given
func (o *PatchDeviceGroupPropertyByNameDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch device group property by name default response
func (o *PatchDeviceGroupPropertyByNameDefault) Code() int {
	return o._statusCode
}

func (o *PatchDeviceGroupPropertyByNameDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /device/groups/{gid}/properties/{name}][%d] patchDeviceGroupPropertyByName default %s", o._statusCode, payload)
}

func (o *PatchDeviceGroupPropertyByNameDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /device/groups/{gid}/properties/{name}][%d] patchDeviceGroupPropertyByName default %s", o._statusCode, payload)
}

func (o *PatchDeviceGroupPropertyByNameDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchDeviceGroupPropertyByNameDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
