// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchEventSourceByIDReader is a Reader for the PatchEventSourceByID structure.
type PatchEventSourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchEventSourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchEventSourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchEventSourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchEventSourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchEventSourceByIDOK creates a PatchEventSourceByIDOK with default headers values
func NewPatchEventSourceByIDOK() *PatchEventSourceByIDOK {
	return &PatchEventSourceByIDOK{}
}

/*
PatchEventSourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchEventSourceByIDOK struct {
	Payload models.EventSource
}

// IsSuccess returns true when this patch event source by Id o k response has a 2xx status code
func (o *PatchEventSourceByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch event source by Id o k response has a 3xx status code
func (o *PatchEventSourceByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch event source by Id o k response has a 4xx status code
func (o *PatchEventSourceByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch event source by Id o k response has a 5xx status code
func (o *PatchEventSourceByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch event source by Id o k response a status code equal to that given
func (o *PatchEventSourceByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch event source by Id o k response
func (o *PatchEventSourceByIDOK) Code() int {
	return 200
}

func (o *PatchEventSourceByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/eventsources/{id}][%d] patchEventSourceByIdOK %s", 200, payload)
}

func (o *PatchEventSourceByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/eventsources/{id}][%d] patchEventSourceByIdOK %s", 200, payload)
}

func (o *PatchEventSourceByIDOK) GetPayload() models.EventSource {
	return o.Payload
}

func (o *PatchEventSourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalEventSource(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewPatchEventSourceByIDTooManyRequests creates a PatchEventSourceByIDTooManyRequests with default headers values
func NewPatchEventSourceByIDTooManyRequests() *PatchEventSourceByIDTooManyRequests {
	return &PatchEventSourceByIDTooManyRequests{}
}

/*
PatchEventSourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchEventSourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch event source by Id too many requests response has a 2xx status code
func (o *PatchEventSourceByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch event source by Id too many requests response has a 3xx status code
func (o *PatchEventSourceByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch event source by Id too many requests response has a 4xx status code
func (o *PatchEventSourceByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch event source by Id too many requests response has a 5xx status code
func (o *PatchEventSourceByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch event source by Id too many requests response a status code equal to that given
func (o *PatchEventSourceByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch event source by Id too many requests response
func (o *PatchEventSourceByIDTooManyRequests) Code() int {
	return 429
}

func (o *PatchEventSourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/eventsources/{id}][%d] patchEventSourceByIdTooManyRequests", 429)
}

func (o *PatchEventSourceByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /setting/eventsources/{id}][%d] patchEventSourceByIdTooManyRequests", 429)
}

func (o *PatchEventSourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchEventSourceByIDDefault creates a PatchEventSourceByIDDefault with default headers values
func NewPatchEventSourceByIDDefault(code int) *PatchEventSourceByIDDefault {
	return &PatchEventSourceByIDDefault{
		_statusCode: code,
	}
}

/*
PatchEventSourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type PatchEventSourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch event source by Id default response has a 2xx status code
func (o *PatchEventSourceByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch event source by Id default response has a 3xx status code
func (o *PatchEventSourceByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch event source by Id default response has a 4xx status code
func (o *PatchEventSourceByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch event source by Id default response has a 5xx status code
func (o *PatchEventSourceByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch event source by Id default response a status code equal to that given
func (o *PatchEventSourceByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch event source by Id default response
func (o *PatchEventSourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *PatchEventSourceByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/eventsources/{id}][%d] patchEventSourceById default %s", o._statusCode, payload)
}

func (o *PatchEventSourceByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/eventsources/{id}][%d] patchEventSourceById default %s", o._statusCode, payload)
}

func (o *PatchEventSourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchEventSourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
