// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewPatchLogPartitionParams creates a new PatchLogPartitionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPatchLogPartitionParams() *PatchLogPartitionParams {
	return &PatchLogPartitionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPatchLogPartitionParamsWithTimeout creates a new PatchLogPartitionParams object
// with the ability to set a timeout on a request.
func NewPatchLogPartitionParamsWithTimeout(timeout time.Duration) *PatchLogPartitionParams {
	return &PatchLogPartitionParams{
		timeout: timeout,
	}
}

// NewPatchLogPartitionParamsWithContext creates a new PatchLogPartitionParams object
// with the ability to set a context for a request.
func NewPatchLogPartitionParamsWithContext(ctx context.Context) *PatchLogPartitionParams {
	return &PatchLogPartitionParams{
		Context: ctx,
	}
}

// NewPatchLogPartitionParamsWithHTTPClient creates a new PatchLogPartitionParams object
// with the ability to set a custom HTTPClient for a request.
func NewPatchLogPartitionParamsWithHTTPClient(client *http.Client) *PatchLogPartitionParams {
	return &PatchLogPartitionParams{
		HTTPClient: client,
	}
}

/*
PatchLogPartitionParams contains all the parameters to send to the API endpoint

	for the patch log partition operation.

	Typically these are written to a http.Request.
*/
type PatchLogPartitionParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.LogPartition

	// ID.
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the patch log partition params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchLogPartitionParams) WithDefaults() *PatchLogPartitionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the patch log partition params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchLogPartitionParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := PatchLogPartitionParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the patch log partition params
func (o *PatchLogPartitionParams) WithTimeout(timeout time.Duration) *PatchLogPartitionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the patch log partition params
func (o *PatchLogPartitionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the patch log partition params
func (o *PatchLogPartitionParams) WithContext(ctx context.Context) *PatchLogPartitionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the patch log partition params
func (o *PatchLogPartitionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the patch log partition params
func (o *PatchLogPartitionParams) WithHTTPClient(client *http.Client) *PatchLogPartitionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the patch log partition params
func (o *PatchLogPartitionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the patch log partition params
func (o *PatchLogPartitionParams) WithUserAgent(userAgent *string) *PatchLogPartitionParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the patch log partition params
func (o *PatchLogPartitionParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the patch log partition params
func (o *PatchLogPartitionParams) WithBody(body *models.LogPartition) *PatchLogPartitionParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the patch log partition params
func (o *PatchLogPartitionParams) SetBody(body *models.LogPartition) {
	o.Body = body
}

// WithID adds the id to the patch log partition params
func (o *PatchLogPartitionParams) WithID(id string) *PatchLogPartitionParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the patch log partition params
func (o *PatchLogPartitionParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PatchLogPartitionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
