// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchLogPartitionReader is a Reader for the PatchLogPartition structure.
type PatchLogPartitionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchLogPartitionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchLogPartitionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchLogPartitionTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchLogPartitionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchLogPartitionOK creates a PatchLogPartitionOK with default headers values
func NewPatchLogPartitionOK() *PatchLogPartitionOK {
	return &PatchLogPartitionOK{}
}

/*
PatchLogPartitionOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchLogPartitionOK struct {
	Payload *models.LogPartition
}

// IsSuccess returns true when this patch log partition o k response has a 2xx status code
func (o *PatchLogPartitionOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch log partition o k response has a 3xx status code
func (o *PatchLogPartitionOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch log partition o k response has a 4xx status code
func (o *PatchLogPartitionOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch log partition o k response has a 5xx status code
func (o *PatchLogPartitionOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch log partition o k response a status code equal to that given
func (o *PatchLogPartitionOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch log partition o k response
func (o *PatchLogPartitionOK) Code() int {
	return 200
}

func (o *PatchLogPartitionOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /log/partitions/{id}][%d] patchLogPartitionOK %s", 200, payload)
}

func (o *PatchLogPartitionOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /log/partitions/{id}][%d] patchLogPartitionOK %s", 200, payload)
}

func (o *PatchLogPartitionOK) GetPayload() *models.LogPartition {
	return o.Payload
}

func (o *PatchLogPartitionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LogPartition)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchLogPartitionTooManyRequests creates a PatchLogPartitionTooManyRequests with default headers values
func NewPatchLogPartitionTooManyRequests() *PatchLogPartitionTooManyRequests {
	return &PatchLogPartitionTooManyRequests{}
}

/*
PatchLogPartitionTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchLogPartitionTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch log partition too many requests response has a 2xx status code
func (o *PatchLogPartitionTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch log partition too many requests response has a 3xx status code
func (o *PatchLogPartitionTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch log partition too many requests response has a 4xx status code
func (o *PatchLogPartitionTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch log partition too many requests response has a 5xx status code
func (o *PatchLogPartitionTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch log partition too many requests response a status code equal to that given
func (o *PatchLogPartitionTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch log partition too many requests response
func (o *PatchLogPartitionTooManyRequests) Code() int {
	return 429
}

func (o *PatchLogPartitionTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /log/partitions/{id}][%d] patchLogPartitionTooManyRequests", 429)
}

func (o *PatchLogPartitionTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /log/partitions/{id}][%d] patchLogPartitionTooManyRequests", 429)
}

func (o *PatchLogPartitionTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchLogPartitionDefault creates a PatchLogPartitionDefault with default headers values
func NewPatchLogPartitionDefault(code int) *PatchLogPartitionDefault {
	return &PatchLogPartitionDefault{
		_statusCode: code,
	}
}

/*
PatchLogPartitionDefault describes a response with status code -1, with default header values.

Error
*/
type PatchLogPartitionDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch log partition default response has a 2xx status code
func (o *PatchLogPartitionDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch log partition default response has a 3xx status code
func (o *PatchLogPartitionDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch log partition default response has a 4xx status code
func (o *PatchLogPartitionDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch log partition default response has a 5xx status code
func (o *PatchLogPartitionDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch log partition default response a status code equal to that given
func (o *PatchLogPartitionDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch log partition default response
func (o *PatchLogPartitionDefault) Code() int {
	return o._statusCode
}

func (o *PatchLogPartitionDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /log/partitions/{id}][%d] patchLogPartition default %s", o._statusCode, payload)
}

func (o *PatchLogPartitionDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /log/partitions/{id}][%d] patchLogPartition default %s", o._statusCode, payload)
}

func (o *PatchLogPartitionDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchLogPartitionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
