// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchPropertyRuleReader is a Reader for the PatchPropertyRule structure.
type PatchPropertyRuleReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchPropertyRuleReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchPropertyRuleOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchPropertyRuleTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchPropertyRuleDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchPropertyRuleOK creates a PatchPropertyRuleOK with default headers values
func NewPatchPropertyRuleOK() *PatchPropertyRuleOK {
	return &PatchPropertyRuleOK{}
}

/*
PatchPropertyRuleOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchPropertyRuleOK struct {
	Payload *models.PropertyRule
}

// IsSuccess returns true when this patch property rule o k response has a 2xx status code
func (o *PatchPropertyRuleOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch property rule o k response has a 3xx status code
func (o *PatchPropertyRuleOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch property rule o k response has a 4xx status code
func (o *PatchPropertyRuleOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch property rule o k response has a 5xx status code
func (o *PatchPropertyRuleOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch property rule o k response a status code equal to that given
func (o *PatchPropertyRuleOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch property rule o k response
func (o *PatchPropertyRuleOK) Code() int {
	return 200
}

func (o *PatchPropertyRuleOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/propertyrules/{id}][%d] patchPropertyRuleOK %s", 200, payload)
}

func (o *PatchPropertyRuleOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/propertyrules/{id}][%d] patchPropertyRuleOK %s", 200, payload)
}

func (o *PatchPropertyRuleOK) GetPayload() *models.PropertyRule {
	return o.Payload
}

func (o *PatchPropertyRuleOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.PropertyRule)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchPropertyRuleTooManyRequests creates a PatchPropertyRuleTooManyRequests with default headers values
func NewPatchPropertyRuleTooManyRequests() *PatchPropertyRuleTooManyRequests {
	return &PatchPropertyRuleTooManyRequests{}
}

/*
PatchPropertyRuleTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchPropertyRuleTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch property rule too many requests response has a 2xx status code
func (o *PatchPropertyRuleTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch property rule too many requests response has a 3xx status code
func (o *PatchPropertyRuleTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch property rule too many requests response has a 4xx status code
func (o *PatchPropertyRuleTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch property rule too many requests response has a 5xx status code
func (o *PatchPropertyRuleTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch property rule too many requests response a status code equal to that given
func (o *PatchPropertyRuleTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch property rule too many requests response
func (o *PatchPropertyRuleTooManyRequests) Code() int {
	return 429
}

func (o *PatchPropertyRuleTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/propertyrules/{id}][%d] patchPropertyRuleTooManyRequests", 429)
}

func (o *PatchPropertyRuleTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /setting/propertyrules/{id}][%d] patchPropertyRuleTooManyRequests", 429)
}

func (o *PatchPropertyRuleTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchPropertyRuleDefault creates a PatchPropertyRuleDefault with default headers values
func NewPatchPropertyRuleDefault(code int) *PatchPropertyRuleDefault {
	return &PatchPropertyRuleDefault{
		_statusCode: code,
	}
}

/*
PatchPropertyRuleDefault describes a response with status code -1, with default header values.

Error
*/
type PatchPropertyRuleDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch property rule default response has a 2xx status code
func (o *PatchPropertyRuleDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch property rule default response has a 3xx status code
func (o *PatchPropertyRuleDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch property rule default response has a 4xx status code
func (o *PatchPropertyRuleDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch property rule default response has a 5xx status code
func (o *PatchPropertyRuleDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch property rule default response a status code equal to that given
func (o *PatchPropertyRuleDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch property rule default response
func (o *PatchPropertyRuleDefault) Code() int {
	return o._statusCode
}

func (o *PatchPropertyRuleDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/propertyrules/{id}][%d] patchPropertyRule default %s", o._statusCode, payload)
}

func (o *PatchPropertyRuleDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/propertyrules/{id}][%d] patchPropertyRule default %s", o._statusCode, payload)
}

func (o *PatchPropertyRuleDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchPropertyRuleDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
