// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchReportGroupByIDReader is a Reader for the PatchReportGroupByID structure.
type PatchReportGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchReportGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchReportGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchReportGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchReportGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchReportGroupByIDOK creates a PatchReportGroupByIDOK with default headers values
func NewPatchReportGroupByIDOK() *PatchReportGroupByIDOK {
	return &PatchReportGroupByIDOK{}
}

/*
PatchReportGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchReportGroupByIDOK struct {
	Payload *models.ReportGroup
}

// IsSuccess returns true when this patch report group by Id o k response has a 2xx status code
func (o *PatchReportGroupByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch report group by Id o k response has a 3xx status code
func (o *PatchReportGroupByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch report group by Id o k response has a 4xx status code
func (o *PatchReportGroupByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch report group by Id o k response has a 5xx status code
func (o *PatchReportGroupByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch report group by Id o k response a status code equal to that given
func (o *PatchReportGroupByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch report group by Id o k response
func (o *PatchReportGroupByIDOK) Code() int {
	return 200
}

func (o *PatchReportGroupByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /report/groups/{id}][%d] patchReportGroupByIdOK %s", 200, payload)
}

func (o *PatchReportGroupByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /report/groups/{id}][%d] patchReportGroupByIdOK %s", 200, payload)
}

func (o *PatchReportGroupByIDOK) GetPayload() *models.ReportGroup {
	return o.Payload
}

func (o *PatchReportGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ReportGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchReportGroupByIDTooManyRequests creates a PatchReportGroupByIDTooManyRequests with default headers values
func NewPatchReportGroupByIDTooManyRequests() *PatchReportGroupByIDTooManyRequests {
	return &PatchReportGroupByIDTooManyRequests{}
}

/*
PatchReportGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchReportGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch report group by Id too many requests response has a 2xx status code
func (o *PatchReportGroupByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch report group by Id too many requests response has a 3xx status code
func (o *PatchReportGroupByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch report group by Id too many requests response has a 4xx status code
func (o *PatchReportGroupByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch report group by Id too many requests response has a 5xx status code
func (o *PatchReportGroupByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch report group by Id too many requests response a status code equal to that given
func (o *PatchReportGroupByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch report group by Id too many requests response
func (o *PatchReportGroupByIDTooManyRequests) Code() int {
	return 429
}

func (o *PatchReportGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /report/groups/{id}][%d] patchReportGroupByIdTooManyRequests", 429)
}

func (o *PatchReportGroupByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /report/groups/{id}][%d] patchReportGroupByIdTooManyRequests", 429)
}

func (o *PatchReportGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchReportGroupByIDDefault creates a PatchReportGroupByIDDefault with default headers values
func NewPatchReportGroupByIDDefault(code int) *PatchReportGroupByIDDefault {
	return &PatchReportGroupByIDDefault{
		_statusCode: code,
	}
}

/*
PatchReportGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type PatchReportGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch report group by Id default response has a 2xx status code
func (o *PatchReportGroupByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch report group by Id default response has a 3xx status code
func (o *PatchReportGroupByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch report group by Id default response has a 4xx status code
func (o *PatchReportGroupByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch report group by Id default response has a 5xx status code
func (o *PatchReportGroupByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch report group by Id default response a status code equal to that given
func (o *PatchReportGroupByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch report group by Id default response
func (o *PatchReportGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *PatchReportGroupByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /report/groups/{id}][%d] patchReportGroupById default %s", o._statusCode, payload)
}

func (o *PatchReportGroupByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /report/groups/{id}][%d] patchReportGroupById default %s", o._statusCode, payload)
}

func (o *PatchReportGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchReportGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
