// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchWebsiteByIDReader is a Reader for the PatchWebsiteByID structure.
type PatchWebsiteByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchWebsiteByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchWebsiteByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchWebsiteByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchWebsiteByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchWebsiteByIDOK creates a PatchWebsiteByIDOK with default headers values
func NewPatchWebsiteByIDOK() *PatchWebsiteByIDOK {
	return &PatchWebsiteByIDOK{}
}

/*
PatchWebsiteByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchWebsiteByIDOK struct {
	Payload models.Website
}

// IsSuccess returns true when this patch website by Id o k response has a 2xx status code
func (o *PatchWebsiteByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch website by Id o k response has a 3xx status code
func (o *PatchWebsiteByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch website by Id o k response has a 4xx status code
func (o *PatchWebsiteByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch website by Id o k response has a 5xx status code
func (o *PatchWebsiteByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch website by Id o k response a status code equal to that given
func (o *PatchWebsiteByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch website by Id o k response
func (o *PatchWebsiteByIDOK) Code() int {
	return 200
}

func (o *PatchWebsiteByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /website/websites/{id}][%d] patchWebsiteByIdOK %s", 200, payload)
}

func (o *PatchWebsiteByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /website/websites/{id}][%d] patchWebsiteByIdOK %s", 200, payload)
}

func (o *PatchWebsiteByIDOK) GetPayload() models.Website {
	return o.Payload
}

func (o *PatchWebsiteByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalWebsite(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewPatchWebsiteByIDTooManyRequests creates a PatchWebsiteByIDTooManyRequests with default headers values
func NewPatchWebsiteByIDTooManyRequests() *PatchWebsiteByIDTooManyRequests {
	return &PatchWebsiteByIDTooManyRequests{}
}

/*
PatchWebsiteByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchWebsiteByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch website by Id too many requests response has a 2xx status code
func (o *PatchWebsiteByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch website by Id too many requests response has a 3xx status code
func (o *PatchWebsiteByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch website by Id too many requests response has a 4xx status code
func (o *PatchWebsiteByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch website by Id too many requests response has a 5xx status code
func (o *PatchWebsiteByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch website by Id too many requests response a status code equal to that given
func (o *PatchWebsiteByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch website by Id too many requests response
func (o *PatchWebsiteByIDTooManyRequests) Code() int {
	return 429
}

func (o *PatchWebsiteByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /website/websites/{id}][%d] patchWebsiteByIdTooManyRequests", 429)
}

func (o *PatchWebsiteByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /website/websites/{id}][%d] patchWebsiteByIdTooManyRequests", 429)
}

func (o *PatchWebsiteByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchWebsiteByIDDefault creates a PatchWebsiteByIDDefault with default headers values
func NewPatchWebsiteByIDDefault(code int) *PatchWebsiteByIDDefault {
	return &PatchWebsiteByIDDefault{
		_statusCode: code,
	}
}

/*
PatchWebsiteByIDDefault describes a response with status code -1, with default header values.

Error
*/
type PatchWebsiteByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch website by Id default response has a 2xx status code
func (o *PatchWebsiteByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch website by Id default response has a 3xx status code
func (o *PatchWebsiteByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch website by Id default response has a 4xx status code
func (o *PatchWebsiteByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch website by Id default response has a 5xx status code
func (o *PatchWebsiteByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch website by Id default response a status code equal to that given
func (o *PatchWebsiteByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch website by Id default response
func (o *PatchWebsiteByIDDefault) Code() int {
	return o._statusCode
}

func (o *PatchWebsiteByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /website/websites/{id}][%d] patchWebsiteById default %s", o._statusCode, payload)
}

func (o *PatchWebsiteByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /website/websites/{id}][%d] patchWebsiteById default %s", o._statusCode, payload)
}

func (o *PatchWebsiteByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchWebsiteByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
