// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewUpdateAccessGroupParams creates a new UpdateAccessGroupParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateAccessGroupParams() *UpdateAccessGroupParams {
	return &UpdateAccessGroupParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateAccessGroupParamsWithTimeout creates a new UpdateAccessGroupParams object
// with the ability to set a timeout on a request.
func NewUpdateAccessGroupParamsWithTimeout(timeout time.Duration) *UpdateAccessGroupParams {
	return &UpdateAccessGroupParams{
		timeout: timeout,
	}
}

// NewUpdateAccessGroupParamsWithContext creates a new UpdateAccessGroupParams object
// with the ability to set a context for a request.
func NewUpdateAccessGroupParamsWithContext(ctx context.Context) *UpdateAccessGroupParams {
	return &UpdateAccessGroupParams{
		Context: ctx,
	}
}

// NewUpdateAccessGroupParamsWithHTTPClient creates a new UpdateAccessGroupParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateAccessGroupParamsWithHTTPClient(client *http.Client) *UpdateAccessGroupParams {
	return &UpdateAccessGroupParams{
		HTTPClient: client,
	}
}

/*
UpdateAccessGroupParams contains all the parameters to send to the API endpoint

	for the update access group operation.

	Typically these are written to a http.Request.
*/
type UpdateAccessGroupParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.AccessGroup

	// ID.
	//
	// Format: int32
	ID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update access group params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateAccessGroupParams) WithDefaults() *UpdateAccessGroupParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update access group params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateAccessGroupParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := UpdateAccessGroupParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the update access group params
func (o *UpdateAccessGroupParams) WithTimeout(timeout time.Duration) *UpdateAccessGroupParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update access group params
func (o *UpdateAccessGroupParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update access group params
func (o *UpdateAccessGroupParams) WithContext(ctx context.Context) *UpdateAccessGroupParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update access group params
func (o *UpdateAccessGroupParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update access group params
func (o *UpdateAccessGroupParams) WithHTTPClient(client *http.Client) *UpdateAccessGroupParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update access group params
func (o *UpdateAccessGroupParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the update access group params
func (o *UpdateAccessGroupParams) WithUserAgent(userAgent *string) *UpdateAccessGroupParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the update access group params
func (o *UpdateAccessGroupParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the update access group params
func (o *UpdateAccessGroupParams) WithBody(body *models.AccessGroup) *UpdateAccessGroupParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update access group params
func (o *UpdateAccessGroupParams) SetBody(body *models.AccessGroup) {
	o.Body = body
}

// WithID adds the id to the update access group params
func (o *UpdateAccessGroupParams) WithID(id int32) *UpdateAccessGroupParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the update access group params
func (o *UpdateAccessGroupParams) SetID(id int32) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateAccessGroupParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
