// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateAlertRuleByIDReader is a Reader for the UpdateAlertRuleByID structure.
type UpdateAlertRuleByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateAlertRuleByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateAlertRuleByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateAlertRuleByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateAlertRuleByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateAlertRuleByIDOK creates a UpdateAlertRuleByIDOK with default headers values
func NewUpdateAlertRuleByIDOK() *UpdateAlertRuleByIDOK {
	return &UpdateAlertRuleByIDOK{}
}

/*
UpdateAlertRuleByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateAlertRuleByIDOK struct {
	Payload *models.AlertRule
}

// IsSuccess returns true when this update alert rule by Id o k response has a 2xx status code
func (o *UpdateAlertRuleByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update alert rule by Id o k response has a 3xx status code
func (o *UpdateAlertRuleByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update alert rule by Id o k response has a 4xx status code
func (o *UpdateAlertRuleByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update alert rule by Id o k response has a 5xx status code
func (o *UpdateAlertRuleByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update alert rule by Id o k response a status code equal to that given
func (o *UpdateAlertRuleByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update alert rule by Id o k response
func (o *UpdateAlertRuleByIDOK) Code() int {
	return 200
}

func (o *UpdateAlertRuleByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/alert/rules/{id}][%d] updateAlertRuleByIdOK %s", 200, payload)
}

func (o *UpdateAlertRuleByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/alert/rules/{id}][%d] updateAlertRuleByIdOK %s", 200, payload)
}

func (o *UpdateAlertRuleByIDOK) GetPayload() *models.AlertRule {
	return o.Payload
}

func (o *UpdateAlertRuleByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AlertRule)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateAlertRuleByIDTooManyRequests creates a UpdateAlertRuleByIDTooManyRequests with default headers values
func NewUpdateAlertRuleByIDTooManyRequests() *UpdateAlertRuleByIDTooManyRequests {
	return &UpdateAlertRuleByIDTooManyRequests{}
}

/*
UpdateAlertRuleByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateAlertRuleByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update alert rule by Id too many requests response has a 2xx status code
func (o *UpdateAlertRuleByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update alert rule by Id too many requests response has a 3xx status code
func (o *UpdateAlertRuleByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update alert rule by Id too many requests response has a 4xx status code
func (o *UpdateAlertRuleByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update alert rule by Id too many requests response has a 5xx status code
func (o *UpdateAlertRuleByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update alert rule by Id too many requests response a status code equal to that given
func (o *UpdateAlertRuleByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update alert rule by Id too many requests response
func (o *UpdateAlertRuleByIDTooManyRequests) Code() int {
	return 429
}

func (o *UpdateAlertRuleByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/alert/rules/{id}][%d] updateAlertRuleByIdTooManyRequests", 429)
}

func (o *UpdateAlertRuleByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/alert/rules/{id}][%d] updateAlertRuleByIdTooManyRequests", 429)
}

func (o *UpdateAlertRuleByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateAlertRuleByIDDefault creates a UpdateAlertRuleByIDDefault with default headers values
func NewUpdateAlertRuleByIDDefault(code int) *UpdateAlertRuleByIDDefault {
	return &UpdateAlertRuleByIDDefault{
		_statusCode: code,
	}
}

/*
UpdateAlertRuleByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateAlertRuleByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update alert rule by Id default response has a 2xx status code
func (o *UpdateAlertRuleByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update alert rule by Id default response has a 3xx status code
func (o *UpdateAlertRuleByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update alert rule by Id default response has a 4xx status code
func (o *UpdateAlertRuleByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update alert rule by Id default response has a 5xx status code
func (o *UpdateAlertRuleByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update alert rule by Id default response a status code equal to that given
func (o *UpdateAlertRuleByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update alert rule by Id default response
func (o *UpdateAlertRuleByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateAlertRuleByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/alert/rules/{id}][%d] updateAlertRuleById default %s", o._statusCode, payload)
}

func (o *UpdateAlertRuleByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/alert/rules/{id}][%d] updateAlertRuleById default %s", o._statusCode, payload)
}

func (o *UpdateAlertRuleByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateAlertRuleByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
