// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateAppliesToFunctionReader is a Reader for the UpdateAppliesToFunction structure.
type UpdateAppliesToFunctionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateAppliesToFunctionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateAppliesToFunctionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateAppliesToFunctionTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateAppliesToFunctionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateAppliesToFunctionOK creates a UpdateAppliesToFunctionOK with default headers values
func NewUpdateAppliesToFunctionOK() *UpdateAppliesToFunctionOK {
	return &UpdateAppliesToFunctionOK{}
}

/*
UpdateAppliesToFunctionOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateAppliesToFunctionOK struct {
	Payload *models.AppliesToFunction
}

// IsSuccess returns true when this update applies to function o k response has a 2xx status code
func (o *UpdateAppliesToFunctionOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update applies to function o k response has a 3xx status code
func (o *UpdateAppliesToFunctionOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update applies to function o k response has a 4xx status code
func (o *UpdateAppliesToFunctionOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update applies to function o k response has a 5xx status code
func (o *UpdateAppliesToFunctionOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update applies to function o k response a status code equal to that given
func (o *UpdateAppliesToFunctionOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update applies to function o k response
func (o *UpdateAppliesToFunctionOK) Code() int {
	return 200
}

func (o *UpdateAppliesToFunctionOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/functions/{id}][%d] updateAppliesToFunctionOK %s", 200, payload)
}

func (o *UpdateAppliesToFunctionOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/functions/{id}][%d] updateAppliesToFunctionOK %s", 200, payload)
}

func (o *UpdateAppliesToFunctionOK) GetPayload() *models.AppliesToFunction {
	return o.Payload
}

func (o *UpdateAppliesToFunctionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AppliesToFunction)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateAppliesToFunctionTooManyRequests creates a UpdateAppliesToFunctionTooManyRequests with default headers values
func NewUpdateAppliesToFunctionTooManyRequests() *UpdateAppliesToFunctionTooManyRequests {
	return &UpdateAppliesToFunctionTooManyRequests{}
}

/*
UpdateAppliesToFunctionTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateAppliesToFunctionTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update applies to function too many requests response has a 2xx status code
func (o *UpdateAppliesToFunctionTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update applies to function too many requests response has a 3xx status code
func (o *UpdateAppliesToFunctionTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update applies to function too many requests response has a 4xx status code
func (o *UpdateAppliesToFunctionTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update applies to function too many requests response has a 5xx status code
func (o *UpdateAppliesToFunctionTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update applies to function too many requests response a status code equal to that given
func (o *UpdateAppliesToFunctionTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update applies to function too many requests response
func (o *UpdateAppliesToFunctionTooManyRequests) Code() int {
	return 429
}

func (o *UpdateAppliesToFunctionTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/functions/{id}][%d] updateAppliesToFunctionTooManyRequests", 429)
}

func (o *UpdateAppliesToFunctionTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/functions/{id}][%d] updateAppliesToFunctionTooManyRequests", 429)
}

func (o *UpdateAppliesToFunctionTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateAppliesToFunctionDefault creates a UpdateAppliesToFunctionDefault with default headers values
func NewUpdateAppliesToFunctionDefault(code int) *UpdateAppliesToFunctionDefault {
	return &UpdateAppliesToFunctionDefault{
		_statusCode: code,
	}
}

/*
UpdateAppliesToFunctionDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateAppliesToFunctionDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update applies to function default response has a 2xx status code
func (o *UpdateAppliesToFunctionDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update applies to function default response has a 3xx status code
func (o *UpdateAppliesToFunctionDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update applies to function default response has a 4xx status code
func (o *UpdateAppliesToFunctionDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update applies to function default response has a 5xx status code
func (o *UpdateAppliesToFunctionDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update applies to function default response a status code equal to that given
func (o *UpdateAppliesToFunctionDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update applies to function default response
func (o *UpdateAppliesToFunctionDefault) Code() int {
	return o._statusCode
}

func (o *UpdateAppliesToFunctionDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/functions/{id}][%d] updateAppliesToFunction default %s", o._statusCode, payload)
}

func (o *UpdateAppliesToFunctionDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/functions/{id}][%d] updateAppliesToFunction default %s", o._statusCode, payload)
}

func (o *UpdateAppliesToFunctionDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateAppliesToFunctionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
