// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewUpdateEventSourceByIDParams creates a new UpdateEventSourceByIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateEventSourceByIDParams() *UpdateEventSourceByIDParams {
	return &UpdateEventSourceByIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateEventSourceByIDParamsWithTimeout creates a new UpdateEventSourceByIDParams object
// with the ability to set a timeout on a request.
func NewUpdateEventSourceByIDParamsWithTimeout(timeout time.Duration) *UpdateEventSourceByIDParams {
	return &UpdateEventSourceByIDParams{
		timeout: timeout,
	}
}

// NewUpdateEventSourceByIDParamsWithContext creates a new UpdateEventSourceByIDParams object
// with the ability to set a context for a request.
func NewUpdateEventSourceByIDParamsWithContext(ctx context.Context) *UpdateEventSourceByIDParams {
	return &UpdateEventSourceByIDParams{
		Context: ctx,
	}
}

// NewUpdateEventSourceByIDParamsWithHTTPClient creates a new UpdateEventSourceByIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateEventSourceByIDParamsWithHTTPClient(client *http.Client) *UpdateEventSourceByIDParams {
	return &UpdateEventSourceByIDParams{
		HTTPClient: client,
	}
}

/*
UpdateEventSourceByIDParams contains all the parameters to send to the API endpoint

	for the update event source by Id operation.

	Typically these are written to a http.Request.
*/
type UpdateEventSourceByIDParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body models.EventSource

	// ID.
	//
	// Format: int32
	ID int32

	// Reason.
	Reason *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update event source by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateEventSourceByIDParams) WithDefaults() *UpdateEventSourceByIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update event source by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateEventSourceByIDParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := UpdateEventSourceByIDParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the update event source by Id params
func (o *UpdateEventSourceByIDParams) WithTimeout(timeout time.Duration) *UpdateEventSourceByIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update event source by Id params
func (o *UpdateEventSourceByIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update event source by Id params
func (o *UpdateEventSourceByIDParams) WithContext(ctx context.Context) *UpdateEventSourceByIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update event source by Id params
func (o *UpdateEventSourceByIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update event source by Id params
func (o *UpdateEventSourceByIDParams) WithHTTPClient(client *http.Client) *UpdateEventSourceByIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update event source by Id params
func (o *UpdateEventSourceByIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the update event source by Id params
func (o *UpdateEventSourceByIDParams) WithUserAgent(userAgent *string) *UpdateEventSourceByIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the update event source by Id params
func (o *UpdateEventSourceByIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the update event source by Id params
func (o *UpdateEventSourceByIDParams) WithBody(body models.EventSource) *UpdateEventSourceByIDParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update event source by Id params
func (o *UpdateEventSourceByIDParams) SetBody(body models.EventSource) {
	o.Body = body
}

// WithID adds the id to the update event source by Id params
func (o *UpdateEventSourceByIDParams) WithID(id int32) *UpdateEventSourceByIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the update event source by Id params
func (o *UpdateEventSourceByIDParams) SetID(id int32) {
	o.ID = id
}

// WithReason adds the reason to the update event source by Id params
func (o *UpdateEventSourceByIDParams) WithReason(reason *string) *UpdateEventSourceByIDParams {
	o.SetReason(reason)
	return o
}

// SetReason adds the reason to the update event source by Id params
func (o *UpdateEventSourceByIDParams) SetReason(reason *string) {
	o.Reason = reason
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateEventSourceByIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if o.Reason != nil {

		// query param reason
		var qrReason string

		if o.Reason != nil {
			qrReason = *o.Reason
		}
		qReason := qrReason
		if qReason != "" {

			if err := r.SetQueryParam("reason", qReason); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
