// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewUpdateInstanceGroupAlertThresholdParams creates a new UpdateInstanceGroupAlertThresholdParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateInstanceGroupAlertThresholdParams() *UpdateInstanceGroupAlertThresholdParams {
	return &UpdateInstanceGroupAlertThresholdParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateInstanceGroupAlertThresholdParamsWithTimeout creates a new UpdateInstanceGroupAlertThresholdParams object
// with the ability to set a timeout on a request.
func NewUpdateInstanceGroupAlertThresholdParamsWithTimeout(timeout time.Duration) *UpdateInstanceGroupAlertThresholdParams {
	return &UpdateInstanceGroupAlertThresholdParams{
		timeout: timeout,
	}
}

// NewUpdateInstanceGroupAlertThresholdParamsWithContext creates a new UpdateInstanceGroupAlertThresholdParams object
// with the ability to set a context for a request.
func NewUpdateInstanceGroupAlertThresholdParamsWithContext(ctx context.Context) *UpdateInstanceGroupAlertThresholdParams {
	return &UpdateInstanceGroupAlertThresholdParams{
		Context: ctx,
	}
}

// NewUpdateInstanceGroupAlertThresholdParamsWithHTTPClient creates a new UpdateInstanceGroupAlertThresholdParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateInstanceGroupAlertThresholdParamsWithHTTPClient(client *http.Client) *UpdateInstanceGroupAlertThresholdParams {
	return &UpdateInstanceGroupAlertThresholdParams{
		HTTPClient: client,
	}
}

/*
UpdateInstanceGroupAlertThresholdParams contains all the parameters to send to the API endpoint

	for the update instance group alert threshold operation.

	Typically these are written to a http.Request.
*/
type UpdateInstanceGroupAlertThresholdParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.RestDeviceInstanceGroupAlertConfigV3

	/* DeviceDsID.

	   The device-datasource ID you'd like to add an instance group for

	   Format: int32
	*/
	DeviceDsID int32

	// DeviceID.
	//
	// Format: int32
	DeviceID int32

	// DpID.
	//
	// Format: int32
	DpID int32

	// DsigID.
	//
	// Format: int32
	DsigID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update instance group alert threshold params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateInstanceGroupAlertThresholdParams) WithDefaults() *UpdateInstanceGroupAlertThresholdParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update instance group alert threshold params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateInstanceGroupAlertThresholdParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := UpdateInstanceGroupAlertThresholdParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) WithTimeout(timeout time.Duration) *UpdateInstanceGroupAlertThresholdParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) WithContext(ctx context.Context) *UpdateInstanceGroupAlertThresholdParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) WithHTTPClient(client *http.Client) *UpdateInstanceGroupAlertThresholdParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) WithUserAgent(userAgent *string) *UpdateInstanceGroupAlertThresholdParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) WithBody(body *models.RestDeviceInstanceGroupAlertConfigV3) *UpdateInstanceGroupAlertThresholdParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) SetBody(body *models.RestDeviceInstanceGroupAlertConfigV3) {
	o.Body = body
}

// WithDeviceDsID adds the deviceDsID to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) WithDeviceDsID(deviceDsID int32) *UpdateInstanceGroupAlertThresholdParams {
	o.SetDeviceDsID(deviceDsID)
	return o
}

// SetDeviceDsID adds the deviceDsId to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) SetDeviceDsID(deviceDsID int32) {
	o.DeviceDsID = deviceDsID
}

// WithDeviceID adds the deviceID to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) WithDeviceID(deviceID int32) *UpdateInstanceGroupAlertThresholdParams {
	o.SetDeviceID(deviceID)
	return o
}

// SetDeviceID adds the deviceId to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) SetDeviceID(deviceID int32) {
	o.DeviceID = deviceID
}

// WithDpID adds the dpID to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) WithDpID(dpID int32) *UpdateInstanceGroupAlertThresholdParams {
	o.SetDpID(dpID)
	return o
}

// SetDpID adds the dpId to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) SetDpID(dpID int32) {
	o.DpID = dpID
}

// WithDsigID adds the dsigID to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) WithDsigID(dsigID int32) *UpdateInstanceGroupAlertThresholdParams {
	o.SetDsigID(dsigID)
	return o
}

// SetDsigID adds the dsigId to the update instance group alert threshold params
func (o *UpdateInstanceGroupAlertThresholdParams) SetDsigID(dsigID int32) {
	o.DsigID = dsigID
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateInstanceGroupAlertThresholdParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param deviceDsId
	if err := r.SetPathParam("deviceDsId", swag.FormatInt32(o.DeviceDsID)); err != nil {
		return err
	}

	// path param deviceId
	if err := r.SetPathParam("deviceId", swag.FormatInt32(o.DeviceID)); err != nil {
		return err
	}

	// path param dpId
	if err := r.SetPathParam("dpId", swag.FormatInt32(o.DpID)); err != nil {
		return err
	}

	// path param dsigId
	if err := r.SetPathParam("dsigId", swag.FormatInt32(o.DsigID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
