// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateJobMonitorReader is a Reader for the UpdateJobMonitor structure.
type UpdateJobMonitorReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateJobMonitorReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateJobMonitorOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateJobMonitorTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateJobMonitorDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateJobMonitorOK creates a UpdateJobMonitorOK with default headers values
func NewUpdateJobMonitorOK() *UpdateJobMonitorOK {
	return &UpdateJobMonitorOK{}
}

/*
UpdateJobMonitorOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateJobMonitorOK struct {
	Payload *models.BatchJob
}

// IsSuccess returns true when this update job monitor o k response has a 2xx status code
func (o *UpdateJobMonitorOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update job monitor o k response has a 3xx status code
func (o *UpdateJobMonitorOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update job monitor o k response has a 4xx status code
func (o *UpdateJobMonitorOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update job monitor o k response has a 5xx status code
func (o *UpdateJobMonitorOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update job monitor o k response a status code equal to that given
func (o *UpdateJobMonitorOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update job monitor o k response
func (o *UpdateJobMonitorOK) Code() int {
	return 200
}

func (o *UpdateJobMonitorOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/batchjobs/{id}][%d] updateJobMonitorOK %s", 200, payload)
}

func (o *UpdateJobMonitorOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/batchjobs/{id}][%d] updateJobMonitorOK %s", 200, payload)
}

func (o *UpdateJobMonitorOK) GetPayload() *models.BatchJob {
	return o.Payload
}

func (o *UpdateJobMonitorOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.BatchJob)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateJobMonitorTooManyRequests creates a UpdateJobMonitorTooManyRequests with default headers values
func NewUpdateJobMonitorTooManyRequests() *UpdateJobMonitorTooManyRequests {
	return &UpdateJobMonitorTooManyRequests{}
}

/*
UpdateJobMonitorTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateJobMonitorTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update job monitor too many requests response has a 2xx status code
func (o *UpdateJobMonitorTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update job monitor too many requests response has a 3xx status code
func (o *UpdateJobMonitorTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update job monitor too many requests response has a 4xx status code
func (o *UpdateJobMonitorTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update job monitor too many requests response has a 5xx status code
func (o *UpdateJobMonitorTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update job monitor too many requests response a status code equal to that given
func (o *UpdateJobMonitorTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update job monitor too many requests response
func (o *UpdateJobMonitorTooManyRequests) Code() int {
	return 429
}

func (o *UpdateJobMonitorTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/batchjobs/{id}][%d] updateJobMonitorTooManyRequests", 429)
}

func (o *UpdateJobMonitorTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/batchjobs/{id}][%d] updateJobMonitorTooManyRequests", 429)
}

func (o *UpdateJobMonitorTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateJobMonitorDefault creates a UpdateJobMonitorDefault with default headers values
func NewUpdateJobMonitorDefault(code int) *UpdateJobMonitorDefault {
	return &UpdateJobMonitorDefault{
		_statusCode: code,
	}
}

/*
UpdateJobMonitorDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateJobMonitorDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update job monitor default response has a 2xx status code
func (o *UpdateJobMonitorDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update job monitor default response has a 3xx status code
func (o *UpdateJobMonitorDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update job monitor default response has a 4xx status code
func (o *UpdateJobMonitorDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update job monitor default response has a 5xx status code
func (o *UpdateJobMonitorDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update job monitor default response a status code equal to that given
func (o *UpdateJobMonitorDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update job monitor default response
func (o *UpdateJobMonitorDefault) Code() int {
	return o._statusCode
}

func (o *UpdateJobMonitorDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/batchjobs/{id}][%d] updateJobMonitor default %s", o._statusCode, payload)
}

func (o *UpdateJobMonitorDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/batchjobs/{id}][%d] updateJobMonitor default %s", o._statusCode, payload)
}

func (o *UpdateJobMonitorDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateJobMonitorDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
