// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateLogSourceReader is a Reader for the UpdateLogSource structure.
type UpdateLogSourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateLogSourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateLogSourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateLogSourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateLogSourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateLogSourceOK creates a UpdateLogSourceOK with default headers values
func NewUpdateLogSourceOK() *UpdateLogSourceOK {
	return &UpdateLogSourceOK{}
}

/*
UpdateLogSourceOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateLogSourceOK struct {
	Payload *models.LogSource
}

// IsSuccess returns true when this update log source o k response has a 2xx status code
func (o *UpdateLogSourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update log source o k response has a 3xx status code
func (o *UpdateLogSourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update log source o k response has a 4xx status code
func (o *UpdateLogSourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update log source o k response has a 5xx status code
func (o *UpdateLogSourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update log source o k response a status code equal to that given
func (o *UpdateLogSourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update log source o k response
func (o *UpdateLogSourceOK) Code() int {
	return 200
}

func (o *UpdateLogSourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/logsources/{id}][%d] updateLogSourceOK %s", 200, payload)
}

func (o *UpdateLogSourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/logsources/{id}][%d] updateLogSourceOK %s", 200, payload)
}

func (o *UpdateLogSourceOK) GetPayload() *models.LogSource {
	return o.Payload
}

func (o *UpdateLogSourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LogSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateLogSourceTooManyRequests creates a UpdateLogSourceTooManyRequests with default headers values
func NewUpdateLogSourceTooManyRequests() *UpdateLogSourceTooManyRequests {
	return &UpdateLogSourceTooManyRequests{}
}

/*
UpdateLogSourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateLogSourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update log source too many requests response has a 2xx status code
func (o *UpdateLogSourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update log source too many requests response has a 3xx status code
func (o *UpdateLogSourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update log source too many requests response has a 4xx status code
func (o *UpdateLogSourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update log source too many requests response has a 5xx status code
func (o *UpdateLogSourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update log source too many requests response a status code equal to that given
func (o *UpdateLogSourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update log source too many requests response
func (o *UpdateLogSourceTooManyRequests) Code() int {
	return 429
}

func (o *UpdateLogSourceTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/logsources/{id}][%d] updateLogSourceTooManyRequests", 429)
}

func (o *UpdateLogSourceTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/logsources/{id}][%d] updateLogSourceTooManyRequests", 429)
}

func (o *UpdateLogSourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateLogSourceDefault creates a UpdateLogSourceDefault with default headers values
func NewUpdateLogSourceDefault(code int) *UpdateLogSourceDefault {
	return &UpdateLogSourceDefault{
		_statusCode: code,
	}
}

/*
UpdateLogSourceDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateLogSourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update log source default response has a 2xx status code
func (o *UpdateLogSourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update log source default response has a 3xx status code
func (o *UpdateLogSourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update log source default response has a 4xx status code
func (o *UpdateLogSourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update log source default response has a 5xx status code
func (o *UpdateLogSourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update log source default response a status code equal to that given
func (o *UpdateLogSourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update log source default response
func (o *UpdateLogSourceDefault) Code() int {
	return o._statusCode
}

func (o *UpdateLogSourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/logsources/{id}][%d] updateLogSource default %s", o._statusCode, payload)
}

func (o *UpdateLogSourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/logsources/{id}][%d] updateLogSource default %s", o._statusCode, payload)
}

func (o *UpdateLogSourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateLogSourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
