// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewUpdateNetscanParams creates a new UpdateNetscanParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateNetscanParams() *UpdateNetscanParams {
	return &UpdateNetscanParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateNetscanParamsWithTimeout creates a new UpdateNetscanParams object
// with the ability to set a timeout on a request.
func NewUpdateNetscanParamsWithTimeout(timeout time.Duration) *UpdateNetscanParams {
	return &UpdateNetscanParams{
		timeout: timeout,
	}
}

// NewUpdateNetscanParamsWithContext creates a new UpdateNetscanParams object
// with the ability to set a context for a request.
func NewUpdateNetscanParamsWithContext(ctx context.Context) *UpdateNetscanParams {
	return &UpdateNetscanParams{
		Context: ctx,
	}
}

// NewUpdateNetscanParamsWithHTTPClient creates a new UpdateNetscanParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateNetscanParamsWithHTTPClient(client *http.Client) *UpdateNetscanParams {
	return &UpdateNetscanParams{
		HTTPClient: client,
	}
}

/*
UpdateNetscanParams contains all the parameters to send to the API endpoint

	for the update netscan operation.

	Typically these are written to a http.Request.
*/
type UpdateNetscanParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body models.Netscan

	// ID.
	//
	// Format: int32
	ID int32

	// Reason.
	Reason *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update netscan params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateNetscanParams) WithDefaults() *UpdateNetscanParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update netscan params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateNetscanParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := UpdateNetscanParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the update netscan params
func (o *UpdateNetscanParams) WithTimeout(timeout time.Duration) *UpdateNetscanParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update netscan params
func (o *UpdateNetscanParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update netscan params
func (o *UpdateNetscanParams) WithContext(ctx context.Context) *UpdateNetscanParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update netscan params
func (o *UpdateNetscanParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update netscan params
func (o *UpdateNetscanParams) WithHTTPClient(client *http.Client) *UpdateNetscanParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update netscan params
func (o *UpdateNetscanParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the update netscan params
func (o *UpdateNetscanParams) WithUserAgent(userAgent *string) *UpdateNetscanParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the update netscan params
func (o *UpdateNetscanParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the update netscan params
func (o *UpdateNetscanParams) WithBody(body models.Netscan) *UpdateNetscanParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update netscan params
func (o *UpdateNetscanParams) SetBody(body models.Netscan) {
	o.Body = body
}

// WithID adds the id to the update netscan params
func (o *UpdateNetscanParams) WithID(id int32) *UpdateNetscanParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the update netscan params
func (o *UpdateNetscanParams) SetID(id int32) {
	o.ID = id
}

// WithReason adds the reason to the update netscan params
func (o *UpdateNetscanParams) WithReason(reason *string) *UpdateNetscanParams {
	o.SetReason(reason)
	return o
}

// SetReason adds the reason to the update netscan params
func (o *UpdateNetscanParams) SetReason(reason *string) {
	o.Reason = reason
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateNetscanParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if o.Reason != nil {

		// query param reason
		var qrReason string

		if o.Reason != nil {
			qrReason = *o.Reason
		}
		qReason := qrReason
		if qReason != "" {

			if err := r.SetQueryParam("reason", qReason); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
