// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateOpsNoteByIDReader is a Reader for the UpdateOpsNoteByID structure.
type UpdateOpsNoteByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateOpsNoteByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateOpsNoteByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateOpsNoteByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateOpsNoteByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateOpsNoteByIDOK creates a UpdateOpsNoteByIDOK with default headers values
func NewUpdateOpsNoteByIDOK() *UpdateOpsNoteByIDOK {
	return &UpdateOpsNoteByIDOK{}
}

/*
UpdateOpsNoteByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateOpsNoteByIDOK struct {
	Payload *models.OpsNote
}

// IsSuccess returns true when this update ops note by Id o k response has a 2xx status code
func (o *UpdateOpsNoteByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update ops note by Id o k response has a 3xx status code
func (o *UpdateOpsNoteByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update ops note by Id o k response has a 4xx status code
func (o *UpdateOpsNoteByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update ops note by Id o k response has a 5xx status code
func (o *UpdateOpsNoteByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update ops note by Id o k response a status code equal to that given
func (o *UpdateOpsNoteByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update ops note by Id o k response
func (o *UpdateOpsNoteByIDOK) Code() int {
	return 200
}

func (o *UpdateOpsNoteByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/opsnotes/{id}][%d] updateOpsNoteByIdOK %s", 200, payload)
}

func (o *UpdateOpsNoteByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/opsnotes/{id}][%d] updateOpsNoteByIdOK %s", 200, payload)
}

func (o *UpdateOpsNoteByIDOK) GetPayload() *models.OpsNote {
	return o.Payload
}

func (o *UpdateOpsNoteByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.OpsNote)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateOpsNoteByIDTooManyRequests creates a UpdateOpsNoteByIDTooManyRequests with default headers values
func NewUpdateOpsNoteByIDTooManyRequests() *UpdateOpsNoteByIDTooManyRequests {
	return &UpdateOpsNoteByIDTooManyRequests{}
}

/*
UpdateOpsNoteByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateOpsNoteByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update ops note by Id too many requests response has a 2xx status code
func (o *UpdateOpsNoteByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update ops note by Id too many requests response has a 3xx status code
func (o *UpdateOpsNoteByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update ops note by Id too many requests response has a 4xx status code
func (o *UpdateOpsNoteByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update ops note by Id too many requests response has a 5xx status code
func (o *UpdateOpsNoteByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update ops note by Id too many requests response a status code equal to that given
func (o *UpdateOpsNoteByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update ops note by Id too many requests response
func (o *UpdateOpsNoteByIDTooManyRequests) Code() int {
	return 429
}

func (o *UpdateOpsNoteByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/opsnotes/{id}][%d] updateOpsNoteByIdTooManyRequests", 429)
}

func (o *UpdateOpsNoteByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/opsnotes/{id}][%d] updateOpsNoteByIdTooManyRequests", 429)
}

func (o *UpdateOpsNoteByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateOpsNoteByIDDefault creates a UpdateOpsNoteByIDDefault with default headers values
func NewUpdateOpsNoteByIDDefault(code int) *UpdateOpsNoteByIDDefault {
	return &UpdateOpsNoteByIDDefault{
		_statusCode: code,
	}
}

/*
UpdateOpsNoteByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateOpsNoteByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update ops note by Id default response has a 2xx status code
func (o *UpdateOpsNoteByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update ops note by Id default response has a 3xx status code
func (o *UpdateOpsNoteByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update ops note by Id default response has a 4xx status code
func (o *UpdateOpsNoteByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update ops note by Id default response has a 5xx status code
func (o *UpdateOpsNoteByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update ops note by Id default response a status code equal to that given
func (o *UpdateOpsNoteByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update ops note by Id default response
func (o *UpdateOpsNoteByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateOpsNoteByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/opsnotes/{id}][%d] updateOpsNoteById default %s", o._statusCode, payload)
}

func (o *UpdateOpsNoteByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/opsnotes/{id}][%d] updateOpsNoteById default %s", o._statusCode, payload)
}

func (o *UpdateOpsNoteByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateOpsNoteByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
