// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateReportGroupByIDReader is a Reader for the UpdateReportGroupByID structure.
type UpdateReportGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateReportGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateReportGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateReportGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateReportGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateReportGroupByIDOK creates a UpdateReportGroupByIDOK with default headers values
func NewUpdateReportGroupByIDOK() *UpdateReportGroupByIDOK {
	return &UpdateReportGroupByIDOK{}
}

/*
UpdateReportGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateReportGroupByIDOK struct {
	Payload *models.ReportGroup
}

// IsSuccess returns true when this update report group by Id o k response has a 2xx status code
func (o *UpdateReportGroupByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update report group by Id o k response has a 3xx status code
func (o *UpdateReportGroupByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update report group by Id o k response has a 4xx status code
func (o *UpdateReportGroupByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update report group by Id o k response has a 5xx status code
func (o *UpdateReportGroupByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update report group by Id o k response a status code equal to that given
func (o *UpdateReportGroupByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update report group by Id o k response
func (o *UpdateReportGroupByIDOK) Code() int {
	return 200
}

func (o *UpdateReportGroupByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /report/groups/{id}][%d] updateReportGroupByIdOK %s", 200, payload)
}

func (o *UpdateReportGroupByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /report/groups/{id}][%d] updateReportGroupByIdOK %s", 200, payload)
}

func (o *UpdateReportGroupByIDOK) GetPayload() *models.ReportGroup {
	return o.Payload
}

func (o *UpdateReportGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ReportGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateReportGroupByIDTooManyRequests creates a UpdateReportGroupByIDTooManyRequests with default headers values
func NewUpdateReportGroupByIDTooManyRequests() *UpdateReportGroupByIDTooManyRequests {
	return &UpdateReportGroupByIDTooManyRequests{}
}

/*
UpdateReportGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateReportGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update report group by Id too many requests response has a 2xx status code
func (o *UpdateReportGroupByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update report group by Id too many requests response has a 3xx status code
func (o *UpdateReportGroupByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update report group by Id too many requests response has a 4xx status code
func (o *UpdateReportGroupByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update report group by Id too many requests response has a 5xx status code
func (o *UpdateReportGroupByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update report group by Id too many requests response a status code equal to that given
func (o *UpdateReportGroupByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update report group by Id too many requests response
func (o *UpdateReportGroupByIDTooManyRequests) Code() int {
	return 429
}

func (o *UpdateReportGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /report/groups/{id}][%d] updateReportGroupByIdTooManyRequests", 429)
}

func (o *UpdateReportGroupByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /report/groups/{id}][%d] updateReportGroupByIdTooManyRequests", 429)
}

func (o *UpdateReportGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateReportGroupByIDDefault creates a UpdateReportGroupByIDDefault with default headers values
func NewUpdateReportGroupByIDDefault(code int) *UpdateReportGroupByIDDefault {
	return &UpdateReportGroupByIDDefault{
		_statusCode: code,
	}
}

/*
UpdateReportGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateReportGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update report group by Id default response has a 2xx status code
func (o *UpdateReportGroupByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update report group by Id default response has a 3xx status code
func (o *UpdateReportGroupByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update report group by Id default response has a 4xx status code
func (o *UpdateReportGroupByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update report group by Id default response has a 5xx status code
func (o *UpdateReportGroupByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update report group by Id default response a status code equal to that given
func (o *UpdateReportGroupByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update report group by Id default response
func (o *UpdateReportGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateReportGroupByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /report/groups/{id}][%d] updateReportGroupById default %s", o._statusCode, payload)
}

func (o *UpdateReportGroupByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /report/groups/{id}][%d] updateReportGroupById default %s", o._statusCode, payload)
}

func (o *UpdateReportGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateReportGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
