// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateRoleByIDReader is a Reader for the UpdateRoleByID structure.
type UpdateRoleByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateRoleByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateRoleByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateRoleByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateRoleByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateRoleByIDOK creates a UpdateRoleByIDOK with default headers values
func NewUpdateRoleByIDOK() *UpdateRoleByIDOK {
	return &UpdateRoleByIDOK{}
}

/*
UpdateRoleByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateRoleByIDOK struct {
	Payload *models.Role
}

// IsSuccess returns true when this update role by Id o k response has a 2xx status code
func (o *UpdateRoleByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update role by Id o k response has a 3xx status code
func (o *UpdateRoleByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update role by Id o k response has a 4xx status code
func (o *UpdateRoleByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update role by Id o k response has a 5xx status code
func (o *UpdateRoleByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update role by Id o k response a status code equal to that given
func (o *UpdateRoleByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update role by Id o k response
func (o *UpdateRoleByIDOK) Code() int {
	return 200
}

func (o *UpdateRoleByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/roles/{id}][%d] updateRoleByIdOK %s", 200, payload)
}

func (o *UpdateRoleByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/roles/{id}][%d] updateRoleByIdOK %s", 200, payload)
}

func (o *UpdateRoleByIDOK) GetPayload() *models.Role {
	return o.Payload
}

func (o *UpdateRoleByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Role)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateRoleByIDTooManyRequests creates a UpdateRoleByIDTooManyRequests with default headers values
func NewUpdateRoleByIDTooManyRequests() *UpdateRoleByIDTooManyRequests {
	return &UpdateRoleByIDTooManyRequests{}
}

/*
UpdateRoleByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateRoleByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update role by Id too many requests response has a 2xx status code
func (o *UpdateRoleByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update role by Id too many requests response has a 3xx status code
func (o *UpdateRoleByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update role by Id too many requests response has a 4xx status code
func (o *UpdateRoleByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update role by Id too many requests response has a 5xx status code
func (o *UpdateRoleByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update role by Id too many requests response a status code equal to that given
func (o *UpdateRoleByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update role by Id too many requests response
func (o *UpdateRoleByIDTooManyRequests) Code() int {
	return 429
}

func (o *UpdateRoleByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/roles/{id}][%d] updateRoleByIdTooManyRequests", 429)
}

func (o *UpdateRoleByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/roles/{id}][%d] updateRoleByIdTooManyRequests", 429)
}

func (o *UpdateRoleByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateRoleByIDDefault creates a UpdateRoleByIDDefault with default headers values
func NewUpdateRoleByIDDefault(code int) *UpdateRoleByIDDefault {
	return &UpdateRoleByIDDefault{
		_statusCode: code,
	}
}

/*
UpdateRoleByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateRoleByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update role by Id default response has a 2xx status code
func (o *UpdateRoleByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update role by Id default response has a 3xx status code
func (o *UpdateRoleByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update role by Id default response has a 4xx status code
func (o *UpdateRoleByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update role by Id default response has a 5xx status code
func (o *UpdateRoleByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update role by Id default response a status code equal to that given
func (o *UpdateRoleByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update role by Id default response
func (o *UpdateRoleByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateRoleByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/roles/{id}][%d] updateRoleById default %s", o._statusCode, payload)
}

func (o *UpdateRoleByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/roles/{id}][%d] updateRoleById default %s", o._statusCode, payload)
}

func (o *UpdateRoleByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateRoleByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
