// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// VerifyStorageAccountsPermissionsReader is a Reader for the VerifyStorageAccountsPermissions structure.
type VerifyStorageAccountsPermissionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *VerifyStorageAccountsPermissionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewVerifyStorageAccountsPermissionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewVerifyStorageAccountsPermissionsTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewVerifyStorageAccountsPermissionsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewVerifyStorageAccountsPermissionsOK creates a VerifyStorageAccountsPermissionsOK with default headers values
func NewVerifyStorageAccountsPermissionsOK() *VerifyStorageAccountsPermissionsOK {
	return &VerifyStorageAccountsPermissionsOK{}
}

/*
VerifyStorageAccountsPermissionsOK describes a response with status code 200, with default header values.

successful operation
*/
type VerifyStorageAccountsPermissionsOK struct {
	Payload *models.RestResponse
}

// IsSuccess returns true when this verify storage accounts permissions o k response has a 2xx status code
func (o *VerifyStorageAccountsPermissionsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this verify storage accounts permissions o k response has a 3xx status code
func (o *VerifyStorageAccountsPermissionsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this verify storage accounts permissions o k response has a 4xx status code
func (o *VerifyStorageAccountsPermissionsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this verify storage accounts permissions o k response has a 5xx status code
func (o *VerifyStorageAccountsPermissionsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this verify storage accounts permissions o k response a status code equal to that given
func (o *VerifyStorageAccountsPermissionsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the verify storage accounts permissions o k response
func (o *VerifyStorageAccountsPermissionsOK) Code() int {
	return 200
}

func (o *VerifyStorageAccountsPermissionsOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /azure/functions/verifyStorageAccountsPermissions][%d] verifyStorageAccountsPermissionsOK %s", 200, payload)
}

func (o *VerifyStorageAccountsPermissionsOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /azure/functions/verifyStorageAccountsPermissions][%d] verifyStorageAccountsPermissionsOK %s", 200, payload)
}

func (o *VerifyStorageAccountsPermissionsOK) GetPayload() *models.RestResponse {
	return o.Payload
}

func (o *VerifyStorageAccountsPermissionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RestResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewVerifyStorageAccountsPermissionsTooManyRequests creates a VerifyStorageAccountsPermissionsTooManyRequests with default headers values
func NewVerifyStorageAccountsPermissionsTooManyRequests() *VerifyStorageAccountsPermissionsTooManyRequests {
	return &VerifyStorageAccountsPermissionsTooManyRequests{}
}

/*
VerifyStorageAccountsPermissionsTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type VerifyStorageAccountsPermissionsTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this verify storage accounts permissions too many requests response has a 2xx status code
func (o *VerifyStorageAccountsPermissionsTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this verify storage accounts permissions too many requests response has a 3xx status code
func (o *VerifyStorageAccountsPermissionsTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this verify storage accounts permissions too many requests response has a 4xx status code
func (o *VerifyStorageAccountsPermissionsTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this verify storage accounts permissions too many requests response has a 5xx status code
func (o *VerifyStorageAccountsPermissionsTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this verify storage accounts permissions too many requests response a status code equal to that given
func (o *VerifyStorageAccountsPermissionsTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the verify storage accounts permissions too many requests response
func (o *VerifyStorageAccountsPermissionsTooManyRequests) Code() int {
	return 429
}

func (o *VerifyStorageAccountsPermissionsTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /azure/functions/verifyStorageAccountsPermissions][%d] verifyStorageAccountsPermissionsTooManyRequests", 429)
}

func (o *VerifyStorageAccountsPermissionsTooManyRequests) String() string {
	return fmt.Sprintf("[POST /azure/functions/verifyStorageAccountsPermissions][%d] verifyStorageAccountsPermissionsTooManyRequests", 429)
}

func (o *VerifyStorageAccountsPermissionsTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewVerifyStorageAccountsPermissionsDefault creates a VerifyStorageAccountsPermissionsDefault with default headers values
func NewVerifyStorageAccountsPermissionsDefault(code int) *VerifyStorageAccountsPermissionsDefault {
	return &VerifyStorageAccountsPermissionsDefault{
		_statusCode: code,
	}
}

/*
VerifyStorageAccountsPermissionsDefault describes a response with status code -1, with default header values.

Error
*/
type VerifyStorageAccountsPermissionsDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this verify storage accounts permissions default response has a 2xx status code
func (o *VerifyStorageAccountsPermissionsDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this verify storage accounts permissions default response has a 3xx status code
func (o *VerifyStorageAccountsPermissionsDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this verify storage accounts permissions default response has a 4xx status code
func (o *VerifyStorageAccountsPermissionsDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this verify storage accounts permissions default response has a 5xx status code
func (o *VerifyStorageAccountsPermissionsDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this verify storage accounts permissions default response a status code equal to that given
func (o *VerifyStorageAccountsPermissionsDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the verify storage accounts permissions default response
func (o *VerifyStorageAccountsPermissionsDefault) Code() int {
	return o._statusCode
}

func (o *VerifyStorageAccountsPermissionsDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /azure/functions/verifyStorageAccountsPermissions][%d] verifyStorageAccountsPermissions default %s", o._statusCode, payload)
}

func (o *VerifyStorageAccountsPermissionsDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /azure/functions/verifyStorageAccountsPermissions][%d] verifyStorageAccountsPermissions default %s", o._statusCode, payload)
}

func (o *VerifyStorageAccountsPermissionsDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *VerifyStorageAccountsPermissionsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
