// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// AwsAccountTestResult aws account test result
//
// swagger:model AwsAccountTestResult
type AwsAccountTestResult struct {

	// detail link
	DetailLink string `json:"detailLink,omitempty"`

	// no permission services
	// Unique: true
	NoPermissionServices []string `json:"noPermissionServices,omitempty"`

	// non permission errors
	// Unique: true
	NonPermissionErrors []string `json:"nonPermissionErrors,omitempty"`

	// warnings
	// Unique: true
	Warnings []string `json:"warnings,omitempty"`
}

// Validate validates this aws account test result
func (m *AwsAccountTestResult) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateNoPermissionServices(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNonPermissionErrors(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateWarnings(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *AwsAccountTestResult) validateNoPermissionServices(formats strfmt.Registry) error {
	if swag.IsZero(m.NoPermissionServices) { // not required
		return nil
	}

	if err := validate.UniqueItems("noPermissionServices", "body", m.NoPermissionServices); err != nil {
		return err
	}

	return nil
}

func (m *AwsAccountTestResult) validateNonPermissionErrors(formats strfmt.Registry) error {
	if swag.IsZero(m.NonPermissionErrors) { // not required
		return nil
	}

	if err := validate.UniqueItems("nonPermissionErrors", "body", m.NonPermissionErrors); err != nil {
		return err
	}

	return nil
}

var awsAccountTestResultWarningsItemsEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["CLIENT_ID_ISSUE","TENANT_ID_ISSUE","KEY_ISSUE","SUBSCRIPTION_ID_ISSUE","SERVICE_NAME_ERROR","TEMPORARY_WARNING","PROJECT_ID_ISSUE","CLIENT_EMAIL_ISSUE","TOKEN_URI_ISSUE","ROLE_ARN_ISSUE","PERMISSION_TEST_BYPASSED","POLICY_OR_NAME_ISSUE","SERVICE_PERMISION_FAILURE","MISSING_REQUIRED_CREDENTIAL_DATA","MISSING_CREDENTIALS","MISSING_SUBSCRIPTION_IDS","NO_SERVICES_CHECKED","MAXIMUM_RECORDS_EXCEEDED","FILTER_UNUSED","ID_NOT_FOUND","TYPE_INVALID","INVALID_TIME_RANGE","UNAUTHORIZED","OPTIONAL_FIELD_NOT_FOUND","EXTRA_FIELDS_PROVIDED","DEFAULT_COLUMNS_FILTER","SAAS_O365_EXTRA_PERMISSION","SAAS_O365_API_INACCESSIBLE","SAAS_O365_NO_PERMISSION_GRANTED","PATCH_NOT_ALLOWED_ON_READ_ONLY","PATCH_NOT_ALLOWED_ON_MULTI","IGNORED_COMPONENT_OF_PAYLOAD","INVALID_FIELD_VALUE","NO_ALERT_RULE_MATCHES_THIS_ALERT","INVALID_PROPERTY_NAMES_IGNORED","NO_STAGE_1_RECEIPIENTS_DEFINED_FOR_ALERT","NO_ESCALATING_CHAIN_MATCHES_THIS_ALERT","ASSUMED_TYPE","NO_DATA_FOR_MODEL","GET_INTEGRATION_FAIL","DASHBOARDS_NOT_CREATED","MISSING_PERMISSION_OR_MISSING_DATAPOINT","DISABLED_CLOUD_TYPE","SERVICE_API_DISABLED","ALERT_GENERATION_DISABLED","ALERT_GENERATION_DISABLED_WITH_NAME"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		awsAccountTestResultWarningsItemsEnum = append(awsAccountTestResultWarningsItemsEnum, v)
	}
}

func (m *AwsAccountTestResult) validateWarningsItemsEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, awsAccountTestResultWarningsItemsEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *AwsAccountTestResult) validateWarnings(formats strfmt.Registry) error {
	if swag.IsZero(m.Warnings) { // not required
		return nil
	}

	if err := validate.UniqueItems("warnings", "body", m.Warnings); err != nil {
		return err
	}

	for i := 0; i < len(m.Warnings); i++ {

		// value enum
		if err := m.validateWarningsItemsEnum("warnings"+"."+strconv.Itoa(i), "body", m.Warnings[i]); err != nil {
			return err
		}

	}

	return nil
}

// ContextValidate validates this aws account test result based on context it is used
func (m *AwsAccountTestResult) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *AwsAccountTestResult) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AwsAccountTestResult) UnmarshalBinary(b []byte) error {
	var res AwsAccountTestResult
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
