// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// BatchJob batch job
//
// swagger:model BatchJob
type BatchJob struct {

	// The Access Groups Id's
	// Example: 1, 2, 3
	// Unique: true
	AccessGroupIds []int32 `json:"accessGroupIds,omitempty"`

	// Module's access groups
	AccessGroups []*AccessGroup `json:"accessGroups,omitempty"`

	// Whether to enable active monitoring of job start
	ActiveMonitoring bool `json:"activeMonitoring,omitempty"`

	// Alert message body
	// Required: true
	AlertBody *string `json:"alertBody"`

	// JobMonitor alert effective interval in minutes
	// Example: 60
	// Required: true
	AlertEffectiveIval *int32 `json:"alertEffectiveIval"`

	// alert level if job doesn't start on time, effective if activeMonitoring true
	// Required: true
	// Enum: ["warn","error","critical"]
	AlertLevel *string `json:"alertLevel"`

	// Alert message subject
	// Required: true
	AlertSubject *string `json:"alertSubject"`

	// The Applies To for the LMModule
	AppliesTo string `json:"appliesTo,omitempty"`

	// The metadata checksum for the LMModule content
	// Read Only: true
	Checksum string `json:"checksum,omitempty"`

	// Cron schedule expression, only the latter 5 ,effective if activeMonitoring true
	// Required: true
	CronSchedule *string `json:"cronSchedule"`

	// Cron timezone, effective if activeMonitoring true
	// Required: true
	CronTimeZone *string `json:"cronTimeZone"`

	// The description for the LMModule
	Description string `json:"description,omitempty"`

	// The group the LMModule is in
	Group string `json:"group,omitempty"`

	// The ID of the LMModule
	// Read Only: true
	ID int32 `json:"id,omitempty"`

	// The local module's IntegrationMetadata, readable for troubleshooting purposes
	// Read Only: true
	InstallationMetadata *IntegrationMetadata `json:"installationMetadata,omitempty"`

	// The lineageId the LMModule belongs to
	// Read Only: true
	LineageID string `json:"lineageId,omitempty"`

	// Max job run time in minutes
	LongestRunTimeInMinute int32 `json:"longestRunTimeInMinute,omitempty"`

	// JobMonitor name
	// Required: true
	Name *string `json:"name"`

	// Max Relative Time Interval Error, effective if activeMonitoring true
	StartMrtie int32 `json:"startMrtie,omitempty"`

	// The Tags for the LMModule
	Tags string `json:"tags,omitempty"`

	// The Technical Notes for the LMModule
	Technology string `json:"technology,omitempty"`
}

// Validate validates this batch job
func (m *BatchJob) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAccessGroupIds(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAccessGroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAlertBody(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAlertEffectiveIval(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAlertLevel(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAlertSubject(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCronSchedule(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCronTimeZone(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateInstallationMetadata(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *BatchJob) validateAccessGroupIds(formats strfmt.Registry) error {
	if swag.IsZero(m.AccessGroupIds) { // not required
		return nil
	}

	if err := validate.UniqueItems("accessGroupIds", "body", m.AccessGroupIds); err != nil {
		return err
	}

	return nil
}

func (m *BatchJob) validateAccessGroups(formats strfmt.Registry) error {
	if swag.IsZero(m.AccessGroups) { // not required
		return nil
	}

	for i := 0; i < len(m.AccessGroups); i++ {
		if swag.IsZero(m.AccessGroups[i]) { // not required
			continue
		}

		if m.AccessGroups[i] != nil {
			if err := m.AccessGroups[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *BatchJob) validateAlertBody(formats strfmt.Registry) error {

	if err := validate.Required("alertBody", "body", m.AlertBody); err != nil {
		return err
	}

	return nil
}

func (m *BatchJob) validateAlertEffectiveIval(formats strfmt.Registry) error {

	if err := validate.Required("alertEffectiveIval", "body", m.AlertEffectiveIval); err != nil {
		return err
	}

	return nil
}

var batchJobTypeAlertLevelPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["warn","error","critical"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		batchJobTypeAlertLevelPropEnum = append(batchJobTypeAlertLevelPropEnum, v)
	}
}

const (

	// BatchJobAlertLevelWarn captures enum value "warn"
	BatchJobAlertLevelWarn string = "warn"

	// BatchJobAlertLevelError captures enum value "error"
	BatchJobAlertLevelError string = "error"

	// BatchJobAlertLevelCritical captures enum value "critical"
	BatchJobAlertLevelCritical string = "critical"
)

// prop value enum
func (m *BatchJob) validateAlertLevelEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, batchJobTypeAlertLevelPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *BatchJob) validateAlertLevel(formats strfmt.Registry) error {

	if err := validate.Required("alertLevel", "body", m.AlertLevel); err != nil {
		return err
	}

	// value enum
	if err := m.validateAlertLevelEnum("alertLevel", "body", *m.AlertLevel); err != nil {
		return err
	}

	return nil
}

func (m *BatchJob) validateAlertSubject(formats strfmt.Registry) error {

	if err := validate.Required("alertSubject", "body", m.AlertSubject); err != nil {
		return err
	}

	return nil
}

func (m *BatchJob) validateCronSchedule(formats strfmt.Registry) error {

	if err := validate.Required("cronSchedule", "body", m.CronSchedule); err != nil {
		return err
	}

	return nil
}

func (m *BatchJob) validateCronTimeZone(formats strfmt.Registry) error {

	if err := validate.Required("cronTimeZone", "body", m.CronTimeZone); err != nil {
		return err
	}

	return nil
}

func (m *BatchJob) validateInstallationMetadata(formats strfmt.Registry) error {
	if swag.IsZero(m.InstallationMetadata) { // not required
		return nil
	}

	if m.InstallationMetadata != nil {
		if err := m.InstallationMetadata.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("installationMetadata")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("installationMetadata")
			}
			return err
		}
	}

	return nil
}

func (m *BatchJob) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this batch job based on the context it is used
func (m *BatchJob) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAccessGroups(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateChecksum(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateInstallationMetadata(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLineageID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *BatchJob) contextValidateAccessGroups(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.AccessGroups); i++ {

		if m.AccessGroups[i] != nil {

			if swag.IsZero(m.AccessGroups[i]) { // not required
				return nil
			}

			if err := m.AccessGroups[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *BatchJob) contextValidateChecksum(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "checksum", "body", string(m.Checksum)); err != nil {
		return err
	}

	return nil
}

func (m *BatchJob) contextValidateID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "id", "body", int32(m.ID)); err != nil {
		return err
	}

	return nil
}

func (m *BatchJob) contextValidateInstallationMetadata(ctx context.Context, formats strfmt.Registry) error {

	if m.InstallationMetadata != nil {

		if swag.IsZero(m.InstallationMetadata) { // not required
			return nil
		}

		if err := m.InstallationMetadata.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("installationMetadata")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("installationMetadata")
			}
			return err
		}
	}

	return nil
}

func (m *BatchJob) contextValidateLineageID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "lineageId", "body", string(m.LineageID)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *BatchJob) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *BatchJob) UnmarshalBinary(b []byte) error {
	var res BatchJob
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
