// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// BillingInfo billing info
//
// swagger:model BillingInfo
type BillingInfo struct {

	// The title that will be displayed above the pie chart
	EndExclusive int64 `json:"endExclusive,omitempty"`

	// filters to be applied on the billing info
	Filters *JSONArray `json:"filters,omitempty"`

	// The datapoints added to the widget. Note that datapoints must be included in the pieChartItems object to be displayed in the widget
	GranularityDrillDownSteps []string `json:"granularityDrillDownSteps,omitempty"`

	// The datapoints added to the widget. Note that datapoints must be included in the pieChartItems object to be displayed in the widget
	GroupByDrillDownSteps [][]string `json:"groupByDrillDownSteps,omitempty"`

	// If the number of slices exceeds the maxSlicesCanBeShown, this value indicates whether the remaining slices should be grouped together
	GroupRemainingAsOthers bool `json:"groupRemainingAsOthers,omitempty"`

	// Whether items at 0% should be hidden
	HideZeroValues bool `json:"hideZeroValues,omitempty"`

	// The maximum number of slices you'd like displayed in the pie chart
	MaxSlicesCanBeShown int32 `json:"maxSlicesCanBeShown,omitempty"`

	// Whether or not labels and lines should be displayed on the pie chart
	ShowLabelsAndLinesOnPC bool `json:"showLabelsAndLinesOnPC,omitempty"`

	// The title that will be displayed above the pie chart
	StartInclusive int64 `json:"startInclusive,omitempty"`

	// The title that will be displayed above the pie chart
	Title string `json:"title,omitempty"`
}

// Validate validates this billing info
func (m *BillingInfo) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateFilters(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateGranularityDrillDownSteps(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *BillingInfo) validateFilters(formats strfmt.Registry) error {
	if swag.IsZero(m.Filters) { // not required
		return nil
	}

	if m.Filters != nil {
		if err := m.Filters.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("filters")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("filters")
			}
			return err
		}
	}

	return nil
}

var billingInfoGranularityDrillDownStepsItemsEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["DAY","WEEK","MONTH","QUARTER","NONE"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		billingInfoGranularityDrillDownStepsItemsEnum = append(billingInfoGranularityDrillDownStepsItemsEnum, v)
	}
}

func (m *BillingInfo) validateGranularityDrillDownStepsItemsEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, billingInfoGranularityDrillDownStepsItemsEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *BillingInfo) validateGranularityDrillDownSteps(formats strfmt.Registry) error {
	if swag.IsZero(m.GranularityDrillDownSteps) { // not required
		return nil
	}

	for i := 0; i < len(m.GranularityDrillDownSteps); i++ {

		// value enum
		if err := m.validateGranularityDrillDownStepsItemsEnum("granularityDrillDownSteps"+"."+strconv.Itoa(i), "body", m.GranularityDrillDownSteps[i]); err != nil {
			return err
		}

	}

	return nil
}

// ContextValidate validate this billing info based on the context it is used
func (m *BillingInfo) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateFilters(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *BillingInfo) contextValidateFilters(ctx context.Context, formats strfmt.Registry) error {

	if m.Filters != nil {

		if swag.IsZero(m.Filters) { // not required
			return nil
		}

		if err := m.Filters.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("filters")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("filters")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *BillingInfo) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *BillingInfo) UnmarshalBinary(b []byte) error {
	var res BillingInfo
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
