// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// MapModuleToAccessGroup map module to access group
//
// swagger:model MapModuleToAccessGroup
type MapModuleToAccessGroup struct {

	// Id's of the access group
	// Required: true
	// Unique: true
	Accessgroups []int32 `json:"accessgroups"`

	// Id of the logic module
	// Required: true
	Moduleid *int32 `json:"moduleid"`

	// Type of module
	// Example: DATASOURCE, EVENTSOURCE, BATCHJOB, JOBMONITOR, LOGSOURCE, TOPOLOGYSOURCE, PROPERTYSOURCE, APPLIESTO_FUNCTION, SNMP_SYSOID_MAP
	// Required: true
	Moduletype *string `json:"moduletype"`
}

// Validate validates this map module to access group
func (m *MapModuleToAccessGroup) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAccessgroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateModuleid(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateModuletype(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *MapModuleToAccessGroup) validateAccessgroups(formats strfmt.Registry) error {

	if err := validate.Required("accessgroups", "body", m.Accessgroups); err != nil {
		return err
	}

	if err := validate.UniqueItems("accessgroups", "body", m.Accessgroups); err != nil {
		return err
	}

	return nil
}

func (m *MapModuleToAccessGroup) validateModuleid(formats strfmt.Registry) error {

	if err := validate.Required("moduleid", "body", m.Moduleid); err != nil {
		return err
	}

	return nil
}

func (m *MapModuleToAccessGroup) validateModuletype(formats strfmt.Registry) error {

	if err := validate.Required("moduletype", "body", m.Moduletype); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this map module to access group based on context it is used
func (m *MapModuleToAccessGroup) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *MapModuleToAccessGroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *MapModuleToAccessGroup) UnmarshalBinary(b []byte) error {
	var res MapModuleToAccessGroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
