// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"bytes"
	"context"
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// NormalGraphWidget normal graph widget
//
// swagger:model NormalGraphWidget
type NormalGraphWidget struct {
	dashboardIdField *int32

	descriptionField string

	idField int32

	intervalField int32

	isSupportCustomPropertyField bool

	lastUpdatedByField string

	lastUpdatedOnField int64

	nameField *string

	supportCustomPropertyField bool

	themeField string

	timescaleField string

	userPermissionField string

	// The name (not display name) of the datasource the graph is associated with
	// Read Only: true
	DsName string `json:"dsName,omitempty"`

	// The id of the datasource instance the graph was pinned from
	// Required: true
	DsiID *int32 `json:"dsiId"`

	// The name of the instance the graph was pinned from
	// Read Only: true
	DsiName string `json:"dsiName,omitempty"`

	// The id of the datasource graph this widget was pinned from
	// Required: true
	GraphID *int32 `json:"graphId"`

	// The id of the datasource graph this widget was pinned from
	// Read Only: true
	GraphName string `json:"graphName,omitempty"`

	// The id of the device the graph was pinned from
	HID int32 `json:"hId,omitempty"`

	// The display name of the device the graph was pinned from
	// Read Only: true
	HostName string `json:"hostName,omitempty"`
}

// DashboardID gets the dashboard Id of this subtype
func (m *NormalGraphWidget) DashboardID() *int32 {
	return m.dashboardIdField
}

// SetDashboardID sets the dashboard Id of this subtype
func (m *NormalGraphWidget) SetDashboardID(val *int32) {
	m.dashboardIdField = val
}

// Description gets the description of this subtype
func (m *NormalGraphWidget) Description() string {
	return m.descriptionField
}

// SetDescription sets the description of this subtype
func (m *NormalGraphWidget) SetDescription(val string) {
	m.descriptionField = val
}

// ID gets the id of this subtype
func (m *NormalGraphWidget) ID() int32 {
	return m.idField
}

// SetID sets the id of this subtype
func (m *NormalGraphWidget) SetID(val int32) {
	m.idField = val
}

// Interval gets the interval of this subtype
func (m *NormalGraphWidget) Interval() int32 {
	return m.intervalField
}

// SetInterval sets the interval of this subtype
func (m *NormalGraphWidget) SetInterval(val int32) {
	m.intervalField = val
}

// IsSupportCustomProperty gets the is support custom property of this subtype
func (m *NormalGraphWidget) IsSupportCustomProperty() bool {
	return m.isSupportCustomPropertyField
}

// SetIsSupportCustomProperty sets the is support custom property of this subtype
func (m *NormalGraphWidget) SetIsSupportCustomProperty(val bool) {
	m.isSupportCustomPropertyField = val
}

// LastUpdatedBy gets the last updated by of this subtype
func (m *NormalGraphWidget) LastUpdatedBy() string {
	return m.lastUpdatedByField
}

// SetLastUpdatedBy sets the last updated by of this subtype
func (m *NormalGraphWidget) SetLastUpdatedBy(val string) {
	m.lastUpdatedByField = val
}

// LastUpdatedOn gets the last updated on of this subtype
func (m *NormalGraphWidget) LastUpdatedOn() int64 {
	return m.lastUpdatedOnField
}

// SetLastUpdatedOn sets the last updated on of this subtype
func (m *NormalGraphWidget) SetLastUpdatedOn(val int64) {
	m.lastUpdatedOnField = val
}

// Name gets the name of this subtype
func (m *NormalGraphWidget) Name() *string {
	return m.nameField
}

// SetName sets the name of this subtype
func (m *NormalGraphWidget) SetName(val *string) {
	m.nameField = val
}

// SupportCustomProperty gets the support custom property of this subtype
func (m *NormalGraphWidget) SupportCustomProperty() bool {
	return m.supportCustomPropertyField
}

// SetSupportCustomProperty sets the support custom property of this subtype
func (m *NormalGraphWidget) SetSupportCustomProperty(val bool) {
	m.supportCustomPropertyField = val
}

// Theme gets the theme of this subtype
func (m *NormalGraphWidget) Theme() string {
	return m.themeField
}

// SetTheme sets the theme of this subtype
func (m *NormalGraphWidget) SetTheme(val string) {
	m.themeField = val
}

// Timescale gets the timescale of this subtype
func (m *NormalGraphWidget) Timescale() string {
	return m.timescaleField
}

// SetTimescale sets the timescale of this subtype
func (m *NormalGraphWidget) SetTimescale(val string) {
	m.timescaleField = val
}

// Type gets the type of this subtype
func (m *NormalGraphWidget) Type() string {
	return "ngraph"
}

// SetType sets the type of this subtype
func (m *NormalGraphWidget) SetType(val string) {
}

// UserPermission gets the user permission of this subtype
func (m *NormalGraphWidget) UserPermission() string {
	return m.userPermissionField
}

// SetUserPermission sets the user permission of this subtype
func (m *NormalGraphWidget) SetUserPermission(val string) {
	m.userPermissionField = val
}

// UnmarshalJSON unmarshals this object with a polymorphic type from a JSON structure
func (m *NormalGraphWidget) UnmarshalJSON(raw []byte) error {
	var data struct {

		// The name (not display name) of the datasource the graph is associated with
		// Read Only: true
		DsName string `json:"dsName,omitempty"`

		// The id of the datasource instance the graph was pinned from
		// Required: true
		DsiID *int32 `json:"dsiId"`

		// The name of the instance the graph was pinned from
		// Read Only: true
		DsiName string `json:"dsiName,omitempty"`

		// The id of the datasource graph this widget was pinned from
		// Required: true
		GraphID *int32 `json:"graphId"`

		// The id of the datasource graph this widget was pinned from
		// Read Only: true
		GraphName string `json:"graphName,omitempty"`

		// The id of the device the graph was pinned from
		HID int32 `json:"hId,omitempty"`

		// The display name of the device the graph was pinned from
		// Read Only: true
		HostName string `json:"hostName,omitempty"`
	}
	buf := bytes.NewBuffer(raw)
	dec := json.NewDecoder(buf)
	dec.UseNumber()

	if err := dec.Decode(&data); err != nil {
		return err
	}

	var base struct {
		/* Just the base type fields. Used for unmashalling polymorphic types.*/

		DashboardID *int32 `json:"dashboardId"`

		Description string `json:"description,omitempty"`

		ID int32 `json:"id,omitempty"`

		Interval int32 `json:"interval,omitempty"`

		IsSupportCustomProperty bool `json:"isSupportCustomProperty,omitempty"`

		LastUpdatedBy string `json:"lastUpdatedBy,omitempty"`

		LastUpdatedOn int64 `json:"lastUpdatedOn,omitempty"`

		Name *string `json:"name"`

		SupportCustomProperty bool `json:"supportCustomProperty,omitempty"`

		Theme string `json:"theme,omitempty"`

		Timescale string `json:"timescale,omitempty"`

		Type string `json:"type"`

		UserPermission string `json:"userPermission,omitempty"`
	}
	buf = bytes.NewBuffer(raw)
	dec = json.NewDecoder(buf)
	dec.UseNumber()

	if err := dec.Decode(&base); err != nil {
		return err
	}

	var result NormalGraphWidget

	result.dashboardIdField = base.DashboardID

	result.descriptionField = base.Description

	result.idField = base.ID

	result.intervalField = base.Interval

	result.isSupportCustomPropertyField = base.IsSupportCustomProperty

	result.lastUpdatedByField = base.LastUpdatedBy

	result.lastUpdatedOnField = base.LastUpdatedOn

	result.nameField = base.Name

	result.supportCustomPropertyField = base.SupportCustomProperty

	result.themeField = base.Theme

	result.timescaleField = base.Timescale

	if base.Type != result.Type() {
		/* Not the type we're looking for. */
		return errors.New(422, "invalid type value: %q", base.Type)
	}
	result.userPermissionField = base.UserPermission

	result.DsName = data.DsName
	result.DsiID = data.DsiID
	result.DsiName = data.DsiName
	result.GraphID = data.GraphID
	result.GraphName = data.GraphName
	result.HID = data.HID
	result.HostName = data.HostName

	*m = result

	return nil
}

// MarshalJSON marshals this object with a polymorphic type to a JSON structure
func (m NormalGraphWidget) MarshalJSON() ([]byte, error) {
	var b1, b2, b3 []byte
	var err error
	b1, err = json.Marshal(struct {

		// The name (not display name) of the datasource the graph is associated with
		// Read Only: true
		DsName string `json:"dsName,omitempty"`

		// The id of the datasource instance the graph was pinned from
		// Required: true
		DsiID *int32 `json:"dsiId"`

		// The name of the instance the graph was pinned from
		// Read Only: true
		DsiName string `json:"dsiName,omitempty"`

		// The id of the datasource graph this widget was pinned from
		// Required: true
		GraphID *int32 `json:"graphId"`

		// The id of the datasource graph this widget was pinned from
		// Read Only: true
		GraphName string `json:"graphName,omitempty"`

		// The id of the device the graph was pinned from
		HID int32 `json:"hId,omitempty"`

		// The display name of the device the graph was pinned from
		// Read Only: true
		HostName string `json:"hostName,omitempty"`
	}{

		DsName: m.DsName,

		DsiID: m.DsiID,

		DsiName: m.DsiName,

		GraphID: m.GraphID,

		GraphName: m.GraphName,

		HID: m.HID,

		HostName: m.HostName,
	})
	if err != nil {
		return nil, err
	}
	b2, err = json.Marshal(struct {
		DashboardID *int32 `json:"dashboardId"`

		Description string `json:"description,omitempty"`

		ID int32 `json:"id,omitempty"`

		Interval int32 `json:"interval,omitempty"`

		IsSupportCustomProperty bool `json:"isSupportCustomProperty,omitempty"`

		LastUpdatedBy string `json:"lastUpdatedBy,omitempty"`

		LastUpdatedOn int64 `json:"lastUpdatedOn,omitempty"`

		Name *string `json:"name"`

		SupportCustomProperty bool `json:"supportCustomProperty,omitempty"`

		Theme string `json:"theme,omitempty"`

		Timescale string `json:"timescale,omitempty"`

		Type string `json:"type"`

		UserPermission string `json:"userPermission,omitempty"`
	}{

		DashboardID: m.DashboardID(),

		Description: m.Description(),

		ID: m.ID(),

		Interval: m.Interval(),

		IsSupportCustomProperty: m.IsSupportCustomProperty(),

		LastUpdatedBy: m.LastUpdatedBy(),

		LastUpdatedOn: m.LastUpdatedOn(),

		Name: m.Name(),

		SupportCustomProperty: m.SupportCustomProperty(),

		Theme: m.Theme(),

		Timescale: m.Timescale(),

		Type: m.Type(),

		UserPermission: m.UserPermission(),
	})
	if err != nil {
		return nil, err
	}

	return swag.ConcatJSON(b1, b2, b3), nil
}

// Validate validates this normal graph widget
func (m *NormalGraphWidget) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateDashboardID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDsiID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateGraphID(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NormalGraphWidget) validateDashboardID(formats strfmt.Registry) error {

	if err := validate.Required("dashboardId", "body", m.DashboardID()); err != nil {
		return err
	}

	return nil
}

func (m *NormalGraphWidget) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name()); err != nil {
		return err
	}

	return nil
}

func (m *NormalGraphWidget) validateDsiID(formats strfmt.Registry) error {

	if err := validate.Required("dsiId", "body", m.DsiID); err != nil {
		return err
	}

	return nil
}

func (m *NormalGraphWidget) validateGraphID(formats strfmt.Registry) error {

	if err := validate.Required("graphId", "body", m.GraphID); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this normal graph widget based on the context it is used
func (m *NormalGraphWidget) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLastUpdatedBy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLastUpdatedOn(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUserPermission(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateDsName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateDsiName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateGraphName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHostName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NormalGraphWidget) contextValidateLastUpdatedBy(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "lastUpdatedBy", "body", string(m.LastUpdatedBy())); err != nil {
		return err
	}

	return nil
}

func (m *NormalGraphWidget) contextValidateLastUpdatedOn(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "lastUpdatedOn", "body", int64(m.LastUpdatedOn())); err != nil {
		return err
	}

	return nil
}

func (m *NormalGraphWidget) contextValidateUserPermission(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "userPermission", "body", string(m.UserPermission())); err != nil {
		return err
	}

	return nil
}

func (m *NormalGraphWidget) contextValidateDsName(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "dsName", "body", string(m.DsName)); err != nil {
		return err
	}

	return nil
}

func (m *NormalGraphWidget) contextValidateDsiName(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "dsiName", "body", string(m.DsiName)); err != nil {
		return err
	}

	return nil
}

func (m *NormalGraphWidget) contextValidateGraphName(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "graphName", "body", string(m.GraphName)); err != nil {
		return err
	}

	return nil
}

func (m *NormalGraphWidget) contextValidateHostName(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "hostName", "body", string(m.HostName)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NormalGraphWidget) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NormalGraphWidget) UnmarshalBinary(b []byte) error {
	var res NormalGraphWidget
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
