// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// RestMapModuleV3 rest map module v3
//
// swagger:model RestMapModuleV3
type RestMapModuleV3 struct {

	// The Module Id's not mapped successfully
	// Unique: true
	Failure []string `json:"failure,omitempty"`

	// Can provide module id, module type and access group for mapping
	// Required: true
	MappingDetails []*MapModuleToAccessGroup `json:"mappingDetails"`

	// The Module Id's mapped successfully
	// Unique: true
	Success []int32 `json:"success,omitempty"`
}

// Validate validates this rest map module v3
func (m *RestMapModuleV3) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateFailure(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMappingDetails(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSuccess(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RestMapModuleV3) validateFailure(formats strfmt.Registry) error {
	if swag.IsZero(m.Failure) { // not required
		return nil
	}

	if err := validate.UniqueItems("failure", "body", m.Failure); err != nil {
		return err
	}

	return nil
}

func (m *RestMapModuleV3) validateMappingDetails(formats strfmt.Registry) error {

	if err := validate.Required("mappingDetails", "body", m.MappingDetails); err != nil {
		return err
	}

	for i := 0; i < len(m.MappingDetails); i++ {
		if swag.IsZero(m.MappingDetails[i]) { // not required
			continue
		}

		if m.MappingDetails[i] != nil {
			if err := m.MappingDetails[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("mappingDetails" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("mappingDetails" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *RestMapModuleV3) validateSuccess(formats strfmt.Registry) error {
	if swag.IsZero(m.Success) { // not required
		return nil
	}

	if err := validate.UniqueItems("success", "body", m.Success); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this rest map module v3 based on the context it is used
func (m *RestMapModuleV3) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateMappingDetails(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RestMapModuleV3) contextValidateMappingDetails(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.MappingDetails); i++ {

		if m.MappingDetails[i] != nil {

			if swag.IsZero(m.MappingDetails[i]) { // not required
				return nil
			}

			if err := m.MappingDetails[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("mappingDetails" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("mappingDetails" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *RestMapModuleV3) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *RestMapModuleV3) UnmarshalBinary(b []byte) error {
	var res RestMapModuleV3
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
